Package: motifStack
Type: Package
Version: 1.57.0
Title: Plot stacked logos for single or multiple DNA, RNA and amino
        acid sequence
Authors@R: c(person(given="Jianhong", family="Ou", email="jou@morgridge.org", 
        role=c("aut", "cre"), comment=c(ORCID="0000-0002-8652-2488")), 
        person(given="Michael", family="Brodsky", role = "ctb", 
        email = "Michael.Brodsky@umassmed.edu"), 
        person(given="Scot", family="Wolfe", role = "ctb", 
        email = "Scot.Wolfe@umassmed.edu"),
        person("Lihua Julie Zhu", "Developer", role = "aut",
        email = "Julie.Zhu@umassmed.edu"))
Author: Jianhong Ou, Michael Brodsky, Scot Wolfe and Lihua Julie Zhu
Maintainer: Jianhong Ou <jou@morgridge.org>
Depends: R (>= 2.15.1), methods, grid
Imports: ade4, Biostrings, ggplot2, grDevices, graphics, htmlwidgets,
        stats, stats4, utils, XML, TFBSTools
Suggests: Cairo, grImport, grImport2, BiocGenerics, MotifDb,
        RColorBrewer, BiocStyle, knitr, RUnit, rmarkdown, JASPAR2020
biocViews: SequenceMatching, Visualization, Sequencing, Microarray,
        Alignment, ChIPchip, ChIPSeq, MotifAnnotation, DataImport
Description: The motifStack package is designed for graphic 
             representation of multiple motifs with different similarity 
             scores. It works with both DNA/RNA sequence motif and amino 
             acid sequence motif. In addition, it provides the flexibility 
             for users to customize the graphic parameters such as the 
             font type and symbol colors.
License: GPL (>= 2)
Lazyload: yes
VignetteBuilder: knitr
RoxygenNote: 7.3.3
Encoding: UTF-8
git_url: https://git.bioconductor.org/packages/motifStack
git_branch: devel
git_last_commit: 3f6e3dc
git_last_commit_date: 2026-04-28
Repository: Bioconductor 3.24
Date/Publication: 2026-04-28
NeedsCompilation: no
Packaged: 2026-04-28 23:55:53 UTC; biocbuild

# motifStack

[![DOI](https://img.shields.io/badge/DOI-10.1038%2Fnmeth.4555-brightgreen.svg)](https://doi.org/10.1038/nmeth.4555)
[![platforms](http://bioconductor.org/shields/availability/devel/motifStack.svg)](http://bioconductor.org/packages/devel/bioc/html/motifStack.html)
[![build](http://bioconductor.org/shields/build/devel/bioc/motifStack.svg)](http://bioconductor.org/packages/devel/bioc/html/motifStack.html)

Plot stacked logos for single or multiple DNA, RNA and amino acid sequence

The motifStack package is designed for graphic representation of multiple motifs with different similarity scores. It works with both DNA/RNA sequence motif and amino acid sequence motif. In addition, it provides the flexibility for users to customize the graphic parameters such as the font type and symbol colors.

## Installation

To install this package, start R and enter:

```r
library(BiocManager)
BiocManager::install("motifStack")
```

## Documentation

To view documentation of motifStack, start R and enter:
```r
browseVignettes("motifStack")
```

#' get the unique motif in each category grouped by distance
#' 
#' to get the unique motif in a given category, eg by species.
#' 
#' 
#' @param phylog an object of class phylog
#' @param attr attribute used for category of motifs
#' @return return a list: \item{uni.rank}{unique motif ranks}
#' \item{uni.length}{length of unique motif grouped by distance}
#' \item{uni.list}{unique motif names grouped by distance}
#' @author Jianhong Ou
#' @keywords misc
#' @export
#' @examples
#' 
#'    if(interactive() || Sys.getenv("USER")=="jianhongou"){
#'         library("MotifDb")
#'         matrix.fly <- query(MotifDb, "Dmelanogaster")
#'         matrix.human <- query(MotifDb, "Hsapiens")
#'         pfms <- c(as.list(matrix.fly), as.list(matrix.human))
#'         pfms <- pfms[sample(seq_along(pfms), 100)]
#'         hc <- clusterMotifs(pfms)
#'         library(ade4)
#'         phylog <- ade4::hclust2phylog(hc)
#'         leaves <- names(phylog$leaves)
#'         attr <- gsub("^(.*?)_.*$", "\1", leaves)
#'         getRankedUniqueMotifs(phylog, attr)
#'     }
#' 
getRankedUniqueMotifs <- function(phylog, attr){
    leaves=names(phylog$leaves)
    if(is.null(names(attr))){
        names(attr) <- leaves
    }else{
        attr <- attr[leaves]
    }
    droot <- phylog$droot
    droot.max <- max(droot)
    parts <- phylog$parts
    parts.dist <- droot.max - droot[names(parts)]
    parts.dist <- sort(parts.dist)
    parts.dist <- parts.dist[names(parts.dist)!="Root"]
    
    getLeaves <- function(parts, name){
        p <- parts[[name]]
        y <- c()
        for(x in p){
            if(x %in% names(parts)) y <- c(y, Recall(parts, x))
            else y <- c(y, x)
        }
        return(y)
    }
    
    getNodes <- function(parts, name){
        p <- parts[[name]]
        y <- c()
        for(x in p){
            if(x %in% names(parts)) {
                y <- c(y, x, Recall(parts, x))
            }
        }
        return(y)
    }
    
    uni.dist <- unique(parts.dist)
    
    uni <- lapply(uni.dist, function(gpDist){
        names <- names(parts.dist)[parts.dist <= gpDist]
        groups <- lapply(names, getLeaves, parts=parts)
        names(groups) <- names
        toberemoved <- lapply(names, getNodes, parts=parts)
        toberemoved <- unique(unlist(toberemoved))
        if(length(toberemoved)>0) {
            groups <- groups[names[!names %in% toberemoved]]
        }
        groupedLeaves <- unlist(groups)
        ungroupedLeaves <- leaves[!leaves %in% groupedLeaves]
        groups <- c(groups, as.list(ungroupedLeaves))
        if(length(groups)<1){
            return(NULL)
        }
        groups <- do.call(rbind, mapply(function(.ele, .id) cbind(.ele, .id),
                                        groups, 1:length(groups)))
        category <- attr[groups[, 1]]
        category <- split(category, groups[,2])
        category <- lapply(category, unique)
        uni.names <- names(category)[sapply(category, length)==1]
        names <- groups[groups[, 2] %in% uni.names, 1]
        as.character(names)
    })
    
    uni.rank <- table(unlist(uni))
    uni.rank <- uni.rank[order(uni.rank, decreasing=TRUE)]
    uni.rank.value <- rle(as.numeric(uni.rank))
    uni.rank.value$values <- 
        c(1, cumsum(uni.rank.value$lengths)[-length(uni.rank.value$lengths)]+1)
    uni.rank.value <- inverse.rle(uni.rank.value)
    names(uni.rank.value) <- names(uni.rank)
    
    uni.length <- sapply(uni, length)
    uni.length <- cbind(distance=uni.dist, uniqueMotifCount=uni.length)
    uni.length <- uni.length[order(-uni.length[,2], -uni.length[,1]), 
                             , drop=FALSE]
    uni.length <- uni.length[!duplicated(uni.length[,2]),
                             , drop=FALSE]
    
    names(uni) <- paste("dist", uni.dist, sep="_")
    uni <- uni[paste("dist", uni.length[,1], sep="_")]
    
    return(list(uni.rank=uni.rank.value, uni.length=uni.length, uni.list=uni))
}

#' Class \code{marker}
#' 
#' An object of class \code{"marker"} represents a marker in a motif
#' 
#' 
#' @name marker-class
#' @aliases marker marker-class
#' @docType class
#' @section Objects from the Class: Objects can be created by calls of the form
#' \code{new("marker", type, start, stop, label, gp)}.
#' @keywords classes
#' @exportClass marker
#' @examples
#' 
#'  new("marker", type="rect", start=c(2, 4), gp=gpar(lty=3))
#' 
# Import some S3 classes
setOldClass("gpar")

setClass(
  "marker", 
  representation(type="character", start="numeric", 
                 stop="numeric", label="character", 
                 gp="gpar"),
  validity=function(object){
    re<-TRUE
    if (length(object@type)!=1) 
      re<-"type should be 1 of 'rect', 'text', 'line'"
    if (!object@type%in%c('rect', 'text', 'symbol', 'line')) 
      re<-"type should be 1 of 'rect', 'text', 'line'"
    if (any(object@stop<object@start)) 
      re <- "stop must be no less than start"
    if (any(start!=round(start, digits = 0)) || 
        any(stop!=round(stop, digits = 0))){
      re <- "start and stop must be an integer."
    }
    re
  }
)

#' @rdname marker-class
#' @docType methods
#' @param x A marker object
#' @param name slot name of marker object
#' @exportMethod `$` `$<-`
#' @aliases $,marker-method $<-,marker-method
setMethod("$", "marker", function(x, name) slot(x, name))
setReplaceMethod("$", "marker",
                 function(x, name, value){
                   slot(x, name, check = TRUE) <- value
                   x
                 })

#' @importFrom grid gpar
setMethod("initialize","marker",function(.Object, type, start, stop, label, gp){
  if (length(type)!=1) 
    re<-"type should be 1 of 'rect', 'text', 'line'"
  if (!type%in%c('rect', 'text', 'symbol', 'line'))
    re<-"type should be 1 of 'rect', 'text', 'line'"
  if(missing(label)) label = character()
  if(missing(start)) start = numeric()
  if(missing(stop)) stop = start
  if(missing(gp)) gp = gpar()
  .Object@type            =    type;
  .Object@start        =    start;
  .Object@stop      = stop;
  .Object@label    =    label;
  .Object@gp        =    gp;
  .Object
})

#' plot a DNA sequence logo cloud
#' 
#' Plot a DNA sequence logo cloud
#' 
#' 
#' @param motifSig an object of class \linkS4class{motifSig}
#' @param rcpostfix postfix for reverse-complement motif names, default: (RC)
#' @param layout layout of the logo cloud, rectangles, cloud or tree
#' @param scale A vector of length 2 indicating the range of the size of the
#' sequence logo.
#' @param rot.per proportion sequence logo with 90 degree rotation. Only work
#' for "cloud" layout
#' @param draw.box draw box for each sequence logo or not
#' @param draw.freq label frequency of each signature or not
#' @param box.col color of box for each sequence logo
#' @param freq.col color of frequency label
#' @param group.col color setting for groups
#' @param groups a named vectors of motif groups
#' @param draw.legend draw group color legend or not
#' @param font font of logo
#' @param ic.scale logical If TRUE, the height of each column is proportional
#' to its information content. Otherwise, all columns have the same height.
#' @return none
#' @export
#' @importFrom grid grid.polygon gpar pushViewport viewport grid.rect grid.text
#' popViewport unit 
#' @importFrom graphics plot.window par plot.new strheight plot.default segments
#' legend 
#' @importFrom stats runif
#' @examples
#' 
#'   if(interactive() || Sys.getenv("USER")=="jianhongou"){
#'     library("MotifDb")
#'     matrix.fly <- query(MotifDb, "Dmelanogaster")
#'     motifs <- as.list(matrix.fly)
#'     motifs <- motifs[grepl("Dmelanogaster-FlyFactorSurvey-", 
#'                             names(motifs), fixed=TRUE)]
#'     names(motifs) <- gsub("Dmelanogaster_FlyFactorSurvey_", "", 
#'                 gsub("_FBgn[0-9]+$", "", 
#'                   gsub("[^a-zA-Z0-9]","_", 
#'                      gsub("(_[0-9]+)+$", "", names(motifs)))))
#'     motifs <- motifs[unique(names(motifs))]
#'     pfms <- sample(motifs, 50)
#'     hc <- clusterMotifs(pfms)
#'     library(ade4)
#'     phylog <- ade4::hclust2phylog(hc)
#'     leaves <- names(phylog$leaves)
#'     pfms <- pfms[leaves]
#'     pfms <- mapply(pfms, names(pfms), FUN=function(.ele, .name){
#'                  new("pfm",mat=.ele, name=.name)})
#'     motifSig <- motifSignature(pfms, phylog, cutoffPval=0.0001)
#'     motifCloud(motifSig)
#'   }
#' 
motifCloud <- function(motifSig, rcpostfix="(RC)", 
                       layout=c("rectangles", "cloud", "tree"), 
                       scale=c(6, .5), rot.per=.1,
                       draw.box=TRUE, draw.freq=TRUE, 
                       box.col="gray", freq.col="gray",
                       group.col=NULL, groups=NULL, draw.legend=FALSE,
                       font="sans", ic.scale=TRUE)
{
  if (!inherits(motifSig, "motifSig")) 
    stop("motifSig be object of motifSig. You could try\n
         ?motifSignature\nto get a motifSig.")
  signatures=signatures(motifSig)
  freq=frequence(motifSig)
  nodelist=nodelist(motifSig)
  if((!is.null(group.col)) && (!is.null(groups))){
    if(!all(names(table(groups)) %in% names(group.col)))
      stop("some value of groups has no corresponding color in group.col")
    names(groups) <- gsub(rcpostfix,"",names(groups), fixed=TRUE)
    pfmNames <-
      as.character(unlist(lapply(signatures, function(.ele) {
        unlist(strsplit(.ele@name, ";"))
        })))
    pfmNames <- gsub(rcpostfix,"",pfmNames, fixed=TRUE)
    if(!all(pfmNames %in% names(groups)))
      stop("not all pfms has a given group")
  }
  layout <- match.arg(layout, c("cloud","rectangles", "tree"), several.ok=TRUE)
  layout <- layout[1]
  normedFreq <- freq/max(freq)
  size <- (scale[1]-scale[2])*normedFreq + scale[2]
  grid.pie <- function(x, edges = 200, radius = 0.8, col = NULL, cex=1){
    if (!is.numeric(x) || any(is.na(x) | x < 0)) 
      stop("'x' values must be positive.")
    x <- c(0, cumsum(x)/sum(x))
    dx <- diff(x)
    nx <- length(dx)
    if (is.null(col)) 
      col <- c("white", "lightblue", "mistyrose", "lightcyan", 
               "lavender", "cornsilk")
    col <- rep(col, length.out = nx)
    twopi <- 2 * pi
    t2xy <- function(t) {
      t2p <- twopi * t
      list(x = radius * cos(t2p)/2 + 0.5, y = radius * sin(t2p)/2 + 0.5)
    }
    for (i in 1L:nx) {
      n <- max(2, floor(edges * dx[i]))
      P <- t2xy(seq.int(x[i], x[i + 1], length.out = n))
      grid.polygon(c(P$x, 0.5), c(P$y, 0.5), gp=gpar(col = col[i],
                                                     fill = col[i]))
    }
  }
  plotSignature <- function(x, y, wid, ht, just, angle, sig, freq, normedFreq){
    pushViewport(viewport(x=x, y=y, 
                          width=wid, height=ht,
                          just=just, angle=angle))
    if(draw.box) grid.rect(gp=gpar(col=box.col, 
                                   lty="dashed", 
                                   fill="transparent"))
    plotMotifLogoA(sig, font=font, ic.scale=ic.scale)
    if(draw.freq) grid.text(label=freq,x=.95,y=.95,
                            gp=gpar(col=freq.col,cex=normedFreq), 
                            just=c("right","top"))
    if((!is.null(group.col)) & (!is.null(groups))) {
      sigNames <- unlist(strsplit(sig@name,";"))
      gps <- table(groups[sigNames])
      gp.col <- group.col[names(gps)]
      pushViewport(viewport(x=.1*as.numeric(ht)/as.numeric(wid), y=.9,
                            width=.2*as.numeric(ht)/as.numeric(wid), height=.2))
      grid.pie(gps, col=gp.col, cex=normedFreq)
      popViewport()
    }
    popViewport()
  }
  
  op <- par(mar=c(0,0,0,0))
  on.exit(par(op))
  
  if(layout=="rectangles"){
    plot.new()
    boxesInch <- list()
    minWid <- .Machine$integer.max
    minHt <- .Machine$integer.max
    for(i in 1:length(signatures)){
      ht <- strheight("ACGT", units="inches", cex=size[i])
      wid <- ht*ncol(signatures[[i]]@mat)/2
      boxesInch[[i]] <- new("Rect", width=wid, height=ht)
      if(ht < minHt) minHt <- ht
      if(wid < minWid) minWid <- wid
    }
    pin <- par("pin")
    bin <- new("Rect", width=pin[1], height=pin[2])
    bin.ratio <- bin@height / bin@width
    basic1.wd <- max(boxesInch[[1]]@width, boxesInch[[1]]@height)
    if(bin.ratio < 1) {
      basic1.ht <- basic1.wd * bin.ratio
    }else{
      basic1.ht <- basic1.wd
      basic1.wd <- basic1.ht/bin.ratio
    }
    basic1 <- new("Rect", width=basic1.wd, height=basic1.ht)
    freeRect <- list(basic1)
    bestNodelist <- list()
    maxX <- 0
    maxY <- 0
    for(i in 1:length(signatures)){
      if(length(freeRect)<1){
        if(interactive()) {
          warning("signature could not be fit on page. It will not be plotted.")
        }
        break
      }
      getBestNode <- function(freeRect, boxesInch, i, bin, basic1){
        bestNode <- new("Rect")
        bestX <- basic1@width
        bestY <- basic1@height
        for(j in 1:length(freeRect)){
          if(freeRect[[j]]@width >= boxesInch[[i]]@width && 
             freeRect[[j]]@height >= boxesInch[[i]]@height){
            topSideY <- freeRect[[j]]@y + boxesInch[[i]]@height
            if(topSideY < bestY || 
               (topSideY == bestY && freeRect[[j]]@x < bestX)){
              bestNode@x <- freeRect[[j]]@x
              bestNode@y <- freeRect[[j]]@y
              bestNode@width <- boxesInch[[i]]@width
              bestNode@height <- boxesInch[[i]]@height
              bestY <- topSideY
              bestX <- freeRect[[j]]@x
            }
          }
          if(freeRect[[j]]@width >= boxesInch[[i]]@height && 
             freeRect[[j]]@height >= boxesInch[[i]]@width){
            topSideY <- freeRect[[j]]@y + boxesInch[[i]]@width
            if(topSideY < bestY || 
               (topSideY == bestY && freeRect[[j]]@x < bestX)){
              bestNode@x <- freeRect[[j]]@x
              bestNode@y <- freeRect[[j]]@y
              bestNode@width <- boxesInch[[i]]@height
              bestNode@height <- boxesInch[[i]]@width
              bestY <- topSideY
              bestX <- freeRect[[j]]@x
            }
          }
        }
        if(bestNode@height==0){
          basic2.wd <- min(boxesInch[[i]]@width, boxesInch[[i]]@height)
          basic2.ht <- basic2.wd * bin.ratio
          if(bin.ratio < 1) {
            basic2.ht <- basic2.wd * bin.ratio
          }else{
            basic2.ht <- basic2.wd
            basic2.wd <- basic2.ht/bin.ratio
          }
          basic2 <- new("Rect", width=basic1@width+basic2.wd, 
                        height=basic1@height+basic2.ht)
          freeRect <- lapply(freeRect, function(.ele){
            if(.ele@x+.ele@width==basic1@width) {
              .ele@width <- .ele@width + basic2.wd
            }
            if(.ele@y+.ele@height==basic1@height) {
              .ele@height <- .ele@height + basic2.ht
            }
            .ele
          })
          freeRect <- 
            c(freeRect, new("Rect", x=basic1@width, y=0, 
                            width=basic2.wd, height=basic2@height), 
              new("Rect", x=0, y=basic1@height, 
                  width=basic2@width, height=basic2.ht))
          basic1 <- basic2
          bestNodeRes <- Recall(freeRect, boxesInch, i, bin, basic1)
          bestNode <- bestNodeRes[["bestNode"]]
          freeRect <- bestNodeRes[["freeRect"]]
          basic1 <- bestNodeRes[["basic1"]]
        }
        list(bestNode=bestNode, freeRect=freeRect, basic1=basic1)
      }
      bestNodeRes <- getBestNode(freeRect, boxesInch, i, bin, basic1)
      bestNode <- bestNodeRes[["bestNode"]]
      freeRect <- bestNodeRes[["freeRect"]]
      basic1 <- bestNodeRes[["basic1"]]
      if(bestNode@height==0){
        if(interactive()) {
          warning("signature could not be fit on page. It will not be plotted.")
        }
        break
      }
      tobeAppend <- list()
      leftNodes <- lapply(freeRect, function(freeNode, usedNode){
        if(usedNode@x >= freeNode@x + freeNode@width || 
           usedNode@x + usedNode@width <= freeNode@x ||
           usedNode@y >= freeNode@y + freeNode@height || 
           usedNode@y + usedNode@height <= freeNode@y){
          TRUE
        }else{
          if(usedNode@x < freeNode@x + freeNode@width &&
             usedNode@x + usedNode@width > freeNode@x){
            ## New node at the top side of the used node
            if(usedNode@y > freeNode@y && 
               usedNode@y <freeNode@y + freeNode@height){
              newFreeNode <- freeNode
              newFreeNode@height <- usedNode@y - newFreeNode@y
              tobeAppend <<- c(tobeAppend, newFreeNode)
            }
            ## New node at the bottom side of the used node
            if(usedNode@y + usedNode@height < freeNode@y + freeNode@height){
              newFreeNode <- freeNode
              newFreeNode@y <- usedNode@y + usedNode@height
              newFreeNode@height <- freeNode@y + freeNode@height - 
                (usedNode@y + usedNode@height)
              tobeAppend <<- c(tobeAppend, newFreeNode)
            }
          }
          if(usedNode@y < freeNode@y + freeNode@height && 
             usedNode@y + usedNode@height > freeNode@y){
            ## New node at the left side of the used node
            if(usedNode@x > freeNode@x && 
               usedNode@x <freeNode@x + freeNode@width){
              newFreeNode <- freeNode
              newFreeNode@width <- usedNode@x - newFreeNode@x
              tobeAppend <<- c(tobeAppend, newFreeNode)
            }
            ## New node at the right side of the used node
            if(usedNode@x + usedNode@width < freeNode@x + freeNode@width){
              newFreeNode <- freeNode
              newFreeNode@x <- usedNode@x + usedNode@width
              newFreeNode@width <- freeNode@x + freeNode@width -
                (usedNode@x + usedNode@width)
              tobeAppend <<- c(tobeAppend, newFreeNode)
            }
          }
          FALSE
        }
      }, bestNode)     
      freeRect <- c(freeRect[unlist(leftNodes)], tobeAppend)
      ## prune freeRect
      if(length(freeRect)>1){
        leftNodes <- rep(TRUE, length(freeRect))
        for(m in 1:(length(freeRect)-1)){
          if(leftNodes[m]){
            for(n in (m+1):length(freeRect)){
              if(leftNodes[n]){
                if(isContainedIn(freeRect[[m]], freeRect[[n]])){
                  leftNodes[m] <- FALSE
                  break;
                }
                if(isContainedIn(freeRect[[n]], freeRect[[m]])){
                  leftNodes[n] <- FALSE
                }
              }
            }
          }
        }
        freeRect <- freeRect[leftNodes]
      }
      
      ##push bestNode
      bestNodelist <- c(bestNodelist, bestNode)
      maxX <- max(unlist(lapply(freeRect, function(.ele){.ele@x+.ele@width})))
      maxY <- max(unlist(lapply(freeRect, function(.ele){.ele@y+.ele@height})))
    }
    ratio <- min(bin@width/maxX, bin@height/maxY)
    for(i in 1:length(bestNodelist)){
      bestNode <- bestNodelist[[i]]
      ## draw logo in bestNode
      if(bestNode@width<bestNode@height){
        plotSignature(x=unit(ratio*bestNode@x, "inches"), 
                      y=unit(ratio*bestNode@y+ratio*bestNode@height, "inches"),
                      wid=unit(ratio*bestNode@height, "inches"), 
                      ht=unit(ratio*bestNode@width, "inches"), 
                      just=c("left","bottom"), 
                      angle=-90,
                      sig=signatures[[i]], 
                      freq=freq[i], 
                      normedFreq=normedFreq[i])
      }else{
        plotSignature(x=unit(ratio*bestNode@x, "inches"), 
                      y=unit(ratio*bestNode@y, "inches"), 
                      wid=unit(ratio*bestNode@width, "inches"), 
                      ht=unit(ratio*bestNode@height, "inches"), 
                      just=c("left","bottom"),
                      angle=0,
                      sig=signatures[[i]], 
                      freq=freq[i], 
                      normedFreq=normedFreq[i])
      }
    }
  }else if(layout=="cloud"){
    plot.new()
    last <- 1
    overlap <- function(x1, y1, sw1, sh1){
      s <- 0
      if(length(boxes)==0) return(FALSE)
      for(i in c(last, 1:length(boxes))){
        bnds <- boxes[[i]]
        x2 <- bnds[1]
        y2 <- bnds[2]
        sw2 <- bnds[3]
        sh2 <- bnds[4]
        if(x1 < x2) overlap <- x1+sw1 > x2-s
        else overlap <- x2 +sw2 > x1-s
        if(y1 <y2) overlap <- overlap && (y1+sh1 > y2-s)
        else overlap <- overlap && (y2 +sh2 > y1-s)
        if(overlap){
          last <- i
          return(TRUE)
        }
      }
      FALSE
    }
    thetaStep <- .1
    rStep <- .05
    plot.window(c(0,1), c(0,1), asp=1)
    boxes <- list()
    
    for(i in 1:length(signatures)){
      sig <- signatures[[i]]
      rotWord <- runif(1)<rot.per
      r <- 0
      theta <- runif(1, 0, 2*pi)
      x1 <- .5
      y1 <- .5
      ht <- strheight("ACGT", cex=size[i])
      wid <- ht * ncol(sig@mat) / 2
      if(rotWord){
        tmp <- ht
        ht <- wid
        wid <- tmp
      }
      isOverlapped <- TRUE
      while(isOverlapped){
        if(!overlap(x1-.5*wid, y1-.5*ht, wid, ht) &&
           x1-.5*wid>0 && y1-.5*ht>0 &&
           x1+.5*wid<1 && y1+.5*ht<1){
          if(rotWord){
            plotSignature(x1, y1, ht, wid, "center", 90, sig, 
                          freq[i], normedFreq[i])
          }else{
            plotSignature(x1, y1, wid, ht, "center", 0, sig, 
                          freq[i], normedFreq[i])
          }
          boxes[[length(boxes)+1]] <- c(x1-.5*wid, y1-.5*ht, wid, ht)
          isOverlapped <- FALSE
        }else{
          if(r>sqrt(.5)){
            if(interactive()) {
              warning("signature could not be fit on page. 
                      It will not be plotted.")
              }
            isOverlapped <- FALSE
          }
          theta <- theta+thetaStep
          r <- r+rStep*thetaStep/(2*pi)
          x1 <- .5+r*cos(theta)
          y1 <- .5+r*sin(theta)
        }
      }
    }
  }else{
    #trim nodelist
    #get all path for each signature
    sigNames <- as.character(unlist(lapply(signatures, 
                                           function(.ele) .ele@name)))
    sigNames <- gsub(rcpostfix, "", sigNames, fixed=TRUE)
    paths <- lapply(sigNames, function(.ele, nodelist){
      pt <- c()
      getPath <- function(nodelist, nodename, pt){
        parent <- getParentNode(nodelist, nodename)
        if(!is.null(parent[1])){
          pt <- c(pt, parent[1])
          pt <- Recall(nodelist, parent[1], pt)
        }
        pt
      }
      pt <- getPath(nodelist, .ele, pt)
      pt
    }, nodelist)
    #leave the nodes in the paths
    paths <- unique(unlist(paths))
    nodelist <- nodelist[paths]
    
    last <- 1
    overlap <- function(x1, y1, sw1, sh1){
      s <- 0
      if(length(boxes)==0) return(FALSE)
      for(i in c(last, 1:length(boxes))){
        bnds <- boxes[[i]]
        x2 <- bnds[1]
        y2 <- bnds[2]
        sw2 <- bnds[3]
        sh2 <- bnds[4]
        if(x1 < x2) overlap <- x1+sw1 > x2-s
        else overlap <- x2 +sw2 > x1-s
        if(y1 <y2) overlap <- overlap && (y1+sh1 > y2-s)
        else overlap <- overlap && (y2 +sh2 > y1-s)
        if(overlap){
          last <- i
          return(TRUE)
        }
      }
      FALSE
    }
    boxes <- list()
    step <- .1
    plot.default(0, 0, type = "n", asp = 1, xlab = "", ylab = "", 
                 xaxt = "n", yaxt = "n", xlim = c(0, 1), ylim = c(0, 1), 
                 xaxs = "i", yaxs = "i", frame.plot = FALSE)
    getRdist <- function(nodelist, Rdist=c(), nodename="Root", distp=0){
      currNode <- nodelist[[nodename]]
      distl <- distp + currNode@distl
      distr <- distp + currNode@distr
      currDist <- c(distl, distr)
      names(currDist) <- c(currNode@left, currNode@right)
      Rdist <- c(Rdist, currDist)
      if(!is.null(nodelist[[currNode@left]])) {
        Rdist <- getRdist(nodelist, Rdist, currNode@left, distp=distl)
      }
      if(!is.null(nodelist[[currNode@right]])) {
        Rdist <- getRdist(nodelist, Rdist, currNode@right, distp=distr)
      }
      Rdist
    }
    Rdist <- getRdist(nodelist)
    longestRdist <- 4*max(Rdist)
    plotUnrootedTree <- 
      function(signatures, nodelist, positions, nodename="Root", 
               AXIS=0, ANGLE=2*pi, orignalX=0.5, orignalY=0.5, longestRdist=0){
      currNode <- nodelist[[nodename]]
      RdistTotal <- 0
      if(currNode@left %in% c(paths, sigNames))
        RdistTotal <- currNode@distl
      if(currNode@right %in% c(paths, sigNames)) 
        RdistTotal <- RdistTotal + currNode@distr
      #plot left node
      start <- AXIS - ANGLE/2
      alpha <- 0
      if(currNode@left %in% c(paths, sigNames)){
        alpha <- ANGLE*currNode@distl/RdistTotal
        beta <- start + alpha/2
        x <- currNode@distl/longestRdist * cos(beta) + orignalX
        y <- currNode@distl/longestRdist * sin(beta) + orignalY
        if(!is.null(nodelist[[currNode@left]])) {
          segments(orignalX, orignalY, x, y)
          positions <- plotUnrootedTree(signatures, nodelist, positions, 
                                        nodename=currNode@left, AXIS=beta,
                                        ANGLE=alpha, orignalX=x, orignalY=y, 
                                        longestRdist=longestRdist)
        }else{
          pfmlid <- getPFMid(signatures, currNode@left)
          if(length(pfmlid)>0){
            ht <- strheight("ACGT", cex=size[pfmlid])
            wid <- ht * ncol(signatures[[pfmlid]]@mat) / 2
            segments(orignalX, orignalY, x, y)
            cp <- new("Rect", x=x, y=y, width=wid, height=ht)
            positions <- c(positions, new("pos", box=cp, beta=beta, 
                                          sig=signatures[[pfmlid]], 
                                          freq=freq[[pfmlid]],
                                          norm=normedFreq[pfmlid]))
          }
        }
      }
      #plot right node
      if(currNode@right %in% c(paths, sigNames)){
        start <- start + alpha
        alpha <- ANGLE*currNode@distr/RdistTotal
        beta <- start + alpha/2
        x <- currNode@distr/longestRdist * cos(beta) + orignalX
        y <- currNode@distr/longestRdist * sin(beta) + orignalY
        if(!is.null(nodelist[[currNode@right]])) {
          segments(orignalX, orignalY, x, y)
          positions <- plotUnrootedTree(signatures, nodelist, positions,
                                        nodename=currNode@right, AXIS=beta, 
                                        ANGLE=alpha, orignalX=x, orignalY=y, 
                                        longestRdist=longestRdist)
        }else{
          pfmrid <- getPFMid(signatures, currNode@right)
          if(length(pfmrid)>0){
            ht <- strheight("ACGT", cex=size[pfmrid])
            wid <- ht * ncol(signatures[[pfmrid]]@mat) / 2
            segments(orignalX, orignalY, x, y)
            cp <- new("Rect", x=x, y=y, width=wid, height=ht)
            positions <- c(positions, new("pos", box=cp, beta=beta, 
                                          sig=signatures[[pfmrid]], 
                                          freq=freq[[pfmrid]],
                                          norm=normedFreq[pfmrid]))
          }
        }
      }
      positions
    }
    positions <- plotUnrootedTree(signatures, nodelist, 
                                  positions=list(), longestRdist=longestRdist)
    positions <- positions[order(unlist(lapply(positions, 
                                               function(.ele) .ele@freq)), 
                                 decreasing=TRUE)]
    for(i in 1:length(positions)){
      isOverlapped <- TRUE
      thisMotif <- positions[[i]]
      x <- thisMotif@box@x
      y <- thisMotif@box@y
      wid <- thisMotif@box@width
      ht <- thisMotif@box@height
      beta <- thisMotif@beta
      x1 <- x
      y1 <- y
      while(isOverlapped){
        if(!overlap(x1-.5*wid, y1-.5*ht, wid, ht)){
          segments(x,y,x1,y1,lty="dashed", col="gray")
          #plot signature
          plotSignature(x1, y1, wid, ht, "center", 0,
                        thisMotif@sig, thisMotif@freq, thisMotif@norm)
          boxes[[length(boxes)+1]] <- c(x1-.5*wid, y1-.5*ht, wid, ht)
          isOverlapped <- FALSE
        }else{
          if((x1>=1-.5*wid || x1<=.5*wid) && (y1<=.5*ht || y1>=1-.5*ht)){
            if(interactive()) {
              warning("signature could not be fit on page. 
                      It will not be plotted.")
            }
            isOverlapped <- FALSE
          }
          r <- sqrt(wid*wid + ht*ht)*step
          if(((beta %% pi) - pi/2) < 0.0001) beta <- beta + pi/90
          x1 <- x1+r*cos(beta)
          y1 <- y1+r*sin(beta)
          if(x1-.5*wid<0) x1 <- .5*wid
          if(x1+.5*wid>1) x1 <-1-.5*wid
          if(y1-.5*ht<0) y1 <- .5*ht
          if(y1+.5*ht>1) y1 <-1-.5*ht
        }
      }
    }
  }
  #plot group legend
  if((!is.null(group.col)) && (!is.null(groups)) && draw.legend){
    legend("topright", names(group.col), fill=group.col, cex=0.5)
  }
  return(invisible())
}

###############################################################################
####### motifstack


#' plot a DNA sequence logo stack
#' 
#' Plot a DNA sequence logo stack
#' 
#' 
#' @param pfms a list of objects of class \link{pfm}
#' @param layout layout of the logo stack, stack, treeview or radialPhylog
#' @param reorder logical(1). Default TRUE. Set to FALSE will do alignment but
#' keep the order of the pfms. This parameter only work for stack layout.
#' @param \dots any parameters could to pass to \link{plotMotifLogoStack},
#' \link{plotMotifLogoStackWithTree}, \link{plotMotifStackWithPhylog} or
#' \link{plotMotifStackWithRadialPhylog}.
#' And the `revcomp` parameter for \link{DNAmotifAlignment}.
#' @return return a list contains pfms and phylog
#' @export
#' @importFrom ade4 hclust2phylog
#' @examples
#' 
#'   if(interactive() || Sys.getenv("USER")=="jianhongou"){
#'     library("MotifDb")
#'     matrix.fly <- query(MotifDb, "Dmelanogaster")
#'     motifs <- as.list(matrix.fly)
#'     motifs <- motifs[grepl("Dmelanogaster-FlyFactorSurvey-", 
#'                             names(motifs), fixed=TRUE)]
#'     names(motifs) <- gsub("Dmelanogaster_FlyFactorSurvey_", "", 
#'                 gsub("_FBgn[0-9]+$", "", 
#'                   gsub("[^a-zA-Z0-9]","_", 
#'                      gsub("(_[0-9]+)+$", "", names(motifs)))))
#'     motifs <- motifs[unique(names(motifs))]
#'     pfms <- sample(motifs, 50)
#'     pfms <- mapply(pfms, names(pfms), FUN=function(.ele, .name){
#'                  new("pfm",mat=.ele, name=.name)})
#'     motifStack(pfms, "radialPhylog")
#'     
#'     ## AA motifs
#'     pcms<-importMatrix(system.file("extdata", "prot.meme", 
#'                                    package="motifStack"),
#'                    format="meme", to="pfm")
#'     motifStack(pcms[1:5])
#'     motifStack(pcms[1:5], reorder=FALSE)
#'   }
#' 
motifStack <-function(pfms, 
                      layout=c("stack", "treeview", "phylog", "radialPhylog"),
                      reorder=TRUE,
                      ...){
    if(!is.list(pfms)){
      if(is(pfms, "pcm")) pfms <- pcm2pfm(pfms)
        plot(pfms)
        return(invisible())
    }
    layout <- match.arg(layout)
    if(!pfms[[1]]@alphabet %in% c("AA")){
      if(all(sapply(pfms, function(.ele) is(.ele, "pcm")))) {
        pfms <- lapply(pfms, pcm2pfm)
      }
      if (any(unlist(lapply(pfms, function(.ele) 
        !inherits(.ele, c("pfm", "psam")))))) 
        stop("pfms must be a list of pfm, pcm or psam objects")
    }
    if(all(sapply(pfms, function(.ele) is(.ele, "psam")))){
      psam <- TRUE
    }else{
      psam <- FALSE
    }
    alphab <- vapply(pfms, function(.ele) .ele@alphabet=="RNA", 
                     FUN.VALUE = TRUE)
    alphab <- any(alphab)
    dots <- list(...)
    if("revcomp" %in% names(dots)){
      revcomp <- dots$revcomp
    }else{
      revcomp <- rep(!alphab, length(pfms))
      dots$revcomp <- revcomp[1]
    }
    if (length(pfms)<2)
        stop("length of pfms less than 2")
    if (length(pfms)==2){
      if(pfms[[1]]@alphabet %in% c("DNA", "RNA")) {
        pfms <- DNAmotifAlignment(pfms, revcomp = revcomp)
      }else{
        if(pfms[[1]]@alphabet %in% c("AA") && layout!="stack"){
          pfms <- AAmotifAlignment(pfms)
        }else{
          if(pfms[[1]]@alphabet=="others"){
            warning("alphabet is set to 'others'. ",
                    "Currently 'others' is not support for alignment.")
          }
        }
      }
      plotMotifLogoStack(pfms)
      return(invisible(list(phylog=NULL, pfms=pfms)))
    }
    dots$motifs <- pfms
    ##calculate the distances
    if(!"phylog" %in% names(dots)){
      if(!psam){
        hc <- do.call(clusterMotifs, args=dots)
        if(layout!="stack" && reorder) pfms <- pfms[hc$order]
        if(pfms[[1]]@alphabet %in% c("DNA", "RNA")) {
          pfms <- DNAmotifAlignment(pfms, revcomp = revcomp)
        }else{
          if(pfms[[1]]@alphabet %in% c("AA") && layout!="stack"){
            pfms <- AAmotifAlignment(pfms)
          }else{
            if(pfms[[1]]@alphabet=="others"){
              warning("alphabet is set to 'others'. ",
                      "Currently 'others' is not support for alignment.")
            }
          }
        }
        phylog <- hclust2phylog(hc)
      }
    }
    if(layout=="treeview" && !exists("hc")){
      if(!psam){
        dots$motifs <- pfms
        hc <- do.call(clusterMotifs, args=dots)
      }
    }
    switch(layout,
           stack = {
               plotMotifLogoStack(pfms, ...)
           },
           treeview = {
               if(!exists("hc")){
                 stop("hc is required for plotMotifLogoStackWithTree.")
               }
              plotMotifLogoStackWithTree(pfms, hc=hc, ...)
           },
           phylog = {
             if(!exists("phylog")){
               stop("phylog is required for plotMotifStackWithPhylog.")
             }
               plotMotifStackWithPhylog(phylog=phylog, pfms=pfms, ...)
           },
           radialPhylog = {
             if(!exists("phylog")){
               stop("phylog is required for plotMotifStackWithRadialPhylog.")
             }
               args <- list(phylog=phylog, pfms=pfms, ...)
               for(i in names(args)){
                   if(i %in% c("col.leaves", "col.leaves.bg", "col.bg",
                               "col.inner.label.circle",
                               "col.outer.label.circle")){
                       args[[i]] <- args[[i]][hc$order]
                   }
               }
               do.call(plotMotifStackWithRadialPhylog, args)
           },
           plotMotifLogoStack(pfms, ...)
    )
    
    return(invisible(list(phylog=phylog, pfms=pfms)))
}

###############################################################################
######## radial style stack
######## 
###############################################################################


#' plot sequence logo stacks with a radial phylogenic tree
#' 
#' plot sequence logo stacks with a radial phylogenic tree
#' 
#' 
#' @param phylog an object of class phylog
#' @param pfms a list of objects of class pfm
#' @param circle a size coefficient for the outer circle of the labels. Please
#' note this is the position of inner.label.cirle.
#' @param circle.motif a size coefficient for the motif circle
#' @param cleaves a character size for plotting the points that represent the
#' leaves, used with par("cex")*cleaves. If zero, no points are drawn
#' @param cnodes a character size for plotting the points that represent the
#' nodes, used with par("cex")*cnodes. If zero, no points are drawn
#' @param labels.leaves a vector of strings of characters for the leaves labels
#' @param clabel.leaves a character size for the leaves labels, used with
#' par("cex")*clabel.leaves
#' @param labels.nodes a vector of strings of characters for the nodes labels
#' @param clabel.nodes a character size for the nodes labels, used with
#' par("cex")*clabel.nodes. If zero, no nodes labels are drawn
#' @param draw.box if TRUE draws a box around the current plot with the
#' function box()
#' @param col.leaves a vector of colors for leaves labels
#' @param col.leaves.bg a vector of colors for background of leaves labels
#' @param col.leaves.bg.alpha alpha value [0, 1] for the colors of backgroud of
#' leaves labels
#' @param col.bg a vector of colors for tree background
#' @param col.bg.alpha a alpha value [0, 1] of colors for tree background
#' @param col.inner.label.circle a vector of colors for inner cirlce of pfms
#' @param inner.label.circle.width width for inner circle of pfms
#' @param col.outer.label.circle a vector of colors for outer circle of pfms
#' @param outer.label.circle.width width for outer circle of pfms
#' @param clockwise a logical value indicating if slices are drawn clockwise or
#' counter clockwise
#' @param init.angle number specifying the starting angle (in degrees) for the
#' slices. Defaults to 0 (i.e., `3 o'clock`) unless clockwise is true where
#' init.angle defaults to 90 (degrees), (i.e., `12 o'clock`)
#' @param angle number specifying the angle (in degrees) for phylogenic tree.
#' Defaults 360
#' @param pfmNameSpliter spliter when name of pfms contain multiple node of
#' labels.leaves
#' @param rcpostfix the postfix for reverse complements
#' @param motifScale the scale of logo size
#' @param ic.scale logical. If TRUE, the height of each column is proportional
#' to its information content. Otherwise, all columns have the same height.
#' @param plotIndex logical. If TRUE, will plot index number in the motifLogo
#' which can help user to describe the motifLogo
#' @param IndexCol The color of the index number when plotIndex is TRUE.
#' @param IndexCex The cex of the index number when plotIndex is TRUE.
#' @param groupDistance show groupDistance on the draw
#' @param groupDistanceLineCol groupDistance line color, default: red
#' @param plotAxis logical. If TRUE, will plot distance axis.
#' @param font font of logo
#' @param ... not used.
#' @return none
#' @seealso \link[ade4:plot.phylog]{plot.phylog}
#' @export
#' @importFrom graphics par plot.default strwidth polygon text segments
#' points lines symbols box
#' @importFrom grDevices grey dev.size
#' @importFrom stats median
#' @importFrom grid pushViewport viewport popViewport grid.text gpar grid.xaxis
#' @examples
#' 
#'   if(interactive() || Sys.getenv("USER")=="jianhongou"){
#'     library("MotifDb")
#'     matrix.fly <- query(MotifDb, "Dmelanogaster")
#'     motifs <- as.list(matrix.fly)
#'     motifs <- motifs[grepl("Dmelanogaster-FlyFactorSurvey-", 
#'                             names(motifs), fixed=TRUE)]
#'     names(motifs) <- gsub("Dmelanogaster_FlyFactorSurvey_", "", 
#'                 gsub("_FBgn[0-9]+$", "", 
#'                   gsub("[^a-zA-Z0-9]","_", 
#'                      gsub("(_[0-9]+)+$", "", names(motifs)))))
#'     motifs <- motifs[unique(names(motifs))]
#'     pfms <- sample(motifs, 50)
#'     hc <- clusterMotifs(pfms)
#'     library(ade4)
#'     phylog <- ade4::hclust2phylog(hc)
#'     leaves <- names(phylog$leaves)
#'     pfms <- pfms[leaves]
#'     pfms <- mapply(pfms, names(pfms), FUN=function(.ele, .name){
#'                  new("pfm",mat=.ele, name=.name)})
#'     pfms <- DNAmotifAlignment(pfms, minimalConsensus=3)
#'     library(RColorBrewer)
#'     color <- brewer.pal(12, "Set3")
#'     plotMotifStackWithRadialPhylog(phylog, pfms, circle=0.9, 
#'                  cleaves = 0.5, clabel.leaves = 0.7, 
#'                  col.bg=rep(color, each=5), col.leaves=rep(color, each=5))
#'   }
#' 
plotMotifStackWithRadialPhylog <- 
  function (phylog, pfms=NULL,
            circle=.75, circle.motif=NA, cleaves=1, cnodes=0,
            labels.leaves=names(phylog$leaves), clabel.leaves=1,
            labels.nodes=names(phylog$nodes), clabel.nodes=0,
            draw.box=FALSE,
            col.leaves=rep("black", length(labels.leaves)),
            col.leaves.bg=NULL, col.leaves.bg.alpha=1,
            col.bg=NULL, col.bg.alpha=1,
            col.inner.label.circle=NULL, inner.label.circle.width="default",
            col.outer.label.circle=NULL, outer.label.circle.width="default",
            clockwise =FALSE, init.angle=if(clockwise) 90 else 0,
            angle=360, pfmNameSpliter=";", rcpostfix="(RC)", 
            motifScale=c("linear","logarithmic"), ic.scale=TRUE,
            plotIndex=FALSE, IndexCol="black", IndexCex=.8,
            groupDistance=NA, groupDistanceLineCol="red", 
            plotAxis=FALSE, font="sans",
            ...)
{
  if (!inherits(phylog, "phylog"))
    stop("Non convenient data")
  if(all(sapply(pfms, function(.ele) is(.ele, "pcm")))) {
      pfms <- lapply(pfms, pcm2pfm)
  }
  leaves.number <- length(phylog$leaves)
  checkLength <- function(tobechecked){
    !((length(tobechecked)>=leaves.number)||is.null(tobechecked))
  }
  checkNA <- function(tobechecked){
    if(is.null(tobechecked)) return(FALSE)
    return(any(is.na(tobechecked)))
  }
  for(tobechecked in c("col.leaves", "col.leaves.bg", "col.bg", "col.inner.label.circle", "col.outer.label.circle")){
    if(checkLength(eval(as.symbol(tobechecked)))) stop(paste("the length of", tobechecked, "should be same as the length of leaves"))
    if(checkNA(eval(as.symbol(tobechecked)))) stop(paste("contain NA in", tobechecked))
  }
  motifScale <- match.arg(motifScale)
  leaves.names <- names(phylog$leaves)
  nodes.number <- length(phylog$nodes)
  nodes.names <- names(phylog$nodes)
  if (length(labels.leaves) != leaves.number)
    labels.leaves <- names(phylog$leaves)
  if (length(labels.nodes) != nodes.number)
    labels.nodes <- names(phylog$nodes)
  if (circle < 0)
    stop("'circle': non convenient value")
  leaves.car <- gsub("[_]", " ", labels.leaves)
  nodes.car <- gsub("[_]", " ", labels.nodes)
  opar <- par(mar = par("mar"), srt = par("srt"))
  on.exit(par(opar))
  par(mar = c(0.1, 0.1, 0.1, 0.1), mfrow=c(1,1))
  dis <- phylog$droot
  max_Dis <- max(dis)
  axis_pos <- circle
  if(!is.na(groupDistance)){
    groupDistance <- (max_Dis - groupDistance) * circle / max_Dis
  }
  dis <- dis/max_Dis
  rayon <- circle
  dis <- dis * rayon
  dist.leaves <- dis[leaves.names]
  dist.nodes <- dis[nodes.names]
  asp <- c(1, 1)
  if(is.null(pfms)){
    plot.default(0, 0, type = "n", asp = 1, xlab = "", ylab = "",
                 xaxt = "n", yaxt = "n", xlim = c(-2, 2), ylim = c(-2, 2),
                 xaxs = "i", yaxs = "i", frame.plot = FALSE)
  }else{
    pin <- dev.size("in") #pin <- par("pin")
    if (pin[1L] > pin[2L]) asp <- c(pin[2L]/pin[1L], 1)
    else asp <- c(1, pin[1L]/pin[2L])
    plot.default(0, 0, type = "n", asp=1, xlab = "", ylab = "",
                 xaxt = "n", yaxt = "n", xlim = c(-2.5, 2.5), ylim = c(-2.5, 2.5),
                 xaxs = "i", yaxs = "i", frame.plot = FALSE)
  }
  d.rayon <- rayon/(nodes.number - 1)
  twopi <- if (clockwise) -2 * pi else 2 * pi
  alpha <- twopi * angle * (1:leaves.number)/leaves.number/360 + init.angle * pi/180
  names(alpha) <- leaves.names
  x <- dist.leaves * cos(alpha)
  y <- dist.leaves * sin(alpha)
  xcar <- (rayon + d.rayon) * cos(alpha)
  ycar <- (rayon + d.rayon) * sin(alpha)
  
  rayonWidth <- max(unlist(lapply(leaves.names, strwidth, units="user", cex=clabel.leaves)))
  circle.motif <- ifelse(is.na(circle.motif), rayon + d.rayon + rayonWidth, circle.motif)
  ##for logos position
  maxvpwidth <- 0
  if(!is.null(pfms)){
    beta <- alpha * 180 / pi
    vpheight <- 2 * pi * angle * circle.motif / 360 / leaves.number / 5
    vpheight <- vpheight * asp[2L]
    xm <- circle.motif * cos(alpha) * asp[1L] / 5 + 0.5
    ym <- circle.motif * sin(alpha) * asp[2L] / 5 + 0.5
    pfmNamesLen <- sapply(pfms, function(.ele) 
      length(strsplit(.ele@name, pfmNameSpliter)[[1]]))
    if(motifScale=="linear")
      vph <- 2.5*vpheight*pfmNamesLen
    else vph <- 2.5*vpheight*(1+log2(pfmNamesLen+0.0001))
    maxvpwidth <- max(mapply(function(.ele, f) ncol(.ele@mat)*f, pfms, vph))
  }
  if(inner.label.circle.width=="default") inner.label.circle.width <- rayonWidth/10
  if(outer.label.circle.width=="default") outer.label.circle.width <- rayonWidth/10
  
  ratio <- if(!is.null(pfms)) 2.5/(circle.motif+maxvpwidth+outer.label.circle.width) else 1
  if(ratio < 1){
    x <- x * ratio
    y <- y * ratio
    xcar <- xcar * ratio
    ycar <- ycar * ratio
    dis <- dis * ratio
    groupDistance <- groupDistance * ratio
    xm <- (xm-.5) * ratio + .5
    ym <- (ym-.5) * ratio + .5
    vpheight <- vpheight * ratio
    axis_pos <- axis_pos * ratio
  }
  ##for plot background
  if(!is.null(col.bg)) col.bg <- highlightCol(col.bg, col.bg.alpha)
  if(!is.null(col.leaves.bg)) col.leaves.bg <- highlightCol(col.leaves.bg, col.leaves.bg.alpha)
  gamma <- twopi * angle * ((1:(leaves.number+1))-0.5)/leaves.number/360 + init.angle * pi/180
  n <- max(2, floor(200*360/leaves.number))
  plotBgArc <- function(r,bgcol,inr){
    if(ratio < 1){
      r <- r*ratio
      inr <- inr*ratio
    }
    t2xy <- function(rx,t) list(x=rx*cos(t), y=rx*sin(t))
    oldcol <- bgcol[1]
    start <- 1
    icnt <- 1
    for(i in 1:leaves.number){
      oldcol <- bgcol[i]
      if(i==leaves.number || bgcol[i+1]!=oldcol){
        P <- t2xy(r, seq.int(gamma[start], gamma[start+icnt], length.out=n*icnt))
        polygon(c(P$x, 0), c(P$y, 0), border=bgcol[i], col=bgcol[i])
        start <- i+1
        icnt <- 1
      } else {
        icnt <- icnt + 1
      }
    }
    if(inr!=0){
      P <- t2xy(inr, seq.int(0, twopi, length.out=n*leaves.number))
      polygon(c(P$x, 0), c(P$y, 0), border="white", col="white")
    }
  }
  if (clabel.leaves > 0) {
    if(!is.null(col.outer.label.circle)) ##plot outer.label.circle
      plotBgArc(circle.motif+maxvpwidth+outer.label.circle.width, col.outer.label.circle, circle.motif+maxvpwidth)
    if(!is.null(col.inner.label.circle)) #plot inner.label.circle
      plotBgArc(circle.motif, col.inner.label.circle, circle.motif - inner.label.circle.width)
    if(!is.null(col.leaves.bg)) ##plot leaves bg
      plotBgArc(circle.motif - inner.label.circle.width, col.leaves.bg, rayon+d.rayon)
    if(!is.null(col.bg)) ##plot center bg
      plotBgArc(ifelse(mean(dist.leaves)/max(dis) > .9, mean(dist.leaves), max(dis)-d.rayon), col.bg, 0)##plotBgArc(mean(dist.leaves), col.bg, 0)
    for(i in 1:leaves.number) {
      par(srt = alpha[i] * 180/pi)
      text(xcar[i], ycar[i], leaves.car[i], adj = 0, col=col.leaves[i], cex = par("cex") *
             clabel.leaves)
      segments(xcar[i], ycar[i], x[i], y[i], col = grey(0.7))
    }
    
    assign("tmp_motifStack_symbolsCache", list(), envir=.globals)
    if(!is.null(pfms)){
      ##extract names
      for(metaChar in c("\\","$","*","+",".","?","[","]","^","{","}","|","(",")"))
      {
        rcpostfix <- gsub(metaChar,paste("\\",metaChar,sep=""),rcpostfix,fixed=TRUE)
      }
      pfmNames <- lapply(pfms, function(.ele) .ele@name)
      for(i in 1:length(pfmNames)){
        pfmname <- unlist(strsplit(pfmNames[[i]], pfmNameSpliter))
        pfmname <- gsub(paste(rcpostfix,"$",sep=""),"",pfmname)
        pfmIdx <- which(makeLeaveNames(labels.leaves) %in% makeLeaveNames(pfmname))
        if(length(pfmIdx)==0) 
          pfmIdx <- which(makeLeaveNames(names(phylog$leaves)) 
                          %in% makeLeaveNames(pfmname))
        if(length(pfmIdx)>0){
          vph <- ifelse(motifScale=="linear",
                        vpheight*length(pfmname),
                        vpheight*(1+log2(length(pfmname))))
          vpw <- vph * ncol(pfms[[i]]@mat) / 2
          vpd <- sqrt(vph*vph+vpw*vpw) / 2
          angle <- median(beta[pfmIdx])
          if(length(pfmIdx)%%2==1){
            this.pfmIdx <- which(beta[pfmIdx] == angle)[1]
            vpx <- xm[pfmIdx[this.pfmIdx]] + vpd * cos(alpha[pfmIdx[this.pfmIdx]]) * asp[1L]
            vpy <- ym[pfmIdx[this.pfmIdx]] + vpd * sin(alpha[pfmIdx[this.pfmIdx]]) * asp[2L]
            vpx1 <- xm[pfmIdx[this.pfmIdx]] - inner.label.circle.width * cos(alpha[pfmIdx[this.pfmIdx]]) * asp[1L] *1.1/5
            vpy1 <- ym[pfmIdx[this.pfmIdx]] - inner.label.circle.width * sin(alpha[pfmIdx[this.pfmIdx]]) * asp[2L] *1.1/5
          }else{
            this.pfmIdx <- order(abs(beta[pfmIdx] - angle))[1:2]
            vpx <- median(xm[pfmIdx[this.pfmIdx]]) + vpd * cos(median(alpha[pfmIdx[this.pfmIdx]])) * asp[1L]
            vpy <- median(ym[pfmIdx[this.pfmIdx]]) + vpd * sin(median(alpha[pfmIdx[this.pfmIdx]])) * asp[2L]
            vpx1 <- median(xm[pfmIdx[this.pfmIdx]]) - inner.label.circle.width * cos(median(alpha[pfmIdx[this.pfmIdx]])) * asp[1L] *1.1/5
            vpy1 <- median(ym[pfmIdx[this.pfmIdx]]) - inner.label.circle.width * sin(median(alpha[pfmIdx[this.pfmIdx]])) * asp[2L] *1.1/5
          }
          pushViewport(viewport(x=vpx, y=vpy, width=vpw, height=vph, angle=angle))
          if(!is(pfms[[i]], "psam")){
            plotMotifLogoA(pfms[[i]], font=font, ic.scale=ic.scale)
          }else{
            plotAffinityLogo(pfms[[i]], font=font, newpage=FALSE)
          }
          popViewport()
          if(plotIndex) {
            grid.text(label=i, x=vpx1, 
                      y=vpy1, 
                      gp=gpar(col=IndexCol, cex=IndexCex), rot=angle, just="right")
          }
        }else{
          warning(paste("No leave named as ", paste(pfmname, collapse=", ")), sep="")
        }
      }
    }
    rm(list="tmp_motifStack_symbolsCache", envir=.globals)
  }
  if (cleaves > 0) {
    for (i in 1:leaves.number) points(x[i], y[i], pch = 21, col=col.leaves[i],
                                      bg = col.leaves[i], cex = par("cex") * cleaves)
  }
  ang <- rep(0, length(dist.nodes))
  names(ang) <- names(dist.nodes)
  ang <- c(alpha, ang)
  for (i in 1:length(phylog$parts)) {
    w <- phylog$parts[[i]]
    but <- names(phylog$parts)[i]
    ang[but] <- mean(ang[w])
    b <- range(ang[w])
    a.seq <- c(seq(b[1], b[2], by = pi/180), b[2])
    lines(dis[but] * cos(a.seq), dis[but] * sin(a.seq), col="#222222", lwd=par("cex") * clabel.leaves)
    x1 <- dis[w] * cos(ang[w])
    y1 <- dis[w] * sin(ang[w])
    x2 <- dis[but] * cos(ang[w])
    y2 <- dis[but] * sin(ang[w])
    segments(x1, y1, x2, y2, col="#222222", lwd=par("cex") * clabel.leaves)
  } 
  if(!is.na(groupDistance)){
    if(length(groupDistanceLineCol)!=length(groupDistance)){
      groupDistanceLineCol <- rep(groupDistanceLineCol, ceiling(length(groupDistance)/length(groupDistanceLineCol)))[1:length(groupDistance)]
    }
    for(i in 1:length(groupDistance)){
      symbols(x=0, y=0, circles=groupDistance[i], fg=groupDistanceLineCol[i], lty=2, inches=FALSE, add=TRUE)
    }
  }
  if (cnodes > 0) {
    for (i in 1:length(phylog$parts)) {
      w <- phylog$parts[[i]]
      but <- names(phylog$parts)[i]
      ang[but] <- mean(ang[w])
      points(dis[but] * cos(ang[but]), dis[but] * sin(ang[but]),
             pch = 21, bg = "white", cex = par("cex") * cnodes)
    }
  }
  
  ## draw distance indix  
  if(plotAxis){
    wd <- if(!is.null(pfms)) 5 else 4
    if(clockwise){
      vp <- viewport(x=0.5, y=0.5, width=axis_pos/wd, height=.1, 
                     xscale=c(0, max_Dis), angle=init.angle, just=c(0, 0))
      pushViewport(vp)
      grid.xaxis(gp=gpar(cex = par("cex") * clabel.leaves, col="lightgray"),
                 main=TRUE)
      popViewport()
    }else{
      vp <- viewport(x=0.5, y=0.5, width=axis_pos/wd, height=.1, 
                     xscale=c(0, max_Dis), angle=init.angle, just=c(0, 1))
      pushViewport(vp)
      grid.xaxis(gp=gpar(cex = par("cex") * clabel.leaves, col="lightgray"),
                 main=FALSE)
      popViewport()
    }
  }
  
  points(0, 0, pch = 21, cex = par("cex") * 2 * clabel.leaves, bg = "red")
  if (clabel.nodes > 0) {
    delta <- strwidth(as.character(length(dist.nodes)), cex = par("cex") *
                        clabel.nodes)
    for (j in 1:length(dist.nodes)) {
      i <- names(dist.nodes)[j]
      par(srt = (ang[i] * 360/2/pi + 90))
      x1 <- dis[i] * cos(ang[i])
      y1 <- dis[i] * sin(ang[i])
      symbols(x1, y1, delta, bg = "white", add = TRUE,
              inches = FALSE)
      text(x1, y1, nodes.car[j], adj = 0.5, cex = par("cex") *
             clabel.nodes)
    }
  }
  
  if (draw.box)
    box()
  return(invisible())
}

## compare two motifs
## require two motifs must be exact same width and aligned


#' plot motif over another motif
#' 
#' plot motif over another motif to emphesize the difference.
#' 
#' 
#' @param motif an object of \code{\link{pcm}} or \code{\link{pfm}}
#' @param backgroundMotif an object of \code{\link{pcm}} or \code{\link{pfm}}
#' @param bgNoise if it is not NA, test will using a background by
#' Dirichlet(1)-distributed random frequencies with weight bg.noise.  The value
#' of bgNoise should be a number in the range of 0 to 1, eg. 0.05
#' @param font font for logo symbol
#' @param textgp text parameter
#' @return none
#' @export
#' @importFrom grid gpar convertUnit unit grid.text grid.lines arrow grid.draw
#' @importFrom stats rgamma
#' @importFrom graphics plot.new
#' @importFrom grDevices dev.size
#' @examples
#' 
#' pcms <- readPCM(file.path(find.package("motifStack"), "extdata"),"pcm$")
#' len <- sapply(pcms, function(.ele) ncol(.ele$mat))
#' pcms <- pcms[len==7]
#' plotMotifOverMotif(pcms[[1]], pcms[[2]], bgNoise=0.05)
#' 
plotMotifOverMotif <- function(motif, backgroundMotif, bgNoise=NA, 
                               font="sans", textgp=gpar()){
    if(!inherits(motif, c("pcm", "pfm")))
        stop("motif must be an object of pcm or pfm")
    if(!inherits(backgroundMotif, c("pcm", "pfm")))
        stop("backgroundMotif must be an object of pcm or pfm")
    if(!is(motif, "pfm")) motif <- pcm2pfm(motif)
    if(!is(backgroundMotif, "pfm")) backgroundMotif <- pcm2pfm(backgroundMotif)
    
    w1 <- ncol(motif$mat)
    w2 <- ncol(backgroundMotif$mat)
    if(w1!=w2) stop("motif and backgroundMotif must be exact same width and aligned")
    if(!identical(motif$alphabet, backgroundMotif$alphabet))
        stop("the type of motif and backgroundMotif is different.")
    if(!identical(motif$background, backgroundMotif$background))
        stop("the backgrounds of motif and backgroundMotif are not identical.")
    
    pfm <- motif$mat
    background <- backgroundMotif$mat
    rdirichlet <- function (n, alpha){
        l <- length(alpha)
        x <- matrix(rgamma(l * n, alpha), ncol = n, byrow = TRUE)
        sm <- x %*% rep(1, n)
        t(x/as.vector(sm))
    }
    if(!is.na(bgNoise)){
        if(bgNoise<0 | bgNoise>1) stop("bgNoise must be number in (0, 1)")
        background <- (1-bgNoise)*background + 
            bgNoise*rdirichlet(nrow(background), rep(1, ncol(background)))
    }
    #plotMotifLogo(pfm, motifName, background, ...)
    #plot
    dat <- pfm - background
    npos <- ncol(dat)
    ncha <- nrow(dat)
    colset <- motif$color
    rname <- rownames(dat)
    key<-paste("x", ncha, font, paste(colset[rname], collapse=""), 
               paste(rname, collapse=""), sep="_")
    symbolsCache <- 
        if(exists("tmp_motifStack_symbolsCache", envir=.globals)){
            get("tmp_motifStack_symbolsCache", envir=.globals)
        } else {
            list()
        }
    if(!is.null(symbolsCache[[key]])){
        symbols <- symbolsCache[[key]]
    } else {
        symbols <- coloredSymbols(ncha, font, colset[rname], rname)
        symbolsCache[[key]]<-symbols
        assign("tmp_motifStack_symbolsCache", symbolsCache, envir=.globals)
    }
    pictureGrob <- get("pictureGrob", envir = .globals)
    
    ##check font height to fix the number size
    plot.new()
    dw <- 1/(npos+2)
    line1 <- as.numeric(convertUnit(unit(1, "strwidth", "W"), "npc"))
    pin <- dev.size("in") #pin <- par("pin")
    cex <- dw/line1
    if(length(textgp)==0){
        cex1 <- ifelse(pin[1L] > pin[2L],
                       cex * pin[2L]/pin[1L],
                       cex)
        textgp <- gpar(cex=.8 * cex1)
    }
    tickgp <- textgp
    tickgp$cex <- cex/3
    x0 <- dw ## max 4 chars
    x1 <- 4/5 * dw
    x2 <- 6/5 * dw
    ##set ylim
    datN <- apply(dat, 2, function(.col) sum(.col[.col<0]))
    datP <- apply(dat, 2, function(.col) sum(.col[.col>0]))
    ylim <- c((as.integer(min(datN)/0.05)-1)*0.05,
              (as.integer(max(datP)/0.05)+1)*0.05)
    remap <- function(x){
        (ylim[1] - x)/(ylim[1] - ylim[2])/(1+dw)
    }
    reheight <- function(x){
        abs(x/(ylim[1] - ylim[2])/(1+dw))
    }
    
    ##draw axis
    x.pos <- 0
    grid.text(0, x0, remap(0)+dw/2, just=c(.5, .5), gp=textgp)
    grid.lines(x=x0, y=c(remap(0)+dw, 1), 
               arrow=arrow(length=unit(0.02, "npc")),
               gp=gpar(lwd=tickgp$cex))
    grid.lines(x=x0, y=c(remap(0), 0), 
               arrow=arrow(length=unit(0.02, "npc")), 
               gp=gpar(lwd=tickgp$cex))
    ##draw tick
    tick <- 0.1
    times <- 100
    for(i in c(as.integer(min(datN)/tick):(-1), 1:as.integer(max(datP)/tick))){
        grid.lines(x=c(x2, x0), y=remap(i*tick)+dw/2, gp=gpar(lwd=tickgp$cex))
        grid.text(times*tick*i, x=x1, remap(i*tick)+dw/2, 
                  just=c(1, .5), gp=tickgp)
    }
    
    x.pos <- x0 + dw/2
    for(j in 1:npos){
        heights <- dat[, j]
        id <- order(heights)
        id1 <- order(heights)
        y.pos <- remap(sum(heights[heights<0]))
        flag <- 0
        if(length(heights)>0){
            for(i in 1:length(heights)){
                h <- reheight(heights[id1[i]])
                if(heights[id1[i]]>0) flag <- flag+1
                if(flag==1) {
                        grid.text(j, x.pos+dw/2, y.pos+dw/2,
                                  just=c(.5, .5), gp=textgp)
                    y.pos <- y.pos + dw
                    flag <- flag+1
                }
                if(h>0) {
                    grid.draw(pictureGrob(picture = symbols[[id[i]]],
                                          x = x.pos, y = y.pos,
                                          width = dw, height = h,
                                          just=c(0,0),distort=TRUE))
                    y.pos<-y.pos+h
                }
            }
            
        }
        if(flag==0) grid.text(j, x.pos+dw/2, y.pos+dw/2, 
                              just=c(.5, .5), gp=textgp)
        x.pos<-x.pos+dw
    }
    return(invisible(dat))
}

#' plot sequence logo
#' 
#' plot amino acid or DNA sequence logo
#' 
#' 
#' @param pfm a position frequency matrices
#' @param motifName motif name
#' @param p background possibility
#' @param font font of logo
#' @param fontface fontface of logo
#' @param colset color setting for each logo letter
#' @param xaxis draw x-axis or not. If a vector of character or numeric is
#' provided, the function will try to plot the x-axis by setting the labels
#' as the vectors.
#' @param yaxis draw y-axis or not
#' @param xlab x-label, do nothing if set xlab as NA
#' @param ylab y-label, do nothing if set ylab as NA
#' @param xlcex cex value for x-label
#' @param ylcex cex value for y-label
#' @param ncex cex value for motif name
#' @param ic.scale logical If TRUE, the height of each column is proportional
#' to its information content. Otherwise, all columns have the same height.
#' It will also can be set as FALSE followed by a numeric vectors.
#' The format is c(FALSE, scale).
#' If it is FALSE followed by a number (eg c(FALSE, 100)), 
#' the y axis labels will be re-scaled by 100.
#' @param newpage logical If TRUE, plot it in a new page.
#' @param margins A numeric vector interpreted in the same way as par(mar) in
#' base graphics.
#' @param draw Vector (logical(1)). TRUE to plot. FALSE, return a gList
#' @param ... Not used.
#' @return none
#' @export
#' @importFrom grid gList gTree plotViewport textGrob unit gpar grid.newpage
#' grid.draw gList grid.draw pointsGrob
#' @examples
#' 
#' pcm<-matrix(runif(40,0,100),nrow=4,ncol=10)
#' pfm<-pcm2pfm(pcm)
#' rownames(pfm)<-c("A","C","G","T")
#' plotMotifLogo(pfm)
#' 
plotMotifLogo<-function(pfm, motifName, p=rep(0.25, 4), 
                        font="sans", fontface="bold", 
                        colset=c("#00811B","#2000C7","#FFB32C","#D00001"), 
                        xaxis=TRUE,yaxis=TRUE,xlab="position",ylab="bits",
                        xlcex=1.2, ylcex=1.2, ncex=1.2, ic.scale=TRUE,
                        newpage=TRUE, margins=c(4.1, 4.1, 2.1, .1), draw=TRUE,
                        ...){
  markers <- NULL
  if (is(pfm, "data.frame")){
    pfm <- as.matrix(pfm)
  }else{
    if(is(pfm, "pcm")){
      pfm <- pcm2pfm(pfm)
    }
    if(is(pfm, "pfm")){
      markers <- pfm@markers
      if(missing(motifName)) motifName = pfm@name
      p=pfm@background[rownames(pfm@mat)]
      p <- p/sum(p)
      colset=pfm@color[rownames(pfm@mat)]
      pfm <- pfm@mat
    }
  } 
  if (!is(pfm, "matrix")){
    stop("pfm must be a matrix")
  }
  if(length(p)<nrow(pfm)){
    warning("background length is shorter than number of rows. Will use default background")
    p <- rep(1/nrow(pfm), nrow(pfm))
  }
  if (any(abs(1 - apply(pfm,2,sum)) > 0.01))
    stop("Columns of pfm must add up to 1.0")
  if(!is(colset, "character"))
    stop("colset must be character")
  if (length(colset)!=nrow(pfm))
    stop(paste("colset length and pfm row numbers different",length(colset),"!=",nrow(pfm)))
  rname<-rownames(pfm)
  if(is.null(rname))
    stop("pfm rowname is empty")
  
  npos<-ncol(pfm)
  ncha<-nrow(pfm)
  key<-paste("x", ncha, font, paste(colset, collapse=""), paste(rname, collapse=""), sep="_")
  symbolsCache <- if(exists("tmp_motifStack_symbolsCache", envir=.globals)) get("tmp_motifStack_symbolsCache", envir=.globals) else list()
  if(!is.null(symbolsCache[[key]])) symbols<-symbolsCache[[key]]
  else {
    symbols<-coloredSymbols(ncha, font, colset, rname, fontface=fontface)
    symbolsCache[[key]]<-symbols
    assign("tmp_motifStack_symbolsCache", symbolsCache, envir=.globals)
  }
  pictureGrob <- get("pictureGrob", envir = .globals)
  #calculate postion of each symbol and plot
  plot <- gList()
  ic<-getIC(pfm, p)
  if(ic.scale[1]){
    ie<-getIE(pfm)
    ie <- max(c(ie, ic))
  }else{
    ie <- 1
  }
  dw<-1/npos
  x.pos<-0
  y.poss <- numeric(length=npos)
  for(j in 1:npos){
    column<-pfm[,j]
    if(ic.scale[1]){
      heights<-column*ic[j]/ie
    }else{
      heights <- column
    }
    id<-order(heights)
    
    y.pos<-0
    for(i in 1:ncha){
      h<-heights[id[i]]
      if(h>0 && ic[j]>0) plot <- 
          gList(plot, 
                pictureGrob(picture=symbols[[id[i]]],
                            x=x.pos,
                            y=y.pos,
                            width = dw,
                            height = h, 
                            just=c(0,0),
                            distort=TRUE))
      y.pos<-y.pos+h
    }
    y.poss[j] <- y.pos
    x.pos<-x.pos+dw
  }
  if(length(markers)>0){
    plot <- gList(plot, plotMarkers(markers, dw, y.poss))
  }
  if(is.logical(xaxis)){
    if(xaxis[1]){
      plot <- gList(plot, plotXaxis(pfm, p))
    }
  }else{
    if(length(xaxis)){
      plot <- gList(plot, plotXaxis(pfm, p, label=xaxis))
    }
  }
  if(yaxis) plot <- gList(plot, plotYaxis(ie, ic.scale))
  plot <- gTree(children=plot,
                vp= plotViewport(margins = margins))
  if(!is.na(xlab)) plot <- gList(plot, textGrob(xlab, y=unit(1, units = "lines"), gp=gpar(cex=xlcex), name="xlab"))
  if(!is.na(ylab)) plot <- gList(plot, textGrob(ylab, x=unit(1, units = "lines"), gp=gpar(cex=ylcex), rot=90, name="ylab"))
  if(!missing(motifName)) plot <- gList(plot, textGrob(motifName,y=unit(1, "npc")-unit(.5, units = "lines"), gp=gpar(cex=ncex), name="motifName"))
  if(draw){
    if(newpage) grid.newpage()
    suppressWarnings(grid.draw(plot))
  }else{
    plot
  }
}



#' plot x-axis
#' 
#' plot x-axis for the sequence logo
#' 
#' 
#' @param pfm position frequency matrices
#' @param p background possibility
#' @param label x-axis labels
#' @return none
#' @importFrom grid xaxisGrob gpar unit 
plotXaxis<-function(pfm, p=rep(0.25, 4), label=NULL){
  npos<-ncol(pfm)
  ic<-getIC(pfm,p)
  dw<-1/npos
  at<-c()
  label_j <- c()
  j=1
  for(i in seq.int(npos)){
    if(ic[i]>0){
      at<-c(at,dw*(i-0.5))
      label_j<-c(label_j,j)
      j<-j+1
    }
  }
  if(length(label)!=length(at)){
    label <- label_j
  }
  grob <- xaxisGrob(at=at,label=label, gp=gpar(lwd=1, lex=1, lineheight=1))
  grob$children$labels$y <- unit(-1.1, "lines")
  grob
}




#' plot y-axis
#' 
#' plot y-axis for the sequence logo
#' 
#' 
#' @param ymax max value of y axix
#' @param ic.scale Use IC scale or not. See plotMotifLogo for help.
#' @return none
#' @importFrom grid yaxisGrob gpar unit gList convertUnit
plotYaxis<-function(ymax, ic.scale){
  ie <- ymax
  interval <- 5
  majorat<-seq(0,floor(ie),length.out = interval)
  majorat <- majorat/ie
  majorlab<-seq(0,floor(ie),length.out = interval)
  if(!ic.scale[1]){
    if(length(ic.scale)>1){
      if(is.numeric(ic.scale[1])){
        majorlab <- majorlab*ic.scale[2]
      }
    }
  }
  majorY <- yaxisGrob(at=majorat,label=majorlab,
                      name = "majorY",
                      gp=gpar(lwd=1, lex=1, lineheight=1))
  YgList <- gList(majorY)
  if(convertUnit(unit(1, "npc"), unitTo = "lines", valueOnly = TRUE) > 10){
    minorat<-seq(0, floor(ie), length.out = (interval-1)*5+1)
    minorat <- seq(0, ie, by=diff(minorat)[1])
    minorat <- minorat/ie
    minorat<-minorat[!(minorat %in% majorat)]
    minorY <- yaxisGrob(at=minorat,label=FALSE,name="minorY",
                        gp=gpar(lwd=1, lineheight=.5))
    at <- c(min(c(minorat, majorat)), max(c(minorat, majorat)))
    terminY <- yaxisGrob(at=at, label=FALSE, name="endY",
                         gp=gpar(lwd=1, lineheight=.5))
    YgList <- gList(YgList, minorY, terminY)
  }
  YgList
}


###############################################################################
######## plot motif logo without plot.new
######## to be used to create a better view of stack, eg. radial sty,
###############################################################################


#' plot sequence logo without plot.new
#' 
#' plot amino acid or DNA sequence logo in a given canvas
#' 
#' 
#' @param pfm an object of pfm
#' @param font font of logo
#' @param fontface fontface of logo
#' @param ic.scale logical If TRUE, the height of each column is proportional
#' to its information content. Otherwise, all columns have the same height.
#' @param draw Vector (logical(1)). TRUE to plot. FALSE, return a gList
#' @return none
#' @export
#' @examples
#' 
#' pcm<-matrix(runif(40,0,100),nrow=4,ncol=10)
#' pfm<-pcm2pfm(pcm)
#' rownames(pfm)<-c("A","C","G","T")
#' motif <- new("pfm", mat=pfm, name="bin_SOLEXA")
#' plotMotifLogoA(motif)
#' 
plotMotifLogoA<-function(pfm, font="sans", fontface="bold", ic.scale=TRUE, draw=TRUE){
  if (is(pfm, "pcm")){
    pfm <- pcm2pfm(pfm)
  }
  if (!is(pfm, "pfm")){
    stop("pfms must be a pfm object")
  }
  rname<-rownames(pfm@mat)
  if(is.null(rname))
    stop("pfm rowname is empty")
  npos<-ncol(pfm@mat)
  ncha<-nrow(pfm@mat) 
  key<-paste("x", ncha, font, paste(pfm@color, collapse=""), paste(rname, collapse=""), sep="_")
  symbolsCache <- if(exists("tmp_motifStack_symbolsCache", envir=.globals)) get("tmp_motifStack_symbolsCache", envir=.globals) else list()
  if(!is.null(symbolsCache[[key]])) symbols<-symbolsCache[[key]]
  else {
    symbols<-coloredSymbols(ncha, font, pfm@color, rname, fontface=fontface)
    symbolsCache[[key]]<-symbols
    assign("tmp_motifStack_symbolsCache", symbolsCache, envir=.globals)
  }
  pictureGrob <- get("pictureGrob", envir = .globals)
  #calculate postion of each symbol and plot   
  plot <- gList()
  ic<-getIC(pfm)
  ie<-getIE(pfm@mat)
  ie <- max(c(ie, ic))
  dw<-1/npos
  x.pos<-0
  y.poss <- numeric(length=npos)
  for(j in 1:npos){
    column<-pfm@mat[,j]
    if(ic.scale){
      heights<-column*ic[j]/ie
    }else{
      heights <- column
    }
    id<-order(heights)
    
    y.pos<-0
    for(i in 1:ncha){
      h<-heights[id[i]]
      if(h>0 && ic[j]>0) plot <- 
          gList(plot, 
                pictureGrob(picture = symbols[[id[i]]],
                            x = x.pos,
                            y = y.pos,
                            width = dw,
                            height = h,
                            just=c(0,0),
                            distort=TRUE))
      y.pos<-y.pos+h
    }
    y.poss[j] <- y.pos
    x.pos<-x.pos+dw
  }
  markers <- pfm@markers
  if(length(markers)>0){
    plot <- gList(plot, plotMarkers(markers, dw, y.poss))
  }
  if(draw){
    suppressWarnings(grid.draw(plot))
  }else{
    plot
  }
}

#' @importFrom grid gList rectGrob textGrob linesGrob segmentsGrob
plotMarkers <- function(markers, dw, h, lo=NULL){
  do.call(gList, lapply(markers, function(m){
    switch(m@type,
           "rect"={
             pos <- mapply(seq, m@start, m@stop, SIMPLIFY = FALSE)
             if(length(lo)>0 && length(lo)==length(h)){
               height <- sapply(pos, function(.ele) max(h[.ele])-min(lo[.ele]))
               y <- sapply(pos, function(.ele) (min(lo[.ele])+max(h[.ele]))/2)
             }else{
               height <- sapply(pos, function(.ele) max(h[.ele]))
               y <- height/2
             }
             res <- rectGrob(x= (m@start + m@stop-1)*dw/2,
                             y = y,
                             width = dw*(m@stop - m@start + 1),
                             height = height, 
                             gp = m@gp)
             if(any(nchar(m@label)>0)){
               tG <- textGrob(label=m@label,
                              x = (m@start+m@stop-1)*dw/2,
                              y = height,
                              vjust = -.5,
                              gp = m@gp)
               res <- gList(res, tG)
             }
             res
             },
           "text"={
             pos <- mapply(seq, m@start, m@stop, SIMPLIFY = FALSE)
             label <- rep(m@label, lengths(pos))
             pos <- unlist(pos)
             textGrob(label=label,
                      x = (pos-.5)*dw, 
                      y = h[pos],
                      vjust = -0.1,
                      gp = m@gp)
             },
           "line"={
             pos <- mapply(seq, m@start, m@stop, SIMPLIFY = FALSE)
             height <- sapply(pos, function(.ele) max(h[.ele]))
             res <- segmentsGrob(x0 = (m@start-1)*dw, 
                                 x1 = m@stop*dw,
                                 y0 = height,
                                 y1 = height,
                                 gp = m@gp)
             if(any(nchar(m@label)>0)){
               tG <- textGrob(label=m@label,
                              x = (m@start+m@stop-1)*dw/2,
                              y = height,
                              vjust = -.5,
                              gp = m@gp)
               res <- gList(res, tG)
             }
             res
             })
  }))
}

################## for ggplot2 ###################


#' Motif Grob
#' 
#' This function create a motif grob.
#' 
#' 
#' @param pfm an object of pfm
#' @param x A numeric vector or unit object specifying x-values.
#' @param y A numeric vector or unit object specifying y-values.
#' @param width A numeric vector or unit object specifying width.
#' @param height A numeric vector or unit object specifying height.
#' @param angle A numeric value indicating the angle of rotation of the motif.
#' Positive values indicate the amount of rotation, in degrees, anticlockwise
#' from the positive x-axis.
#' @param ic.scale logical If TRUE, the height of each column is proportional
#' to its information content. Otherwise, all columns have the same height.
#' @param default.units A string indicating the default units to use if x, y,
#' width, or height are only given as numeric vectors.
#' @param name A character value to uniquely identify the motifGrob once it has
#' been pushed onto the grob tree.
#' @param gp A gpar object, typically the output from a call to the function
#' gpar. The list will be used as parameter of plotMotifLogoA.
#' @return An gTree object.
#' @author Jianhong Ou
#' @export
#' @importFrom grid unit gpar viewport gTree
#' @examples
#' 
#' pcm<-matrix(runif(40,0,100),nrow=4,ncol=10)
#' pfm<-pcm2pfm(pcm)
#' rownames(pfm)<-c("A","C","G","T")
#' motif <- new("pfm", mat=pfm, name="bin_SOLEXA")
#' motifGrob(motif)
#' 
motifGrob <- function(pfm, x = unit(0.5, "npc"), y = unit(0.5, "npc"),
                      width = unit(1, "npc"), height = unit(1, "npc"),
                      angle = 0, ic.scale=TRUE, default.units = "native", name=NULL, 
                      gp = gpar(fontfamily="sans",
                                fontface="bold")){
  vp <- viewport(x=x, y=y, width = width, height = height, 
                 default.units = default.units, angle = angle, name = "motifVP")
  fontfamily <- ifelse(length(gp$fontfamily)>0, gp$fontfamily[1], "sans")
  fontface <- ifelse(length(gp$fontface)>0, gp$fontface[1], "bold")
  gTree(children=plotMotifLogoA(pfm, font = fontfamily, fontface = fontface, ic.scale = ic.scale, draw=FALSE),
        name=name, vp=vp, cl="motif")
}



#' geom_motif
#' 
#' geom_motif uses the locations of the four corners (xmin, xmax, ymin and
#' ymax) to plot motifs.
#' 
#' 
#' @param mapping Set of aesthetic mappings created by aes() or aes_(). If
#' specified and inherit.aes = TRUE (the default), it is combined with the
#' default mapping at the top level of the plot.  You must supply mapping if
#' there is no plot mapping.
#' @param data The data to be displayed in this layer.
#' @param stat The statistical transformation to use on the data for this
#' layer, as a string.
#' @param position Position adjustment, either as a string, or the result of a
#' call to a position adjustment function.
#' @param \dots Other arguments passed on to layer().
#' @param ic.scale logical If TRUE, the height of each column is proportional
#' to its information content.  Otherwise, all columns have the same height.
#' @param use.xy logical If TRUE, the required aesthethics will be x, y, width,
#' height, and motif.  Otherwise, xmin, ymin, xmax, ymax and motif.
#' @param show.legend Not used.
#' @param inherit.aes If FALSE, overrides the default aesthetics, rather than
#' combining with them.
#' @return a layer that contains GeomMotif object.
#' @section Aesthetics: geom_motif() understands the following aesthetics
#' (required aesthetics are in bold): \itemize{ \item \strong{\code{xmin}}
#' \item \strong{\code{xmax}} \item \strong{\code{ymin}} \item
#' \strong{\code{ymax}} \item \strong{\code{motif}} \item \code{angle} \item
#' \code{fontfamily} \item \code{fontface} }
#' 
#' OR
#' 
#' \itemize{ \item \strong{\code{x}} \item \strong{\code{y}} \item
#' \strong{\code{width}} \item \strong{\code{height}} \item
#' \strong{\code{motif}} \item \code{angle} \item \code{fontfamily} \item
#' \code{fontface} }
#' @author Jianhong Ou
#' @export
#' @importFrom ggplot2 layer
#' @examples
#' 
#' pcm <- read.table(file.path(find.package("motifStack"), 
#'                             "extdata", "bin_SOLEXA.pcm"))
#' pcm <- pcm[,3:ncol(pcm)]
#' rownames(pcm) <- c("A","C","G","T")
#' motif <- new("pcm", mat=as.matrix(pcm), name="bin_SOLEXA")
#' 
#' df <- data.frame(xmin=c(.25, .25), ymin=c(.25, .75), xmax=c(.75, .75), ymax=c(.5, 1))
#' df$motif <- list(pcm2pfm(motif), pcm2pfm(motif))
#' 
#' library(ggplot2)
#' ggplot(df, aes(xmin=xmin, ymin=ymin, xmax=xmax, ymax=ymax, motif=motif)) + 
#' geom_motif() + theme_bw() + ylim(0, 1) + xlim(0, 1)
#' 
geom_motif <- function(mapping = NULL, data = NULL,
                       stat = "identity", position = "identity",
                       ...,
                       ic.scale=TRUE,
                       use.xy=FALSE,
                       show.legend = NA,
                       inherit.aes = TRUE) {
  layer(
    data = data,
    mapping = mapping,
    stat = stat,
    geom = if(use.xy) GeomMotifA else GeomMotif,
    position = position,
    show.legend = show.legend,
    inherit.aes = inherit.aes,
    params = list(
      ic.scale = ic.scale,
      ...
    )
  )
}

#' GeomMotif object
#' 
#' GeomMotif object is a ggproto object.
#' 
#' 
#' @name GeomMotif
#' @format The format is: Classes 'GeoMotif', 'Geom', 'ggproto', 'gg' <ggproto
#' object: Class GeoMotif, Geom, gg> aesthetics: function default_aes: uneval
#' draw_group: function draw_key: function draw_layer: function draw_panel:
#' function extra_params: na.rm handle_na: function non_missing_aes:
#' optional_aes: parameters: function required_aes: xmin ymin xmax ymax motif
#' setup_data: function use_defaults: function super: <ggproto object: Class
#' Geom, gg>
#' @seealso geom_motif
#' @export
#' @importFrom ggplot2 ggproto aes Geom
#' @examples
#' 
#' pcm <- read.table(file.path(find.package("motifStack"), 
#'                             "extdata", "bin_SOLEXA.pcm"))
#' pcm <- pcm[,3:ncol(pcm)]
#' rownames(pcm) <- c("A","C","G","T")
#' motif <- new("pcm", mat=as.matrix(pcm), name="bin_SOLEXA")
#' 
#' df <- data.frame(xmin=c(.25, .25), ymin=c(.25, .75), xmax=c(.75, .75), ymax=c(.5, 1))
#' df$motif <- list(pcm2pfm(motif), pcm2pfm(motif))
#' 
#' library(ggplot2)
#' 
#' ggplot(df, aes(xmin=xmin, ymin=ymin, xmax=xmax, ymax=ymax, motif=motif)) + 
#' geom_motif() + theme_bw() + ylim(0, 1) + xlim(0, 1)
#' 
#' 

GeomMotif <- 
  ggproto("GeomMotif", Geom, 
          required_aes = c("xmin", "ymin", "xmax", "ymax", "motif"),
          default_aes = aes(angle=0, fontfamily="sans", 
                            fontface="bold"),
          draw_panel = function(data, panel_params, coord, ic.scale=TRUE){
            coords <- coord$transform(data, panel_params)
            n <- nrow(coords)
            do.call(gList, lapply(seq.int(n), function(.id){
              motifGrob(pfm=coords$motif[[.id]],
                        x=mean(c(coords$xmin[.id], coords$xmax[.id])),
                        y=mean(c(coords$ymin[.id], coords$ymax[.id])),
                        width=coords$xmax[.id] - coords$xmin[.id], 
                        height=coords$ymax[.id] - coords$ymin[.id],
                        angle=coords$angle[.id], ic.scale=ic.scale,
                        default.units = "native",
                        gp = gpar(fontfamily=coords$fontfamily[.id],
                                  fontface=coords$fontface[.id]),
                        name = paste0("geom_motif_", .id))
            }))
          })

GeomMotifA <- 
  ggproto("GeomMotif", Geom, 
          required_aes = c("x", "y", "width", "height", "motif"),
          default_aes = aes(angle=0, fontfamily="sans", 
                            fontface="bold"),
          draw_panel = function(data, panel_params, coord, ic.scale=TRUE){
            if(is.unit(data$x)) data$x <- convertUnit(data$x, unitTo = "native", valueOnly = TRUE)
            if(is.unit(data$y)) data$y <- convertUnit(data$x, unitTo = "native", valueOnly = TRUE)
            if(is.unit(data$width)) data$width <- convertUnit(data$width, unitTo = "native", valueOnly = TRUE)
            if(is.unit(data$height)) data$height <- convertUnit(data$height, unitTo = "native", valueOnly = TRUE)
            hw <- data$width/2
            hh <- data$height/2
            data$xmin <- data$x - hw
            data$ymin <- data$y - hh
            data$xmax <- data$x + hw
            data$ymax <- data$y + hh
            coords <- coord$transform(data, panel_params)
            n <- nrow(coords)
            do.call(gList, lapply(seq.int(n), function(.id){
              motifGrob(pfm=coords$motif[[.id]],
                        x=mean(c(coords$xmin[.id], coords$xmax[.id])),
                        y=mean(c(coords$ymin[.id], coords$ymax[.id])),
                        width=coords$xmax[.id] - coords$xmin[.id], 
                        height=coords$ymax[.id] - coords$ymin[.id],
                        angle=coords$angle[.id], ic.scale=ic.scale,
                        default.units = "native",
                        gp = gpar(fontfamily=coords$fontfamily[.id],
                                  fontface=coords$fontface[.id]),
                        name = paste0("geom_motif_", .id))
            }))
          })

#' cluster motifs
#' @description A help function to do matalign and motifHclust in one function.
#' @param motifs A list of pcms of pfms.
#' @param ... parameter to be passed to \link{matalign} function.
#' @return An object of hclust.
#' @export
#' @examples 
#'  if(interactive() || Sys.getenv("USER")=="jianhongou"){
#'   fp <- system.file("extdata", package="motifStack")
#'   fs <- dir(fp, "pcm$")
#'   pcms <- importMatrix(file.path(fp, fs), format="pcm")
#'   hc <- clusterMotifs(pcms)
#'  }
clusterMotifs <- function(motifs, ...){
  d <- matalign(motifs, ...)
  hc <- motifHclust(d, method="average")
  hc
}

pfmList2matrixList <- function(pfms){
  m <- lapply(pfms, pfm2pwm)
  names(m) <- unlist(lapply(pfms, function(.ele) .ele@name))
  m
}

pfm2pcm <- function(pfm, total=1000){
  stopifnot(is(pfm, "pfm"))
  .mat <- pfm@mat
  .mat <- round(total*.mat+.49)
  new("pcm", name=pfm@name, mat=.mat,
      alphabet=pfm@alphabet, color=pfm@color,
      background=pfm@background, tags=pfm@tags,
      markers=pfm@markers)
}

#' Class \code{"pfm"}
#' 
#' An object of class \code{"pfm"} represents the position frequency matrix of
#' a DNA/RNA/amino-acid sequence motif. The entry stores a matrix, which in row
#' i, column j gives the frequency of observing nucleotide/or amino acid i in
#' position j of the motif.
#' 
#' 
#' @name pfm-class
#' @aliases pfm
#' @docType class
#' @section Objects from the Class: Objects can be created by calls of the form
#' \code{new("pfm", mat, name, alphabet, color, background)}.
#' @keywords classes
#' @export
#' @examples
#' 
#' pcm <- read.table(file.path(find.package("motifStack"), "extdata", "bin_SOLEXA.pcm"))
#' pcm <- pcm[,3:ncol(pcm)]
#' rownames(pcm) <- c("A","C","G","T")
#' motif <- pcm2pfm(pcm)
#' motif <- new("pfm", mat=motif, name="bin_SOLEXA")
#' plot(motif)
#' 
setClass("pfm", 
        representation(mat="matrix", name="character", alphabet="character", 
                       color="character", background="numeric", tags="list",
                       markers="list"),
        validity=function(object){
            re<-TRUE
            if (any(abs(1 - apply(object@mat, 2, sum)) > 0.01)) re<-"Columns of PFM must add up to 1.0"
            if (is.null(rownames(object@mat))) re<-"rownames of PFM is empty"
            if (is.null(names(object@color))) re<-"names of color is empty"
            if (length(setdif(rownames(object@mat), names(object@color)))>0) re<-"not every alphabet in pfm has a corresponding color"
            if (is.null(names(object@background))) re<-"names of background is empty"
            if (length(setdif(rownames(object@mat), names(object@background)))>0) re<-"not every alphabet in pfm has a background"
            if (!object@alphabet %in% c("DNA", "RNA", "AA", "others")) re<-"alphabet must be either DNA, RNA, AA or others"
            if (object@alphabet=="DNA" & !all(rownames(object@mat) %in% c("A","C","G","T"))) re<-"rownames of PFM for DNA motifs must be capital A, C, G and T"
            if (object@alphabet=="RNA" & !all(rownames(object@mat) %in% c("A","C","G","U"))) re<-"rownames of PFM for RNA motifs must be capital A, C, G and U"
            if (object@alphabet=="AA" & !all(rownames(object@mat) %in% LETTERS[1:26])) re<-"rownames of PFM for AA motifs must be capital letters"
            if (any(!is(object@markers, "marker"))) re<- "markers must be a list of marker object"
            re
        }
)

#' "pfm" methods
#' 
#' methods for pfm objects.
#' 
#' 
#' @rdname pfm-class
#' @aliases $,pfm-method $<-,pfm-method
#' @docType methods
#' @param x An object of class \code{pfm}. For \code{getIC}, if parameter p is
#' followed, x should be an object of matrix.
#' @param name Slot name.
#' @param y Not use.
#' @param p p is the background frequency.
#' @param n how many spaces should be added.
#' @param b logical value to indicate where the space should be added.
#' @param t numeric value of information content threshold for trimming.
#' @param \dots Further potential arguments passed to \code{plotMotifLogo}.
#' @param row.names,optional see as.data.frame
#' @section Methods: \describe{ \item{addBlank}{\code{signature(x="pfm",
#' n="numeric", b="logical")} add space into the position frequency matrix for
#' alignment. b is a bool value, if TRUE, add space to the 3' end, else add
#' space to the 5' end. n indicates how many spaces should be added.}
#' 
#' \item{getIC}{\code{signature(x = "pfm",)} Calculate information content
#' profile for position frequency matrix. }
#' 
#' \item{getIC}{\code{signature(x = "matrix", p = "numeric")} Calculate
#' information content profile for matrix. p is the background frequency}
#' 
#' \item{matrixReverseComplement}{\code{signature(x = "pfm")} get the reverse
#' complement of position frequency matrix.}
#' 
#' \item{plot}{\code{signature(x = "pfm")} Plots the sequence logo of the
#' position frequency matrix. }
#' 
#' \item{trimMotif}{\code{signature(x = "pfm", t= "numeric")} trim motif by
#' information content. }
#' 
#' \item{$, $<-}{Get or set the slot of \code{\link{pfm-class}}}
#' \item{as.data.frame}{convert \code{\link{pfm-class}} to a data.frame}
#' \item{format}{return the name_pfm of \code{\link{pfm-class}}} }
#' @keywords classes
#' @examples
#' 
#' pcm <- read.table(file.path(find.package("motifStack"), "extdata", "bin_SOLEXA.pcm"))
#' pcm <- pcm[,3:ncol(pcm)]
#' rownames(pcm) <- c("A","C","G","T")
#' motif <- pcm2pfm(pcm)
#' motif <- new("pfm", mat=motif, name="bin_SOLEXA")
#' getIC(motif)
#' matrixReverseComplement(motif)
#' addBlank(motif, 1, FALSE)
#' addBlank(motif, 3, TRUE)
#' as(motif,"matrix")
#' as.data.frame(motif)
#' format(motif)
#' 
#' @exportMethod `$` `$<-`
setMethod("$", "pfm", function(x, name) slot(x, name))
setReplaceMethod("$", "pfm",
                 function(x, name, value){
                     slot(x, name, check = TRUE) <- value
                     x
                 })
#' @importFrom grDevices rainbow
setMethod("initialize","pfm",function(.Object, mat, name, alphabet, color, background, tags, markers){
    if(mode(mat)!="numeric") stop("mat must be a numeric matrix")
    if(is.null(rownames(mat))) stop("rownames of PFM is empty")
    rownames(mat)<-toupper(rownames(mat))
    rname<-rownames(mat)
    if(missing(alphabet)){
        rname<-rname[order(rname)]
        if(all(rname %in% c("A","C","G","T"))) alphabet<-"DNA"
        else{
            if(all(rname %in% c("A","C","G","U"))) alphabet<-"RNA"
            else{
                if(all(rname %in% LETTERS[1:26]) & nrow(mat)==20) alphabet<-"AA"
                else alphabet<-"others"
            }
        }
    }
    if(missing(color)){
      if(alphabet!="others"){
        color<-colorset(alphabet, "auto")
      }else{
        color <- rainbow(nrow(mat))
        names(color) <- rname
      }
    }
    names(color) <- toupper(names(color))
    if(missing(background)){
        background<-rep(1/nrow(mat), nrow(mat))
        names(background)<-rname
    }
    if(length(background)<nrow(mat)){
        background <- rep(background, nrow(mat))[1:nrow(mat)]
        names(background) <- rname
    }
    .Object@mat            =    mat
    .Object@name        =    name
    .Object@alphabet    =    alphabet
    .Object@color        =    color
    .Object@background    =    background
    if(!missing(tags)) .Object@tags = tags
    if(!missing(markers)) .Object@markers = markers
    .Object
})

#' @rdname pfm-class 
#' @aliases plot,pfm,ANY-method
#' @exportMethod plot
setMethod("plot", signature(x="pfm"), 
    function(x, y="missing", ...){
        plotMotifLogo(pfm=x, ...)
    }
)

#' @name coerce
#' @rdname pfm-class
#' @aliases coerce,pfm,matrix-method
#' @exportMethod coerce
setAs(from="pfm", to="matrix", function(from){
    from@mat
})

## get information content profile from PFM
#' @rdname pfm-class
#' @exportMethod getIC
#' @aliases getIC,pfm,ANY-method getIC,matrix,numeric-method 
#' getIC,matrix,matrix-method
setMethod("getIC", signature(x="pfm"), function(x, p="missing"){
    colSums(x@mat * (addPseudolog2(x@mat) - addPseudolog2(x@background)))
})
## get information content profile from matrix
setMethod("getIC", signature(x="matrix", p="numeric"), function(x, p){
    if (any(abs(1 - apply(x, 2, sum)) > 0.01)) re<-"Columns of PFM must add up to 1.0"
    colSums(x * (addPseudolog2(x) - addPseudolog2(p)))
})
setMethod("getIC", signature(x="matrix", p="matrix"), function(x, p){
    if (any(abs(1 - apply(x, 2, sum)) > 0.01)) re<-"Columns of PFM must add up to 1.0"
    colSums(x * (addPseudolog2(x) - addPseudolog2(p)))
})

#' @rdname pfm-class
#' @exportMethod trimMotif
#' @aliases trimMotif,pfm,numeric-method
setMethod("trimMotif", signature(x="pfm", t="numeric"), function(x, t){
    .sw <- c(0, 0)
    ic <- getIC(x)
    for(i in 1:ncol(x@mat)){
        if(ic[i]>=t){
            .flag <- FALSE
            if(i<ncol(x@mat)){
                if(ic[i+1]>=t) .flag<-TRUE
                else if(ic[i]>=min(2*t, 0.5)) .flag<-TRUE
            }else{
                .flag<-TRUE
            }
            if(.flag){
                if(.sw[1]==0) .sw[1] <- i
                else .sw[2] <- i
            }
        }
    }
    if(.sw[1]<.sw[2]-1) x@mat <- x@mat[, .sw[1]:.sw[2]]
    else x <- NA
    x
})

#' @rdname pfm-class
#' @exportMethod matrixReverseComplement
#' @aliases matrixReverseComplement,pfm-method
setMethod("matrixReverseComplement", "pfm", function(x){
    if(x@alphabet!="DNA") stop("alphabet of pfm must be DNA")
    mat<-x@mat
    ## double check the rownames to A, C, G, T.
    if(!all(toupper(rownames(mat))==c("A", "C", "G", "T"))){
      mat <- mat[match(c("A", "C", "G", "T"), toupper(rownames(mat))), ]
    }
    rc<-matrix(nrow=nrow(mat),ncol=ncol(mat))
    complements<-c(4,3,2,1)
    for(i in 1:nrow(mat)){
        for(j in 1:ncol(mat)){
            rc[complements[i],(ncol(mat)+1-j)]<-mat[i,j]
        }
    }
    rownames(rc)<-rownames(mat)
    x@mat<-rc
    x
})

#' @rdname pfm-class
#' @exportMethod addBlank
#' @aliases addBlank,pfm,numeric,logical-method
setMethod("addBlank", signature(x="pfm", n="numeric", b="logical"), function(x, n, b){
    #if(x@alphabet!="DNA") stop("alphabet of pfm must be DNA")
    N<-matrix(rep(x@background[rownames(x@mat)], n), nrow=nrow(x@mat))
    if(b){
        N<-cbind(x@mat,N)
    }else{
        N<-cbind(N,x@mat)
        if(length(x@markers)>0){
          x@markers <- lapply(x@markers, function(.ele){
            .ele@start <- .ele@start+n
            .ele@stop <- .ele@stop+n
            .ele
          })
        }
    }
    rownames(N)<-rownames(x@mat)
    x@mat<-N
    x
})

## for data.frame
#' @rdname pfm-class
#' @exportMethod as.data.frame
#' @aliases as.data.frame,pfm-method
setMethod("as.data.frame", signature(x="pfm"), function(x, row.names = NULL, optional = FALSE, ...){
  as.data.frame(x@mat, ...)
})

#' @rdname pfm-class
#' @exportMethod format
#' @aliases format,pfm-method
setMethod("format", signature(x="pfm"), function(x, ...){
  paste0(x@name, "_pfm")
})

#' re-order UPGMA tree
#' 
#' re-order the UPGMA tree by adjacent motif distance
#' 
#' 
#' @param phylog an object of phylog
#' @param motifs a list of objects of pfm
#' @param rcpostfix the postfix for reverse complements
#' @return an object of phylog
#' @author Jianhong Ou
#' @keywords misc
#' @export
#' @examples
#' 
#'   if(interactive() || Sys.getenv("USER")=="jianhongou"){
#'     library("MotifDb")
#'     matrix.fly <- query(MotifDb, "Dmelanogaster")
#'     motifs <- as.list(matrix.fly)
#'     motifs <- motifs[grepl("Dmelanogaster-FlyFactorSurvey-", names(motifs), fixed=TRUE)]
#'     names(motifs) <- gsub("Dmelanogaster_FlyFactorSurvey_", "", 
#'                 gsub("_FBgn[0-9]+$", "", 
#'                   gsub("[^a-zA-Z0-9]","_", 
#'                      gsub("(_[0-9]+)+$", "", names(motifs)))))
#'     motifs <- motifs[unique(names(motifs))]
#'     pfms <- sample(motifs, 50)
#'     hc <- clusterMotifs(pfms)
#'     library(ade4)
#'     phylog <- ade4::hclust2phylog(hc)
#'     pfms <- mapply(pfms, names(pfms), FUN=function(.ele, .name){
#'                  new("pfm",mat=.ele, name=.name)})
#'     reorderUPGMAtree(phylog, pfms)
#'   }
#' 
reorderUPGMAtree <- function(phylog, motifs, rcpostfix = "(RC)"){
    if(!inherits(phylog, "phylog")) stop("phylog must be an object of phylog")
    if(!all(sapply(motifs, function(.ele) inherits(.ele, c("pfm", "pcm")))))
        stop("motifs must be a list of pfm or pcm object")
    lnames <- sapply(motifs, function(.ele) .ele$name)
    for(metaChar in c("\\","$","*","+",".","?","[","]","^","{","}","|","(",")"))
    {
        rcpostfix <- gsub(metaChar,paste("\\",metaChar,sep=""),rcpostfix,fixed=TRUE)
    }
    lnames <- gsub(paste(rcpostfix,"$",sep=""),"",lnames)
    if(!all(names(phylog$leaves) %in% lnames)){
        stop("not all leaves have corresponding motif")
    }
    names(motifs) <- lnames
    motifs <- motifs[names(phylog$leaves)]
    d <- matalign(motifs)
    d <- matalignOut2dist(d)
    motifs <- lapply(motifs, function(.ele){
        if(is(.ele, "pcm")) .ele <- pcm2pfm(.ele)
        .ele
    })
    
    paths <- phylog$paths
    par <- sapply(paths, function(.ele) .ele[length(.ele)-1])
    
    pars <- split(names(par), factor(par, levels=unique(par)))
    
    
    buildTree <- function(pars, ln, rn){
        re <- list()
        re[[ln]] <- if(is.null(pars[[ln]])) ln else pars[[ln]]
        re[[rn]] <- if(is.null(pars[[rn]])) rn else pars[[rn]]
        if(length(unlist(pars[re[[ln]]]))>0){
            re[[ln]] <- buildTree(pars, re[[ln]][1], re[[ln]][2])
        }
        if(length(unlist(pars[re[[rn]]]))>0){
            re[[rn]] <- buildTree(pars, re[[rn]][1], re[[rn]][2])
        }
        
        return(re)
    }
    
    shortestDist <- function(mat){
        d <- dim(mat)
        id <- which(mat==min(mat))[1]
        j <- ceiling(id/d[1])
        i <- id %% d[1]
        if(i==0) i <- d[1]
        paste(i, j, sep="")
    }
    
    sortTree <- function(tree){
        child1 <- tree[[1]]
        child2 <- tree[[2]]
        if(is.list(child1)){
            child1 <- sortTree(child1)
        }
        if(is.list(child2)){
            child2 <- sortTree(child2)
        }
        child1.flat <- unlist(child1)
        len1 <- length(child1.flat)
        child2.flat <- unlist(child2)
        len2 <- length(child2.flat)
        
        dist <- d[child1.flat[c(1, len1)], child2.flat[c(1, len2)], drop=FALSE]
        neighbor <- shortestDist(dist)
        leaves <- switch(neighbor,
                         "11"=c(rev(child1.flat), child2.flat),
                         "12"=c(child2.flat, child1.flat),
                         "21"=c(child1.flat, child2.flat),
                         "22"=c(child1.flat, rev(child2.flat)),
                         c(child1.flat, child2.flat))
    }
    
    tre <- pars[["Root"]]
    if(length(tre)==0){
        return(phylog)
    }
    tre <- buildTree(pars, tre[1], tre[2])
    phylog$leaves <- phylog$leaves[sortTree(tre)]
    phylog
}

#' align DNA motifs
#' 
#' align DNA motifs for plotting motifs stack
#' 
#' 
#' @param pfms a list of position frequency matrices, pfms must be a list of
#' class pfm or psam
#' @param threshold information content cutoff threshold for useful postions
#' @param minimalConsensus minimal length of consensus for alignment
#' @param rcpostfix the postfix for reverse complements
#' @param revcomp a logical vector to indicates whether the reverse complemet
#' should be involved into alignment
#' @return a list of aligned motifs
#' @export
#' @examples
#' 
#' pcms<-readPCM(file.path(find.package("motifStack"), "extdata"),"pcm$")
#' motifs<-lapply(pcms,pcm2pfm)
#' motifs<-DNAmotifAlignment(motifs)
#' 
DNAmotifAlignment<-function(pfms, threshold=0.4, minimalConsensus=0, 
                            rcpostfix="(RC)", 
                            revcomp=rep(TRUE, length(pfms))){
  if(length(pfms)<2) stop("less than 2 motifs")
  if(length(revcomp)!=length(pfms)){
    if(length(revcomp)>1) message("length of revcomp and pfms is not identical")
    revcomp <- rep(revcomp, length(pfms))[seq_along(pfms)]
  }
  if(all(sapply(pfms, function(.ele) is(.ele, "psam")))){
    return(alignmentByPCC(pfms, minimalConsensus, rcpostfix, revcomp))
  }
  lapply(pfms,function(.ele){
    if(!inherits(.ele, c("pfm", "pcm"))) {
      stop("pfms must be a list of pfm objects.")
    }
    if(!.ele@alphabet %in% c("DNA", 'RNA')) {
      stop("the alphabet of pfm must be DNA or RNA")
    }
  })
  alphab <- vapply(pfms, function(.ele) .ele@alphabet=="RNA", FUN.VALUE = TRUE)
  if(any(alphab & revcomp)){
    message("The input is RNA motif. 
            The reverse complementation alignment will be turn off.
            To avoid this message, please set revcomp=rep(FALSE, length(pfms))")
    revcomp[alphab] <- FALSE
  }
  pfmcopy<-list(length=length(pfms))
  pfmcopy[[1]]<-pfms[[1]]
  for(i in 2:length(pfms)){
    pfmcopy[[i]]<-pfms[[i]]
    pfmcopy<-UngappedAlignment(pfmcopy, i, threshold, 
                               minimalConsensus, rcpostfix, revcomp[i])
  }
  l<-unlist(lapply(pfmcopy,function(.ele) ncol(.ele@mat)))
  l<-max(l)-l
  for(i in 1:length(pfmcopy)){
    pfmcopy[[i]]<-addBlank(pfmcopy[[i]],l[i],TRUE)
  }
  pfmcopy
}

#' plot sequence logos stack
#' 
#' plot sequence logos stack
#' 
#' 
#' @param pfms a list of position frequency matrices, pfms must be a list of
#' class pfm
#' @param ... other parameters can be passed to plotMotifLogo function
#' @return none
#' @export
#' @importFrom grid grid.newpage pushViewport viewport convertUnit unit
#' grid.text popViewport
#' @examples
#' 
#'   pcm1<-matrix(c(0,50,0,50,
#'            100,0,0,0,
#'            0,100,0,0,
#'            0,0,100,0,
#'            0,0,0,100,
#'            50,50,0,0,
#'            0,0,50,50), nrow=4)
#'   pcm2<-matrix(c(50,50,0,0,
#'            0,100,0,0,
#'            0,50,50,0,
#'            0,0,0,100,
#'            50,50,0,0,
#'            0,0,50,50), nrow=4)
#'   rownames(pcm1)<-c("A","C","G","T")
#'   rownames(pcm2)<-c("A","C","G","T")
#'   pfms<-list(p1=new("pfm",mat=pcm2pfm(pcm1),name="m1"),
#'          p2=new("pfm",mat=pcm2pfm(pcm2),name="m2"))
#'   pfms<-DNAmotifAlignment(pfms)
#'   plotMotifLogoStack(pfms)
#' 
plotMotifLogoStack<-function(pfms, ...){
  n<-length(pfms)
  dots <- list(...)
  if(is.null(dots$draw)) dots$draw <- TRUE
  if(is.null(dots$newpage)) dots$newpage <- TRUE
  if(all(sapply(pfms, function(.ele) is(.ele, "psam")))){
    .local <- function(..., newpage, draw){
      plotAffinityLogo(..., newpage = FALSE, draw = FALSE)
    }
    plot <- gList()
    ht <- 1/n
    y0 <- .5 * ht
    for(i in seq.int(n)){
      ht.title <- convertUnit(unit(1.5, "lines"), unitTo = "npc", valueOnly = TRUE)
      ht.body <- 1 - ht.title
      plotsub <- gTree(children = .local(psam=pfms[[i]], ...), 
                       vp = viewport(y=ht.body*.5, height=ht.body))
      plot <- gList(plot, 
                    gTree(children = gList(textGrob(label=pfms[[i]]@name,
                                                     y=1-.5*ht.title),
                                           plotsub),
                          vp = viewport(y=y0, height=ht)))
      y0 <- y0 + ht
    }
    if(dots$draw){
      if(dots$newpage) grid.newpage()
      suppressWarnings(grid.draw(plot))
    }else{
      return(plot)
    }
    return()
  }
  if(all(sapply(pfms, function(.ele) is(.ele, "pcm")))) {
    pfms <- lapply(pfms, pcm2pfm)
  }
  lapply(pfms,function(.ele){
    if(!is(.ele, "pfm")) stop("pfms must be a list of pfm objects.")
  })
  assign("tmp_motifStack_symbolsCache", list(), envir=.globals)
  .local <- function(..., newpage, draw){
    plotMotifLogo(..., newpage = FALSE, draw = FALSE)
  }
  plot <- gList()
  ht <- 1/n
  y0 <- .5 * ht
  for(i in seq.int(n)){
    plot <- 
      gList(plot, gTree(children=
                          .local(pfm=pfms[[i]], motifName=pfms[[i]]@name, 
                                 p=pfms[[i]]@background,
                                 colset = pfms[[i]]@color,
                                 xlab=NA, newpage=FALSE,
                                 margins=c(1.5, 4.1, 1.1, .1), ...),
                        vp= viewport(y=y0, height=ht)))
    y0 <- y0 + ht
  }
  rm(list="tmp_motifStack_symbolsCache", envir=.globals)
  if(dots$draw){
    if(dots$newpage) grid.newpage()
    suppressWarnings(grid.draw(plot))
  }else{
    plot
  }
}

#' browse motifs
#' 
#' browse motifs in a web browser
#' 
#' 
#' @param pfms a list of \link{pfm}
#' @param phylog layout type. see \link[Rgraphviz]{GraphvizLayouts}
#' @param layout layout type. Could be tree, cluster or radialPhylog.
#' @param nodeRadius node radius, default 2.5px.
#' @param baseWidth,baseHeight width and height of each alphabet of the motif
#' logo.
#' @param xaxis,yaxis plot x-axis or y-axis or not in the motifs.
#' @param width width of the figure
#' @param height height of the figure
#' @param ... parameters not used
#' @return An object of class htmlwidget that will intelligently print itself
#' into HTML in a variety of contexts including the R console, within R
#' Markdown documents, and within Shiny output bindings.
#' @keywords plot
#' @export
#' @importFrom ade4 hclust2phylog
#' @importFrom htmlwidgets createWidget
#' @examples
#' 
#' if(interactive() || Sys.getenv("USER")=="jianhongou"){
#'  library("MotifDb")
#'  matrix.fly <- query(MotifDb, "Dmelanogaster")
#'  motifs <- as.list(matrix.fly)
#'  motifs <- motifs[grepl("Dmelanogaster-FlyFactorSurvey-", 
#'                         names(motifs), fixed=TRUE)]
#'  names(motifs) <- gsub("Dmelanogaster_FlyFactorSurvey_", "", 
#'                       gsub("_FBgn[0-9]+$", "", 
#'                            gsub("[^a-zA-Z0-9]","_", 
#'                                 gsub("(_[0-9]+)+$", "", names(motifs)))))
#'  motifs <- motifs[unique(names(motifs))]
#'  pfms <- sample(motifs, 10)
#'  pfms <- mapply(pfms, names(pfms), FUN=function(.ele, .name){
#'                   new("pfm",mat=.ele, name=.name)})
#'  browseMotifs(pfms)
#' }
#' 
browseMotifs <- function(pfms, phylog,
                      layout=c("tree", "cluster", "radialPhylog"),
                      nodeRadius=2.5, baseWidth=12, baseHeight=30,
                      xaxis=TRUE, yaxis=TRUE,
                      width=NULL, height=NULL,
                      ...){
  if(!is.list(pfms)){
    pfms <- list(pfms)
  }
  layout <- match.arg(layout)
  if(all(sapply(pfms, function(.ele) is(.ele, "pcm")))) {
    pfms <- lapply(pfms, pcm2pfm)
  }
  if (any(unlist(lapply(pfms, function(.ele) !is(.ele, "pfm"))))) 
    stop("pfms must be a list of pfm objects")
  maxW <- 0
  if(length(pfms)<=2){
    elements <- lapply(pfms, function(pfm){
      w <- (ncol(pfm$mat)+1)*baseWidth
      if(w > maxW) maxW <<- w
      list(name="Root",
           motif=list(t(pfm$mat)),
           letters=rownames(pfm$mat),
           color=as.list(pfm$color),
           background=as.list(pfm$background),
           width=w,
           height=baseHeight,
           xaxis=xaxis,
           yaxis=yaxis)
    })
    names(elements) <- NULL
  }else{
    if(missing(phylog)){
      hc <- clusterMotifs(pfms)
      pfms <- pfms[hc$order]
      #pfms <- DNAmotifAlignment(pfms)
      phylog <- hclust2phylog(hc)
    }
    stopifnot(inherits(phylog, "phylog"))
    names(pfms) <- names(phylog$leaves)
    ## list to recursive list
    flatListToRecursiveList <- function(flatList, nodeName="Root"){
      if(nodeName %in% names(flatList)){## nodes
        out <- lapply(flatList[[nodeName]], 
                      flatListToRecursiveList, 
                      flatList=flatList)
        names(out) <- NULL
        ele <- list(name=nodeName, children=out)
      }else{## leaves
        pfm <- pfms[[nodeName]]
        w <- (ncol(pfm$mat)+1)*baseWidth
        if(w > maxW) maxW <<- w
        ele <- list(name=nodeName,
                    motif=list(t(pfm$mat)),
                    letters=rownames(pfm$mat),
                    color=as.list(pfm$color),
                    background=as.list(pfm$background),
                    width=w,
                    height=baseHeight,
                    xaxis=xaxis,
                    yaxis=yaxis)
      }
      return(ele)
    }
    elements <- flatListToRecursiveList(phylog$parts)
  }
  
  x <- list(
    elements = elements,
    nodeRadius = nodeRadius,
    maxH = baseHeight,
    maxW = maxW,
    layout = layout
  )
  
  htmlwidgets::createWidget(
    name = 'browseMotifs',
    x = x,
    width = width,
    height = height,
    package = getPackageName()
  )
}

#' Shiny bindings for browseMotifs
#'
#' Output and render functions for using browseMotifs within Shiny
#' applications and interactive Rmd documents.
#'
#' @param outputId output variable to read from
#' @param width,height Must be a valid CSS unit (like \code{'100\%'},
#'   \code{'400px'}, \code{'auto'}) or a number, which will be coerced to a
#'   string and have \code{'px'} appended.
#' @param expr An expression that generates a browseMotifs
#' @param env The environment in which to evaluate \code{expr}.
#' @param quoted Is \code{expr} a quoted expression (with \code{quote()})? This
#'   is useful if you want to save an expression in a variable.
#'
#' @name browseMotifs-shiny
#'
#' @export
#' @importFrom htmlwidgets shinyWidgetOutput
browseMotifsOutput <- function(outputId, width = '100%', height = '400px'){
  htmlwidgets::shinyWidgetOutput(outputId, 'browseMotifs', width, height, 
                                 package = 'motifStack')
}

#' @rdname browseMotifs-shiny
#' @export
#' @importFrom htmlwidgets shinyRenderWidget
renderbrowseMotifs <- function(expr, env = parent.frame(), quoted = FALSE) {
  if (!quoted) { expr <- substitute(expr) } # force quoted
  htmlwidgets::shinyRenderWidget(expr, browseMotifsOutput, env, quoted = TRUE)
}

#' get signatures from motifs
#' 
#' extract signatures from multiple motifs by distance calculated from STAMP
#' 
#' 
#' @param pfms a list of objects of class pfm
#' @param phylog an object of class phylog
#' @param cutoffPval pvalue for motifs to merge.
#' @param groupDistance maxmal distance of motifs in the same group
#' @param rcpostfix postfix for reverse-complement motif names, default: (RC)
#' @param min.freq signatures with frequency below min.freq will not be plotted
#' @param trim minimal information content for each position of signature
#' @param families for each family, the motif number in one signature should
#' only count as 1
#' @param sort sort the signatures by frequency or not.
#' @return an Object of class \linkS4class{motifSig}
#' @export
#' @examples
#' 
#'   if(interactive() || Sys.getenv("USER")=="jianhongou"){
#'     library("MotifDb")
#'     matrix.fly <- query(MotifDb, "Dmelanogaster")
#'     motifs <- as.list(matrix.fly)
#'     motifs <- motifs[grepl("Dmelanogaster-FlyFactorSurvey-", 
#'                             names(motifs), fixed=TRUE)]
#'     names(motifs) <- gsub("Dmelanogaster_FlyFactorSurvey_", "", 
#'                 gsub("_FBgn[0-9]+$", "", 
#'                   gsub("[^a-zA-Z0-9]","_", 
#'                      gsub("(_[0-9]+)+$", "", names(motifs)))))
#'     motifs <- motifs[unique(names(motifs))]
#'     pfms <- sample(motifs, 50)
#'     hc <- clusterMotifs(pfms)
#'     library(ade4)
#'     phylog <- ade4::hclust2phylog(hc)
#'     leaves <- names(phylog$leaves)
#'     pfms <- pfms[leaves]
#'     pfms <- mapply(pfms, names(pfms), FUN=function(.ele, .name){
#'                  new("pfm",mat=.ele, name=.name)})
#'     motifSig <- motifSignature(pfms, phylog, cutoffPval=0.0001)
#'   }
#' 
motifSignature <- function(pfms, phylog, cutoffPval, groupDistance, rcpostfix="(RC)", 
                           min.freq=2, trim=0.2, families=list(), sort=TRUE){
  if (!inherits(phylog, "phylog")) 
    stop("phylog should be an object of phylog of package ade4")
  leaves.number <- length(phylog$leaves)
  if (length(pfms)!=leaves.number)
    stop("length of pfms and leaves of phylog should be identical.")
  if (all(unlist(lapply(pfms, function(.ele) !inherits(.ele, "pfm"))))){
    pfms.class="pcm"
    if(any(unlist(lapply(pfms, function(.ele) !inherits(.ele, "pcm")))))
      stop("pfms should be a list of objects of pfm or pcm")
  }else{
    pfms.class="pfm"
    if(any(unlist(lapply(pfms, function(.ele) !inherits(.ele, "pfm")))))
      stop("pfms should be a list of objects of pfm or pcm")
  }
  if(missing(groupDistance) && missing(cutoffPval)){
    stop("cutoffPval and groupDistance are missing. Please assign at least one of them.")
  }
  if (missing(groupDistance))
    groupDistance <- max(phylog$droot)
  if (missing(cutoffPval))
    cutoffPval <- 1
  
  getSignature <- function(pfms, pfmnames, rcpostfix, pfms.class){
    .pfmnames <- unlist(strsplit(pfmnames, ";"))
    .pfms <- lapply(.pfmnames, function(.name, pfms) {
      pfms[[getPFMid(pfms, .name, rcpostfix=rcpostfix)]]
      }, pfms)
    if(length(.pfms)>1){
      .pfms <- DNAmotifAlignment(.pfms, rcpostfix="")
      .rown <- rownames(.pfms[[1]]@mat)
      .mats <- lapply(.rown, function(i, .pfms){
        do.call(rbind,lapply(.pfms, function(.ele, i) 
          .ele@mat[i, , drop=FALSE], i))
      }, .pfms)
      if(pfms.class=="pfms"){
        .mats <- do.call(rbind, lapply(.mats, colMeans))
      }
      else{
        .mats <- do.call(rbind, lapply(.mats, colSums))
        .mats <- pcm2pfm(.mats)
      }
      rownames(.mats) <- .rown
      colnames(.mats) <- 1:ncol(.mats)
    }else{
      if(pfms.class=="pfms") .mats <- .pfms[[1]]@mat
      else .mats <- pcm2pfm(.pfms[[1]]@mat)
    }
    new("pfm", mat=.mats, name=pfmnames, alphabet=.pfms[[1]]@alphabet,
        color=.pfms[[1]]@color, background=.pfms[[1]]@background)
  }
  
  if(groupDistance >= max(phylog$droot) && cutoffPval>=1){
    signatures <- list(getSignature(pfms, names(phylog$leaves), 
                                    rcpostfix, pfms.class=pfms.class))
    signatures <- lapply(signatures, trimMotif, trim)
    nodelist <- list(Root=new("ouNode", 
                              left=paste(names(phylog$leaves),sep=";"), 
                              parent="Root", distl=max(phylog$droot), 
                              sizel=length(pfms), sizer=0))
    return(new("motifSig", signatures=signatures, 
               freq=length(pfms), 
               nodelist=nodelist, 
               gpcol=rep("gray30", length(pfms))))
  }
  #generate the new phylog from newick tree
  tree <- phylog$tre
  droot <- phylog$droot
  tree <- gsub(";$","",tree)
  str <- unlist(strsplit(gsub("^\\((.*?)\\)([^\\)\\(;,]+)$",
                              "\\1///\\2",tree),"///",fixed=TRUE))[1]
  nodelist <- list()
  getNodelist <- function(str, nodelist=list(), pid=0){
    ge <- gregexpr("\\(([^\\(\\),]+),([^\\(\\),]+)\\)([^\\(\\),]+)", str)
    if(ge[[1]][1]!=-1){## (A,B)C
      start <- ge[[1]]
      stop <- attr(ge[[1]],"match.length")
      trec<-c()
      for(i in 1:length(start)){
        trec<- c(trec,substr(str, start[i],start[i]+stop[i]-1))
      }
      nodes <- do.call(rbind,strsplit(trec,"\\)|\\(|,"))[,2:4,drop=FALSE]
      newnodes <- apply(nodes, 1, function(.ele) 
        new("ouNode",left=.ele[1], right=.ele[2], 
            parent=.ele[3], sizel=0, sizer=0))
      names(newnodes) <- nodes[,3]
      nodelist <- c(newnodes,nodelist)
      for(i in 1:length(trec)){
        str<-gsub(trec[i],gsub(".*?\\)(.*?)$","\\1",trec[i]),str,fixed=TRUE)
      }
      Recall(str=str, nodelist=nodelist, pid=pid)
    }else{
      ge <- gregexpr("\\((([^\\(\\),]+,){2,})([^\\(\\),]+)\\)([^\\(\\),]+)", 
                     str)
      if(ge[[1]][1]!=-1){ ##(A,B,C,...)N
        start <- ge[[1]]
        stop <- attr(ge[[1]],"match.length")
        trec<-c()
        for(i in 1:length(start)){
          trec<- c(trec,substr(str, start[i],start[i]+stop[i]-1))
        }
        for(i in 1:length(trec)){
          nodes <- strsplit(trec[i], "\\)|\\(|,")[[1]][-1]
          pnodes <- nodes[length(nodes)]
          nodes <- nodes[-length(nodes)]
          curNode <- nodes[length(nodes)]
          for(j in (length(nodes)-1):2){
            parNode <- paste("MSP", pid, sep="")
            newnodes <- new("ouNode", left=nodes[i], right=curNode,
                            parent=parNode, distl=0, distr=0,
                            sizel=0, sizer=0)
            curNode <- parNode
            pid <- pid + 1
            nodelist <- c(newnodes, nodelist)
            names(nodelist)[1] <- parNode
          }
          newnodes <- new("ouNode", left=nodes[1], right=curNode, 
                          parent=pnodes, sizel=0, sizer=0)
          nodelist <- c(newnodes, nodelist)
          names(nodelist)[1] <- pnodes
          str<-gsub(trec[i],gsub(".*?\\)(.*?)$","\\1",trec[i]),str,fixed=TRUE)
        }
        Recall(str=str, nodelist=nodelist, pid=pid)
      }else{ ##to Root one
        nodes <- unlist(strsplit(str, ","))
        if(length(nodes)>2){
          curNode <- nodes[length(nodes)]
          for(i in (length(nodes)-1):2){
            parNode <- paste("MSP", pid, sep="")
            newnodes <- new("ouNode", left=nodes[i], right=curNode,
                            parent=parNode, distl=0, distr=0, sizel=0, sizer=0)
            curNode <- parNode
            pid <- pid + 1
            nodelist <- c(newnodes, nodelist)
            names(nodelist)[1] <- parNode
          }
          Root <- new("ouNode", left=nodes[1], right=curNode, 
                      parent="Root", sizel=0, sizer=0)
          nodelist <- c(Root=Root, nodelist)
          return(nodelist)
        }else{
          Root <- new("ouNode", left=nodes[1], right=nodes[2], 
                      parent="Root", sizel=0, sizer=0)
          nodelist <- c(Root=Root, nodelist)
          return(nodelist)
        }
      }
    }
  }
  nodelist <- getNodelist(str)
  leaves <- names(phylog$leaves)
  buildTree <- function(nodelist, nodename, droot, dpar=0){
    nodelist[[nodename]]@distl <<- droot[nodelist[[nodename]]@left] - dpar
    nodelist[[nodename]]@distr <<- droot[nodelist[[nodename]]@right] - dpar
    if(nodelist[[nodename]]@left %in% leaves) nodelist[[nodename]]@sizel <<- 1
    if(nodelist[[nodename]]@right %in% leaves) nodelist[[nodename]]@sizer <<- 1
    if(!is.null(nodelist[[nodelist[[nodename]]@left]])){
      buildTree(nodelist, nodelist[[nodename]]@left, droot, 
                droot[nodelist[[nodename]]@left])
    }
    if(!is.null(nodelist[[nodelist[[nodename]]@right]])){
      buildTree(nodelist, nodelist[[nodename]]@right, droot,
                droot[nodelist[[nodename]]@right])
    }
  }
  buildTree(nodelist, "Root", droot, dpar=0)
  
  mergeNodes <- function(nodelist, leaves, cutoffPval, groupDistance){
    l <- length(nodelist)
    for(i in 1:l){
      nodename <- names(nodelist)[i]
      currNode <- nodelist[[nodename]]
      if(currNode@left %in% leaves && currNode@right %in% leaves){
        if(cutoffPval!=1){
          pval <- 
            matalign(list(left=getSignature(pfms, currNode@left,
                                             rcpostfix, pfms.class=pfms.class),
                          right=getSignature(pfms, currNode@right,
                                       rcpostfix, pfms.class=pfms.class)))$P_value[1] 
        } 
        else pval <- 0
        if(currNode@distl < groupDistance && currNode@distr < groupDistance &&
           pval < cutoffPval){
          parNodeInfo <- getParentNode(nodelist, nodename)
          if(!is.null(parNodeInfo)[1]){
            if(parNodeInfo[2]=="left") {
              nodelist[[parNodeInfo[1]]]@sizel <- 
                nodelist[[parNodeInfo[1]]]@sizel + max(currNode@sizel, 1) +
                max(currNode@sizer, 1)
              nodelist[[parNodeInfo[1]]]@distl <- 
                nodelist[[parNodeInfo[1]]]@distl + 
                (currNode@distl + currNode@distr)/2
              nodelist[[parNodeInfo[1]]]@left <- 
                paste(currNode@left, currNode@right, sep=";")
              leaves <- c(leaves[!leaves %in% c(currNode@left,
                                                currNode@right)], 
                          paste(currNode@left, currNode@right, sep=";"))
              nodelist[[nodename]] <- new("ouNode",left="NULL", right="NULL", 
                                          parent="NULL", sizel=0, sizer=0)
            }
            else if(parNodeInfo[2]=="right") {
              nodelist[[parNodeInfo[1]]]@sizer <- 
                nodelist[[parNodeInfo[1]]]@sizer + max(currNode@sizel, 1) + 
                max(currNode@sizer, 1)
              nodelist[[parNodeInfo[1]]]@distr <- 
                nodelist[[parNodeInfo[1]]]@distr + 
                (currNode@distl + currNode@distr)/2
              nodelist[[parNodeInfo[1]]]@right <- 
                paste(currNode@left, currNode@right, sep=";")
              leaves <- c(leaves[!leaves %in% 
                                   c(currNode@left, currNode@right)], 
                          paste(currNode@left, currNode@right, sep=";"))
              nodelist[[nodename]] <- 
                new("ouNode",left="NULL", right="NULL",
                    parent="NULL", sizel=0, sizer=0)
            }
          }
        }
      }
    }
    sel <- unlist(lapply(nodelist, function(.ele) .ele@parent=="NULL"))
    nodelist <- nodelist[!sel]
    nodelist <<- nodelist
    leaves <<- leaves
    if(length(nodelist)<l) mergeNodes(nodelist, leaves, cutoffPval, groupDistance)
  }
  
  mergeNodes(nodelist, leaves, cutoffPval, groupDistance)
  #get signatures and frequences (count of frequences should > min.freq)
  filterFamilies <- function(pfmnames, size, families){
    if(length(families)>0){
      pfmnames <- unlist(strsplit(pfmnames, ";"))
      if(length(pfmnames)!=size) stop("pfm names contain ';'")
      for(j in 1:length(families)){
        inters <- intersect(families[[j]], pfmnames)
        if(length(inters)>1){
          pfmnames <- pfmnames[!pfmnames %in% inters[2:length(inters)]]
        }
      }
      size <- length(pfmnames)
      pfmnames <- paste(pfmnames, sep="", collapse=";")
    }
    list(name=pfmnames,size=size)
  }
  signatures <- list()
  freq <- c()
  for(i in 1:length(nodelist)){
    if(nodelist[[i]]@sizel>=min.freq){
      ftmp <- filterFamilies(nodelist[[i]]@left, nodelist[[i]]@sizel, families)
      nodelist[[i]]@left <- ftmp[["name"]]
      nodelist[[i]]@sizel <- ftmp[["size"]]
      if(ftmp[["size"]]>=min.freq){
        signatures <- 
          c(signatures, getSignature(pfms, nodelist[[i]]@left,
                                     rcpostfix, pfms.class=pfms.class))
        freq <- c(freq, nodelist[[i]]@sizel)
      }
    }
    if(nodelist[[i]]@sizer>=min.freq){
      ftmp <- filterFamilies(nodelist[[i]]@right, nodelist[[i]]@sizer, families)
      nodelist[[i]]@right <- ftmp[["name"]]
      nodelist[[i]]@sizer <- ftmp[["size"]]
      if(ftmp[["size"]]>=min.freq){
        signatures <- c(signatures, 
                        getSignature(pfms, nodelist[[i]]@right,
                                     rcpostfix, pfms.class=pfms.class))
        freq <- c(freq, nodelist[[i]]@sizer)
      }
    }
  }
  
  #trime signatures
  signatures <- lapply(signatures, trimMotif, trim)
  ord <- unlist(lapply(signatures, function(.ele){inherits(.ele,"pfm")}))
  signatures <- signatures[ord]
  freq <- freq[ord]
  #sort signatures
  if(sort){
    ord <- order(freq, decreasing=TRUE)
    signatures <- signatures[ord]
    freq <- freq[ord]
  }
  if(length(freq)==0){
    if(interactive()) warning("All frequency are smaller than min.freq.")
    return(FALSE)
  }
  
  getGpCol <- function(sig, phylog){
    pfmNames <- lapply(sig, function(.ele){unlist(strsplit(.ele@name, ";"))})
    pfmNames <- mapply(function(.ele, .name){cbind(.ele, .name)},
                       pfmNames, paste("gps", 1:length(pfmNames), sep=""),
                       SIMPLIFY=FALSE)
    pfmNames <- do.call(rbind, pfmNames)
    pfmNames <- pfmNames[match(names(phylog$leaves), pfmNames[,1]),]
    bd.color <- c("gray80","gray30")
    in.color <- rle(pfmNames[,2])
    in.color$values <- bd.color[rep(1:2, 
                                    length(in.color$lengths))[
                                      seq_along(in.color$lengths)]]
    return(inverse.rle(in.color))
  }
  gpcol <- getGpCol(signatures, phylog)
  
  return(new("motifSig", signatures=signatures, freq=freq, 
             nodelist=nodelist, gpcol=gpcol))
}

#' Matrix Aligner
#' @description Matrix Aligner is modified from Matalign-v4a.
#' Matalign-v4a is a program to compare two positional specific matrices.
#' The author of Matalign-v4a is Ting Wang and Gary Stormo.
#' @param pcms A list of \link{pcm}
#' @param method Alignment method. "Smith-Waterman" or "Needleman-Wunsch".
#' Default is "Smith-Waterma"
#' @param pseudo pseudocount
#' @param revcomp Check reverseComplement or not.
#' @param ... Not use.
#' @return A data frame with alignment information. The column names
#' are motif1, motif2, alignmentScore, startPos1, startPos2, endPos1, endPos2,
#' alignmentLength.
#' @export
#' @importFrom utils combn
#' @examples 
#' if(interactive() || Sys.getenv("USER")=="jianhongou"){
#'   fp <- system.file("extdata", package="motifStack")
#'   fs <- dir(fp, "pcm$")
#'   pcms <- importMatrix(file.path(fp, fs), format="pcm")
#'   matalign(pcms)
#'  }
matalign <- function(pcms, 
                     method=c("Smith-Waterman", "Needleman-Wunsch"),
                     pseudo=1,
                     revcomp=TRUE,
                     ...){
  method <- match.arg(method, 
                      choices = c("Smith-Waterman", "Needleman-Wunsch"))
  stopifnot(is.numeric(pseudo))
  stopifnot(is.list(pcms))
  stopifnot(is.logical(revcomp))
  if(length(revcomp)>1){
    message('only the first revcomp will be used.')
    revcomp <- revcomp[1]
  }
  if(length(names(pcms))!=length(pcms)) 
    names(pcms) <- paste0("M", seq_along(pcms))
  pcms <- mapply(pcms, names(pcms), FUN=function(.ele, .name){
    if(is(.ele, "pcm")){
      return(.ele)
    }
    if(is(.ele, "pfm")){
      return(pfm2pcm(.ele))
    }
    if(is(.ele, "matrix") || is(.ele, "data.frame")){
      cols <- colSums(.ele)
      if(all(abs(1 - cols) < 0.01)){
        .ele <- new("pfm", name=.name, mat=.ele)
        return(pfm2pcm(.ele))
      }
      if(all(cols>=1) && all(cols==round(cols))){
        return(new("pcm", name=.name, mat=.ele))
      }
    }
    stop("motifs must be pcms")
  }, SIMPLIFY = FALSE)
  stopifnot("pcms must be a list of pcm object" = is.list(pcms))
  null <- lapply(pcms, function(.ele) if(!is(.ele, "pcm")){
    stop("pcms must be a list of pcm object.")
  })
  n <- vapply(pcms, FUN = function(.ele) .ele@name,
              FUN.VALUE = "a", USE.NAMES = FALSE)
  alphab <- vapply(pcms, function(.ele) .ele@alphabet=="RNA", FUN.VALUE = TRUE)
  if(any(alphab)&&revcomp[1]){
    message("The input is RNA motif. 
            The reverse complementation alignment will be turn off.
            To avoid this message, please set revcomp=FALSE")
    revcomp <- FALSE
  }
  stopifnot("There is duplicated motif names"=!duplicated(n))
  names(pcms) <- n
  cmb <- combn(n, m = 2, simplify = FALSE)
  align <- lapply(cmb, FUN=function(.ele){
    compareProfiles(pcms[[.ele[1]]], pcms[[.ele[2]]], method = method,
                    pseudo=pseudo, revcomp=revcomp)
  })
  align <- do.call(rbind, align)
  align <- cbind(do.call(rbind, cmb), align[, -(2:3)])
  colnames(align) <- c("motif1", "motif2", "alignmentScore", 
                      "startPos1", "startPos2", "endPos1", "endPos2",
                      "alignmentLength", "P_value", 
                      "distance", 'alignedDist',
                      "direction")[seq.int(ncol(align))]
  return(align)
}

#' comapre w pcm
#' @description compare two pcm objects
#' @param pcm1,pcm2 object of pcm
#' @param method Alignment method. "Smith-Waterman" or "Needleman-Wunsch".
#' Default is "Smith-Waterma"
#' @param pseudo pseudocount
#' @param revcomp Check reverseComplement or not.
#' @return a list with names: motif1, motif2, alignmentScore, 
#' startPos1, startPos2, endPos1, endPos2, alignmentLength.
compareProfiles <- function(pcm1, pcm2, 
                            method=c("Smith-Waterman", "Needleman-Wunsch"),
                            pseudo=1, 
                            revcomp=TRUE){
  method <- match.arg(method, 
                      choices = c("Smith-Waterman", "Needleman-Wunsch"))
  hspF <- compare2profiles(pcm1, pcm2, method, pseudo)
  if(!(pcm1@alphabet %in% c("DNA", "RNA")) || !revcomp){
    hspF$direction <- "Forward"
    return(hspF)
  }
  hspR <- compare2profiles(pcm1, matrixReverseComplement(pcm2),
                           method, pseudo)
  if(hspF$score >= hspR$score){
    hspF$direction <- "Forward"
    return(hspF)
  }else{
    hspR$direction <- "Reverse"
    return(hspR)
  }
}

#' compare two profiles
#' @description compare two pcm object
#' @param pcm1,pcm2 object of pcm
#' @param method Alignment method. "Smith-Waterman" or "Needleman-Wunsch".
#' Default is "Smith-Waterma"
#' @param pseudo pseudocount
#' @return a list with names: motif1, motif2, alignmentScore, 
#' startPos1, startPos2, endPos1, endPos2, alignmentLength.
compare2profiles <- function(pcm1, pcm2, 
                             method = c("Smith-Waterman", 
                                        "Needleman-Wunsch"),
                             pseudo=1
                             ){
  method <- match.arg(method, 
                      choices = c("Smith-Waterman", "Needleman-Wunsch"))
  if(!identical(rownames(pcm1@mat), rownames(pcm2@mat))){
    stop("the alphabet of the matrix are not identical.",
         "The alphabet (", rownames(pcm1@mat),
         ") is not identical with (", rownames(pcm2@mat),
         ")")
  }
  profile1 <- pcm1@mat
  profile2 <- pcm2@mat
  width1 <- ncol(profile1)
  width2 <- ncol(profile2)
  
  score <- getScore(pcm1, pcm2, pseudo)
  
  if(method == "Needleman-Wunsch"){
    dpScore <- dpGlobal(score, width1, width2)
    hsp <- traceBackGlobal(dpScore, score, width1, width2)
  }else{
    dpScore <- dpLocal(score, width1, width2)
    hsp <- traceBackLocal(dpScore, score, width1, width2)
  }
  dist <- getDistance(hsp, count1 = profile1, count2 = profile2,
                      P1 = pcm1@background, P2 = pcm2@background,
                      pseudo = pseudo)
  hsp$distance <- dist[1]
  hsp$alignedDist <- dist[2]
  return(hsp)
}


#' Calculate pair_wise position score
#' @param pcm1,pcm2 object of pcm
#' @param pseudo pseudocount
#' @return A score matrix with nrow of ncol of pcm1 
#' and ncol of ncol of pcm2.
getScore <- function(pcm1, pcm2, pseudo=1){
  stopifnot("input is not pcm object"=is(pcm1, "pcm"))
  stopifnot("input is not pcm object"=is(pcm2, "pcm"))
  profile1 <- pcm1@mat
  profile2 <- pcm2@mat
  P1 <- pcm1@background
  P2 <- pcm2@background
  isAA <- pcm1@alphabet=="AA" && pcm2@alphabet=="AA"
  score <- matrix(0, 
                  nrow = ncol(profile1),
                  ncol = ncol(profile2))
  for(i in seq.int(ncol(profile1))){
    for(j in seq.int(ncol(profile2))){
      if(isAA){##condense AA by chemical characteristics
        score[i, j] <- 
          getALLRscoreFromCounts(condenseByGroup(profile1[, i]), 
                                 condenseByGroup(profile2[, j]), 
                                 condenseByGroup(P1), 
                                 condenseByGroup(P2), pseudo)
      }else{
        score[i, j] <- 
          getALLRscoreFromCounts(profile1[, i], profile2[, j], 
                                 P1, P2, pseudo)
      }
    }
  }
  return(score)
}

condenseByGroup <- function(x, 
                            group=list(A=c("G", "A", "V", "L", "I"),
                                         S=c("S", "C", "U", "T", "M"),
                                         P=c("P"),
                                         F=c("F", "Y", "W"),
                                         H=c("H", "K", "R"),
                                         D=c("D", "E", "N", "Q"))){
  stopifnot(all(names(x) %in% unlist(group)))
  stopifnot(is.list(group))
  stopifnot(length(names(group))>0)
  vapply(group, FUN = function(.ele){
    sum(x[.ele], na.rm = TRUE)
  }, FUN.VALUE = 0.0)
}

#' calculate I'
#' @param freq1 position frequence for matrix 1 position j
#' @param freq2 position frequence for matrix 2 position j
#' @param P background of profile1
#' @return numeric(1)
calI <- function(freq1, freq2, P){
  stopifnot("The nrow of the matrix are not identical"
            =length(freq1)==length(freq2))
  sum(freq2*log(freq1/P)/log(2))
}

#' calculate frequence
#' @param count position counts
#' @param P background probility 
#' @param pseudo pseudocount
#' @return numeric(1)
calF <- function(count, 
                 P=rep(1/length(count), length(count)),
                 pseudo=1){
  total <- sum(count)
  f <- (count + P*pseudo)/(total+pseudo)
  return(f)
}

#' calculate ALLR from counts
#' @param count1,count2 count in position j for matrix 1 or 2
#' @param P1,P2 background for matrix 1 or 2
#' @param pseudo pseudocount
#' @return numeric(1) of ALLR
getALLRscoreFromCounts <- function(count1, count2, P1, P2, pseudo){
  freq1 <- calF(count1, P1, pseudo)
  freq2 <- calF(count2, P2, pseudo)
  
  I1 <- calI(freq1, freq2, P1)
  I2 <- calI(freq2, freq1, P2)
  
  total1 <- sum(count1)
  total2 <- sum(count2)
  
  score <- (I1*total2 + I2*total1)/(total1+total2)
  return(score)
}

#' Dynamic programming function, local version 
#' @param score ALLR scores, m x n matrix
#' @param m,n matrix width 
#' @return score matrix
dpLocal <- function(score, m, n){
  s <- 0
  DP <- matrix(0, nrow = m, ncol = n)
  DP[score[, 1]>0, 1] <- score[score[, 1]>0, 1]
  DP[1, score[1, ]>0] <- score[1, score[1, ]>0]
  for(i in seq.int(m)[-1]){
    for(j in seq.int(n)[-1]){
      s <- DP[i-1, j-1] + score[i, j]
      DP[i, j] <- ifelse(s>0, s, 0)
    }
  }
  return(DP)
}

#' Global alignment version
#' @param score ALLR scores, m x n matrix
#' @param m,n matrix width 
#' @return score matrix
dpGlobal <- function(score, m, n){
  s <- 0
  DP <- matrix(0, nrow = m, ncol = n)
  DP[, 1] <- score[, 1]
  DP[1, ] <- score[1, ]
  for(i in seq.int(m)[-1]){
    for(j in seq.int(n)[-1]){
      s <- DP[i-1, j-1] + score[i, j]
      DP[i, j] <- s
    }
  }
  return(DP)
}

#' traceback local
#' @param dpScore Dynamic programming score matrix
#' @param score ALLR scores, m x n matrix
#' @param m,n matrix width
#' @return a data.frame
traceBackLocal <- function(dpScore, score, m, n){
  max <- max(dpScore)
  maxpos <- which.max(dpScore)
  maxpos <- maxpos[length(maxpos)]
  j <- j_end <- ceiling(maxpos/m)
  i <- i_end <- maxpos - m*(j_end - 1)
  while(i>1 && j>1){
    if(dpScore[i, j]>0){
      i <- i-1
      j <- j-1
    }else{
      i <- i+1
      j <- j+1
      break()
    }
  }
  i_start <- i
  j_start <- j
  eval <- getEval(max, m, n)
  pval <- Eval2Pval(eval)
  return(data.frame(score=max,
              width1=m,
              width2=n,
              i_start=i_start,
              j_start=j_start,
              i_end=i_end,
              j_end=j_end,
              length=i_end - i_start + 1,
              P_value=pval))
}
#' traceback global
#' @param dpScore Dynamic programming score
#' @param score ALLR scores
#' @param m,n matrix width 
#' @return a data.frame
traceBackGlobal <- function(dpScore, score, m, n){
  max <- dpScore[m, n]
  i_end <- m
  j_end <- n
  for(i in seq.int(m)){
    if(dpScore[i, n]>=max){
      max <- dpScore[i, n]
      i_end <- i
      j_end <- n
    }
  }
  for(j in seq.int(n)){
    if(dpScore[m, j]>=max){
      max <- dpScore[m, j]
      i_end <- m
      j_end <- j
    }
  }
  i <- i_end
  j <- j_end
  while(i>1 && j>1){
    i <- i-1
    j <- j-1
  }
  i_start <- i
  j_start <- j
  eval <- getEval(max, m, n)
  pval <- Eval2Pval(eval)
  return(data.frame(score=max,
                    width1=m,
                    width2=n,
                    i_start=i_start,
                    j_start=j_start,
                    i_end=i_end,
                    j_end=j_end,
                    length=i_end - i_start + 1,
                    P_value=pval))
}

#' Calculate distances between two profiles
#' @param hsp output of traceBack function
#' @param count1,count2 motif profile 1 or 2
#' @param P1,P2 background of profile 1 or 2
#' @param pseudo pseudocount
#' @return full distance and aligned distance.
getDistance <- function(hsp, count1, count2, 
                        P1, P2, pseudo){
  full1 <- sum(
    apply(count1, 2, function(.ele) 
      getALLRscoreFromCounts(count1 = .ele, count2 = .ele, 
                             P1=P1, P2=P1, pseudo = pseudo))
  )
  if(hsp$i_start<=hsp$i_end){
    aligned1 <- sum(
      apply(count1[, hsp$i_start:hsp$i_end, drop=FALSE], 2, function(.ele) 
        getALLRscoreFromCounts(count1 = .ele, count2 = .ele, 
                               P1=P1, P2=P1, pseudo = pseudo))
    )
  }else{
    aligned1 <- 0
  }
  
  full2 <- sum(
    apply(count2, 2, function(.ele) 
      getALLRscoreFromCounts(count1 = .ele, count2 = .ele, 
                             P1=P2, P2=P2, pseudo = pseudo))
  )
  if(hsp$i_start<=hsp$i_end){
    aligned2 <- sum(
      apply(count2[, hsp$j_start:hsp$j_end, drop=FALSE], 2, function(.ele) 
        getALLRscoreFromCounts(count1 = .ele, count2 = .ele,
                               P1=P2, P2=P2, pseudo = pseudo))
    )
  }else{
    aligned2 <- 0
  }
  return(c(
    dist1 = full1 + full2 - 2*hsp$score,
    dist2 = aligned1 + aligned2 - 2*hsp$score
  ))
}

getEval <- function(alignmentScore, m, n){
  Lambda <- 0.02094
  K <- 0.26062
  H <- 3.25810
  K * m * n * exp (-Lambda*(alignmentScore*100))
}

Eval2Pval <- function(e){
  1 - exp(-e)
}

alignmentByPCC <- function(motifs, minimalConsensus=0, rcpostfix="(RC)", revcomp=rep(TRUE, length(motifs))){
  if(length(motifs)<2) stop("less than 2 motifs")
  if(length(revcomp)!=length(motifs)) stop("length of revcomp and motifs is not identical")
  lapply(motifs,function(.ele){
    if(!inherits(.ele, c("pfm", "psam"))) {
      stop("motifs must be a list of pfm or psam objects.")
    }
    if(.ele@alphabet!="DNA") stop("the alphabet of motif must be DNA")
  })
  motifcopy<-list(length=length(motifs))
  motifcopy[[1]]<-motifs[[1]]
  for(i in 2:length(motifs)){
    motifcopy[[i]]<-motifs[[i]]
    motifcopy<-UngappedPCCAlignment(motifcopy, i, minimalConsensus, rcpostfix, revcomp[i])
  }
  l<-unlist(lapply(motifcopy,function(.ele) ncol(.ele@mat)))
  l<-max(l)-l
  for(i in 1:length(motifcopy)){
    motifcopy[[i]]<-addBlank(motifcopy[[i]],l[i],TRUE)
  }
  motifcopy
}

UngappedPCCAlignment <- function(motifs, i, minimalConsensus=0, rcpostfix="(RC)", revcomp=TRUE){
  res<-getAlignedPCCWithoutGap(motifs[[i-1]], motifs[[i]], revcomp)
  if(res$max>=minimalConsensus){
    if(res$rev){
      motifs[[i]]<-matrixReverseComplement(motifs[[i]])
      motifs[[i]]@name<-paste(motifs[[i]]@name, rcpostfix, sep="")
    }
    if(res$offset>0){
      motifs[[i]]<-addBlank(motifs[[i]], res$offset, FALSE)
    }else{
      if(res[1]<0){
        motifs[1:(i-1)]<-lapply(motifs[1:(i-1)],function(.ele) addBlank(.ele, -1*res$offset, FALSE))
      }
    }
  }
  motifs
}

getAlignedPCCWithoutGap<-function(motif1, motif2, revcomp=TRUE){
  offset1<-getoffsetPosByPCC(motif1@mat, motif2@mat)
  if(revcomp){
    motif3<-matrixReverseComplement(motif2)
    offset2<-getoffsetPosByPCC(motif1@mat, motif3@mat)
  }else{
    offset2<-list(k=0,max=0)
  }
  offset<-0
  rev<-FALSE
  if((offset1$max < offset2$max)){
    rev<-TRUE
    max<-offset2$max
    offset<-offset2$k
  }else{
    max<-offset1$max
    offset<-offset1$k
  }
  list(offset=offset,rev=rev,max=max)    
}

#' @importFrom stats cor.test
getoffsetPosByPCC<-function(query, subject){
  if(!is(query, "matrix") || !is(subject, "matrix")){
    stop("query and subject must be numeric matrix")
  }
  score1<-rep(0, ncol(query))
  score2<-rep(0, ncol(subject))
  pvalue1<-rep(0, ncol(query))
  pvalue2<-rep(0, ncol(subject))
  for(i in seq.int(ncol(query))){
    J<-ifelse(ncol(query)-i>ncol(subject)-1,ncol(subject)-1,ncol(query)-i)
    corr <- cor.test(query[, i:(J+i)], subject[, 1:(J+1)], method="pearson")
    score1[i] <- J+1
    pvalue1[i] <- corr$p.value
  }
  for(i in 1:ncol(subject)){
    J<-ifelse(ncol(subject)-i>ncol(query)-1,ncol(query)-1,ncol(subject)-i)
    corr <- cor.test(query[, 1:(J+1)], subject[, i:(J+i)], method="pearson")
    score2[i] <- J+1
    pvalue2[i] <- corr$p.value
  }
  k1<-match(min(pvalue1),pvalue1)
  k2<-match(min(pvalue2),pvalue2)
  sc <- pvalue1[k1] > pvalue2[k2]
  k <- ifelse(sc, -1*(k2-1), (k1-1))
  max <- ifelse(sc, score2[k2], score1[k1])
  list(k=k, max=max)
}

require("motifStack") || stop("unable to load Package:motifStack")
require("TFBSTools") || stop("unable to load Package:TFBSTools")
#require("MotifDb") || stop("unalble to load Package::motifDb")
BiocGenerics:::testPackage("motifStack")

#' Class \code{"psam"}
#' 
#' An object of class \code{"psam"} represents the position specific affinity
#' matrix (PSAM) of a DNA/RNA/amino-acid sequence motif. The entry stores a
#' matrix, which in row i, column j gives the affinity of observing
#' nucleotide/or amino acid i in position j of the motif.
#' 
#' 
#' @name psam-class
#' @aliases psam
#' @docType class
#' @section Objects from the Class: Objects can be created by calls of the form
#' \code{new("psam", mat, name, alphabet, color)}.
#' @keywords classes
#' @export
#' @examples
#' 
#' motif <- importMatrix(file.path(find.package("motifStack"), "extdata", "PSAM.mxr"), 
#'          format="psam")[[1]]
#' plot(motif)
#' 
setClass("psam", 
         representation(mat="matrix", name="character", alphabet="character", 
                        color="character", tags="list",
                        markers="list"),
         validity=function(object){
           re<-TRUE
           if (abs(1-max(object@mat)) > 0.01) re<-"PSAM matrix should be normalized with respect to the value of the highest affinity oligonucleotied."
           if (any(object@mat<0)) re<-"PSAM matrix contain value less than 0"
           if (is.null(rownames(object@mat))) re<-"rownames of PSAM is empty"
           if (is.null(names(object@color))) re<-"names of color is empty"
           if (length(setdif(rownames(object@mat), names(object@color)))>0) re<-"not every alphabet in psam has a corresponding color"
           if (!object@alphabet %in% c("DNA", "RNA", "AA", "others")) re<-"alphabet must be either DNA, RNA, AA or others"
           if (object@alphabet=="DNA" & !all(rownames(object@mat) %in% c("A","C","G","T"))) re<-"rownames of PSAM for DNA motifs must be capital A, C, G and T"
           if (object@alphabet=="RNA" & !all(rownames(object@mat) %in% c("A","C","G","U"))) re<-"rownames of PSAM for RNA motifs must be capital A, C, G and U"
           if (object@alphabet=="AA" & !all(rownames(object@mat) %in% LETTERS[1:26])) re<-"rownames of PSAM for AA motifs must be capital letters"
           if (any(!is(object@markers, "marker"))) re<- "markers must be a list of marker object"
           re
         }
)

#' "psam" methods
#' 
#' methods for psam objects.
#' 
#' 
#' @name psam-class
#' @aliases $,psam-method $<-,psam-method
#' @docType methods
#' @param x An object of class \code{psam}.
#' @param name Slot name.
#' @param y Not use.
#' @param n how many spaces should be added.
#' @param b logical value to indicate where the space should be added.
#' @param \dots Further potential arguments passed to \code{plotAffinityLogo}.
#' @param row.names,optional see as.data.frame
#' @section Methods: \describe{ \item{addBlank}{\code{signature(x="psam",
#' n="numeric", b="logical")} add space into the position specific affinity
#' matrix for alignment. b is a bool value, if TRUE, add space to the 3' end,
#' else add space to the 5' end. n indicates how many spaces should be added.}
#' 
#' \item{matrixReverseComplement}{\code{signature(x = "psam")} get the reverse
#' complement of position specific affinity matrix.}
#' 
#' \item{plot}{\code{signature(x = "psam")} Plots the affinity logo of the
#' position specific affinity matrix. }
#' 
#' \item{$, $<-}{Get or set the slot of \code{\link{psam-class}}}
#' \item{as.data.frame}{convert \code{\link{psam-class}} to a data.frame}
#' \item{format}{return the name_pfm of \code{\link{psam-class}}} }
#' @keywords classes
#' @examples
#' 
#' motif <- importMatrix(file.path(find.package("motifStack"), "extdata", "PSAM.mxr"), 
#'                       format="psam")[[1]]
#' matrixReverseComplement(motif)
#' addBlank(motif, 1, FALSE)
#' addBlank(motif, 3, TRUE)
#' as(motif,"matrix")
#' as.data.frame(motif)
#' format(motif)
#' 
#' @exportMethod `$` `$<-`
setMethod("$", "psam", function(x, name) slot(x, name))
setReplaceMethod("$", "psam",
                 function(x, name, value){
                   slot(x, name, check = TRUE) <- value
                   x
                 })

setMethod("initialize","psam",function(.Object, mat, name, alphabet, color, tags, markers){
  if(mode(mat)!="numeric") stop("mat must be a numeric matrix")
  if(is.null(rownames(mat))) stop("rownames of PSAM is empty")
  rownames(mat)<-toupper(rownames(mat))
  rname<-rownames(mat)
  if(missing(alphabet)){
    rname<-rname[order(rname)]
    if(all(rname %in% c("A","C","G","T"))) alphabet<-"DNA"
    else{
      if(all(rname %in% c("A","C","G","U"))) alphabet<-"RNA"
      else{
        if(all(rname %in% LETTERS[1:26]) & nrow(mat)==20) alphabet<-"AA"
        else alphabet<-"others"
      }
    }
  }
  if(missing(color)){
    color<-colorset(alphabet, "auto")
  }
  .Object@mat            =    mat
  .Object@name        =    name
  .Object@alphabet    =    alphabet
  .Object@color        =    color
  if(!missing(tags)) .Object@tags = tags
  if(!missing(markers)) .Object@markers = markers
  .Object
})

#' @rdname psam-class
#' @aliases plot,psam,ANY-method
#' @exportMethod plot
setMethod("plot", signature(x="psam"), 
          function(x, y="missing", ...){
            plotAffinityLogo(psam=x, ...)
          }
)

#' @name as()
#' @rdname psam-class
#' @aliases coerce,psam,matrix-method
#' @exportMethod coerce
setAs(from="psam", to="matrix", function(from){
  from@mat
})

#' @rdname psam-class
#' @exportMethod matrixReverseComplement
#' @aliases matrixReverseComplement,psam-method
setMethod("matrixReverseComplement", "psam", function(x){
  if(x@alphabet!="DNA") stop("alphabet of psam must be DNA")
  mat<-x@mat
  ## double check the rownames to A, C, G, T.
  if(!all(toupper(rownames(mat))==c("A", "C", "G", "T"))){
    mat <- mat[match(c("A", "C", "G", "T"), toupper(rownames(mat))), ]
  }
  rc<-matrix(nrow=nrow(mat),ncol=ncol(mat))
  complements<-c(4,3,2,1)
  for(i in 1:nrow(mat)){
    for(j in 1:ncol(mat)){
      rc[complements[i],(ncol(mat)+1-j)]<-mat[i,j]
    }
  }
  rownames(rc)<-rownames(mat)
  x@mat<-rc
  x
})

#' @rdname psam-class
#' @exportMethod addBlank
#' @aliases addBlank,psam,numeric,logical-method
setMethod("addBlank", signature(x="psam", n="numeric", b="logical"), function(x, n, b){
  if(x@alphabet!="DNA") stop("alphabet of psam must be DNA")
  N<-matrix(rep(0, n*4), nrow=4)
  if(b){
    N<-cbind(x@mat,N)
  }else{
    N<-cbind(N,x@mat)
    if(length(x@markers)>0){
      x@markers <- lapply(x@markers, function(.ele){
        .ele@start <- .ele@start+n
        .ele@stop <- .ele@stop+n
        .ele
      })
    }
  }
  rownames(N)<-rownames(x@mat)
  x@mat<-N
  x
})

## for data.frame
#' @rdname psam-class
#' @exportMethod as.data.frame
#' @aliases as.data.frame,psam-method
setMethod("as.data.frame", signature(x="psam"), function(x, row.names = NULL, optional = FALSE, ...){
  as.data.frame(x@mat, ...)
})

#' @rdname psam-class
#' @exportMethod format
#' @aliases format,psam-method
setMethod("format", signature(x="psam"), function(x, ...){
  paste0(x@name, "_psam")
})

#' merge multiple motifs
#' 
#' merge multiple motifs by calculate mean of each position
#' 
#' 
#' @param ... \link{pcm} or \link{pfm} objects
#' @param bgNoise if it is not NA, test will using a background by
#' Dirichlet(1)-distributed random frequencies with weight bg.noise.  The value
#' of bgNoise should be a number in the range of 0 to 1, eg. 0.05
#' @return a \link{pfm} object
#' @author Jianhong Ou
#' @keywords misc
#' @export
#' @importFrom stats rgamma
#' @examples
#' 
#'     pcms<-readPCM(file.path(find.package("motifStack"), "extdata"),"pcm$")
#'     mergeMotifs(pcms)
#' 
mergeMotifs <- function(..., bgNoise=NA){
    mL <- list(...)
    n <- length(mL)
    if(n==1){
        mL <- mL[[1]]
        n <- length(mL)
    }
    if(n<2){
        stop("The number of input motifs should more than 1")
    }
    classes <- sapply(mL, function(.ele) {
      if(is(.ele, "pcm")) return("pcm")
      if(is(.ele, "pfm")) return("pfm")
      return("others")
    })
    if(any(!classes %in% c("pcm", "pfm"))){
        stop("Not all of the motifs are pcm or pfm object")
    }
    if(length(unique(classes))!=1){
        stop("The inputs are not in same format")
    }
    names <- sapply(mL, function(.ele) .ele$name)
    if(length(names)!=n){
        message("Not all motifs have names. the Name slot will be set as NULL")
        names <- ""
    }else{
        names <- paste(names, collapse=";")
    }
    
    mL <- DNAmotifAlignment(mL)
    d <- sapply(mL, function(.ele) dim(.ele$mat))
    if(nrow(unique(t(d)))!=1) stop("Unexpect happened. Report this bug please.")
    d <- c(d[, 1], n)
    dat <- lapply(mL, function(.ele) .ele$mat)
    dat <- array(unlist(dat), dim=d)
    mat <- apply(dat, MARGIN=c(1, 2), FUN=mean)
    mat <- t(t(mat)/colSums(mat)) #convert into frequency
    
    rdirichlet <- function (n, alpha){
        l <- length(alpha)
        x <- matrix(rgamma(l * n, alpha), ncol = n, byrow = TRUE)
        sm <- x %*% rep(1, n)
        t(x/as.vector(sm))
    }
    if(!is.na(bgNoise)){
        if(bgNoise<0 | bgNoise>1) stop("bgNoise must be number in (0, 1)")
        mat <- (1-bgNoise)*mat + 
            bgNoise*rdirichlet(nrow(mat), rep(1, ncol(mat)))
    }
    
    rownames(mat) <- rownames(mL[[1]]$mat)
    
    new("pfm", mat=mat, name=names)
}

#' read pcm from a path
#' 
#' read position count matrix from a path
#' 
#' 
#' @param path a character vector of full path names
#' @param pattern an optional regular expression
#' @return A list of \code{\link{pcm}} objects
#' @export
#' @importFrom utils read.table
#' @examples
#' 
#' pcms<-readPCM(file.path(find.package("motifStack"), "extdata"),"pcm$")
#' 
readPCM <- function(path=".", pattern=NULL){
    pcms <- dir(path,pattern)
    pcml <- lapply(pcms, function(.ele){
        data <- read.table(file.path(path, basename(.ele)))
        classes <- sapply(data, class)
        data <- data[, classes %in% c("integer", "numeric")]
        rownames(data) <- c("A", "C", "G", "T")
        data
    })
    names(pcml) <- gsub("\\.(pcm|txt)$", "", basename(pcms), ignore.case=TRUE)
    pcm <- mapply(function(.d, .n){
        new("pcm", mat=as.matrix(.d), name=gsub("\\.", "_", make.names(.n))) 
    }, pcml, names(pcml))
    names(pcm) <- gsub("\\.", "_", make.names(names(pcm)))
    pcm
}

readPWM <- function(path=".", pattern=NULL, to=c("pfm", "pcm")){
    to <- match.arg(to)
    pwms <- dir(path,pattern)
    pwml <- lapply(pwms, function(.ele){
        data <- readLines(file.path(path, basename(.ele)))
        data <- data[grepl("^[ACGT]:",data)]
        data <- do.call(rbind, strsplit(data, "\\t"))
        rownames(data) <- gsub(":", "", data[,1])
        data <- data[c("A","C","G","T"), -1]
        data <- as.data.frame(data)
        for(i in 1:ncol(data)) data[,i] <- as.numeric(as.character(data[,i]))
        as.matrix(data)
    })
    names(pwml) <- gsub("[\\._](pwm|txt|pwm\\.txt)$", "", basename(pwms), ignore.case=TRUE)
    pwm <- mapply(function(.d, .n){
        if(!all(colSums(.d)==1)) .d <- .25*exp(.d)
        if(to=="pfm") new("pfm", mat=as.matrix(.d), name=gsub("\\.", "_", make.names(.n)))
        else{
            .d <- round(.d * 1000)
            new("pcm", mat=as.matrix(.d), name=gsub("\\.", "_", make.names(.n)))
        }
    }, pwml, names(pwml))
    names(pwm) <- gsub("\\.", "_", make.names(names(pwm)))
    pwm
}



#' retrieve color setting for logo
#' 
#' retrieve color setting for logo
#' 
#' 
#' @param alphabet character, 'DNA', 'RNA' or 'AA'
#' @param colorScheme 'auto', 'charge', 'chemistry', 'classic' or
#' 'hydrophobicity' for AA, 'auto', 'basepairing', or 'blindnessSafe' for DNA
#' ro RNA
#' @return A character vector of color scheme
#' @export
#' @examples
#' 
#' col <- colorset("AA", "hydrophobicity")
#' 
colorset<-function(alphabet="DNA", colorScheme='auto'){
    if(!alphabet %in% c("DNA","RNA","AA")) stop("alphabet must be one of 'DNA', 'RNA' or 'AA'")
    if(alphabet=='PROTEIN' & !(colorScheme %in% c('auto', 'charge', 'chemistry', 'classic', 'hydrophobicity')))
    stop("color scheme must be one of 'auto', 'charge', 'chemistry', 'classic' or 'hydrophobicity' for protein")
    if(alphabet %in% c('DNA','RNA') & !(colorScheme %in% c('auto', 'basepairing', 'blindnessSafe')))
    stop("color scheme must be one of 'auto', 'basepairing' or 'blindnessSafe'")
    taylor<-c(  'A'='#CCFF00',
                'C'='#FFFF00',
                'D'='#FF0000',
                'E'='#FF0066',
                'F'='#00FF66',
                'G'='#FF9900',
                'H'='#0066FF',
                'I'='#66FF00',
                'K'='#6600FF',
                'L'='#33FF00',
                'M'='#00FF00',
                'N'='#CC00FF',
                'P'='#FFCC00',
                'Q'='#FF00CC',
                'R'='#0000FF',
                'S'='#FF3300',
                'T'='#FF6600',
                'V'='#99FF00',
                'W'='#00CCFF',
                'Y'='#00FFCC')
    charge<-c(   'A'='#CCCCCC',
                 'C'='#CCCCCC',
                 'D'='#FFB32C',
                 'E'='#FFB32C',
                 'F'='#CCCCCC',
                 'G'='#CCCCCC',
                 'H'='#2000C7',
                 'I'='#CCCCCC',
                 'K'='#2000C7',
                 'L'='#CCCCCC',
                 'M'='#CCCCCC',
                 'N'='#CCCCCC',
                 'P'='#CCCCCC',
                 'Q'='#CCCCCC',
                 'R'='#2000C7',
                 'S'='#CCCCCC',
                 'T'='#CCCCCC',
                 'V'='#CCCCCC',
                 'W'='#CCCCCC',
                 'Y'='#CCCCCC')
    chemistry<-c(   'A'='#000000',
                    'C'='#00811B',
                    'D'='#D00001',
                    'E'='#D00001',
                    'F'='#000000',
                    'G'='#00811B',
                    'H'='#2000C7',
                    'I'='#000000',
                    'K'='#2000C7',
                    'L'='#000000',
                    'M'='#000000',
                    'N'='#800080',
                    'P'='#000000',
                    'Q'='#800080',
                    'R'='#2000C7',
                    'S'='#00811B',
                    'T'='#00811B',
                    'V'='#000000',
                    'W'='#000000',
                    'Y'='#00811B')
    hydrophobicity<-c(   'A'='#00811B',
                         'C'='#2000C7',
                         'D'='#000000',
                         'E'='#000000',
                         'F'='#2000C7',
                         'G'='#00811B',
                         'H'='#00811B',
                         'I'='#2000C7',
                         'K'='#000000',
                         'L'='#2000C7',
                         'M'='#2000C7',
                         'N'='#000000',
                         'P'='#00811B',
                         'Q'='#000000',
                         'R'='#000000',
                         'S'='#00811B',
                         'T'='#00811B',
                         'V'='#2000C7',
                         'W'='#2000C7',
                         'Y'='#2000C7')
    base_pairing<-c('A'="#ff8c00",'C'="#2000C7",'G'="#2000C7",'TU'="#ff8c00")
    nucleotide<-c('A'="#00811B",'C'="#2000C7",'G'="#FFB32C",'TU'="#D00001")
    blindnessSafe <- c('A'="#009E73", 'C'="#0072B2", 'G'="#E69F00", 'TU'="#D55E00")
    if(alphabet=='DNA'){
        color<-switch(colorScheme, auto=nucleotide, 
                      basepairing=base_pairing, blindnessSafe=blindnessSafe)
        names(color)<-c('A','C','G','T')
        color
    }else{
        if(alphabet=='RNA'){
            color<-switch(colorScheme, auto=nucleotide, 
                          basepairing=base_pairing, blindnessSafe=blindnessSafe)
            names(color)<-c('A','C','G','U')
            color
        }else{
            switch(colorScheme, 
                   auto=taylor, 
                   charge=charge, 
                   chemistry=chemistry, 
                   classic=taylor, 
                   hydrophobicity=hydrophobicity)
        }
    }
}




#' add alpha transparency value to a color
#' 
#' An alpha transparency value can be specified to a color, in order to get
#' better color for background.
#' 
#' 
#' @param col vector of any of the three kinds of R color specifications, i.e.,
#' either a color name (as listed by \link[grDevices]{colors}()), a hexadecimal
#' string of the form "#rrggbb" or "#rrggbbaa" (see \link[grDevices]{rgb}), or
#' a positive integer i meaning \link[grDevices]{palette}()[i].
#' @param alpha a value in [0, 1]
#' @return a vector of colors in hexadecimal string of the form "#rrggbbaa".
#' @author Jianhong Ou
#' @keywords misc
#' @export
#' @importFrom grDevices col2rgb rgb
#' @examples
#' 
#'     highlightCol(1:5, 0.3)
#'     highlightCol(c("red", "green", "blue"), 0.3)
#' 
highlightCol <- function (col, alpha=0.5){
  if(alpha==1){
    return(col)
  }
  if(alpha<0 || alpha >1){
    stop("alpha must be a number in [0, 1].")
  }
    n <- names(col)
    col <- col2rgb(col,alpha=TRUE)
    col <- apply(col, 2, function(.ele, alpha){rgb(.ele[1], .ele[2], .ele[3], alpha=ceiling(alpha*.ele[4]), maxColorValue=255)}, alpha)
    col <- unlist(col)
    names(col) <- n
    col
}



#' convert pfm object to PWM
#' 
#' convert pfm object to PWM
#' 
#' 
#' @param x an object of \code{\link{pfm}} or \code{\link{pcm}} or matrix
#' @param N Total number of event counts used for pfm generation.
#' @return A numeric matrix representing the Position Weight Matrix for PWM.
#' @author Jianhong Ou
#' @seealso \code{\link[Biostrings:matchPWM]{PWM}}
#' @keywords misc
#' @export
#' @importFrom Biostrings PWM
#' @examples
#' 
#' library("MotifDb")
#' matrix.fly <- query(MotifDb, "Dmelanogaster")
#' pfm2pwm(matrix.fly[[1]])
#' 
pfm2pwm <- function(x, N=10000){
    if(!inherits(x, c("pfm", "pcm", "matrix")))
        stop("x must be an object of matrix or pcm or pfm")
  if(inherits(x, c("pcm", "pfm"))){
    prior.params=x@background
  }else{
    prior.params=rep(1/nrow(x), nrow(x))
    names(prior.params) <- rownames(x)
  }
  if(is(x, "pcm")){
    x <- x@mat
  }else{
    if(is(x, "pfm")){
      x <- x@mat*N
    }else{
      x <- x*N
    }
    x <- round(x)
    x[nrow(x),] <- N - colSums(x[-nrow(x),])
    id <- which(x[nrow(x),] < 0)
    if(length(id)>0){
      max.id <- apply(x, 2, function(.e) which(.e==max(.e))[1])
      for(i in 1:length(id)){
        x[max.id[id[i]], id[i]] <- x[max.id[id[i]], id[i]] + x[nrow(x), id[i]]
      }
      x[nrow(x), id] <- 0
    }
  }
  mode(x) <- "integer"
  PWM(x, prior.params=prior.params)
}

#' @importFrom stats loess predict
isHomoDimer <- function(x, t=0.001){
    if(!inherits(x, c("pfm", "pcm"))) stop("x must be an object of pfm or pcm")
    if(is(x, "pcm")) x <- pcm2pfm(x)
    ic <- getIC(x)
    if(length(ic)<11) return(FALSE)
    x.loess <- loess(y ~ x, span=.75, data.frame(x=1:length(ic), y=ic))
    x.predict <- predict(x.loess, data.frame(x=1:length(ic)))
    names(x.predict) <- NULL
    x.sign <- rle(sign(diff(x.predict)))
    x.values <- x.sign$values[x.sign$lengths>1]
    if(length(x.values)<3 && !identical(x.values, c(-1,1))) return(FALSE)
    y <- matrixReverseComplement(x)
    pfms <- list(x=x, y=y)
    d <- matalign(pfms, revComp=FALSE)
    ifelse(d$distance<t, TRUE, FALSE)
}


getHomoDimerCenter <- function(x){
    if(!inherits(x, c("pfm", "pcm"))) stop("x must be an object of pfm or pcm")
    if(is(x, "pcm")) x <- pcm2pfm(x)
    len <- ncol(x@mat)
    if(len < 6) return(NA)
    ra <- 3:(len-3) ## minimal monomer 3mer
    dist <- sapply(ra, function(pos){
        a <- b <- c <- x
        a@mat <- a@mat[, 1:pos]
        b@mat <- b@mat[, (pos+1):len]
        c@mat <- c@mat[, (pos+2):len]
        b <- matrixReverseComplement(b)
        c <- matrixReverseComplement(c)
        pfms <- list(a=a, b=b)
        d <- matalign(pfms, revComp=FALSE)
        pfms2 <- list(a=a, c=c)
        d2 <- matalign(pfms2, revComp=FALSE)
        c(d1=d$distance, d2=d2$distance)
    })
    colnames(dist) <- ra
    n <- which(dist==min(dist))
    
    j <- ceiling(n/2)
    i <- n + 2 - (2*j)
    pos <- ra[j]
    pos <- ifelse(i==2, pos+1, pos)
    ord <- order(abs(len/2 - pos))[1]
    pos <- pos[ord]
    type <- ifelse(i[ord]==2, "odd", "even")
    c(pos=pos, type=type)
}

#' import motifs from local files
#' 
#' Import the motifs into \link{pcm-class} or \link{pfm-class} from files
#' exported from Transfac, CisBP, and JASPAR.
#' 
#' 
#' @param filenames filename, 
#' an \link[TFBSTools:XMatrixList-class]{XMatrixList} object,
#' or an \link[TFBSTools:XMatrix-class]{XMatrix} object
#' to be imported.
#' @param format file format
#' @param to import to \link{pcm-class} or \link{pfm-class}
#' @return a list of object \link{pcm-class} or \link{pfm-class}
#' @author Jianhong Ou
#' @keywords misc
#' @export
#' @examples
#' 
#'   path <- system.file("extdata", package = "motifStack")
#'   importMatrix(dir(path, "*.pcm", full.names = TRUE))
#' 
importMatrix <- function(filenames, 
                         format=c("auto", "pfm", "cm", "pcm", "meme", 
                                  "transfac", "jaspar", "scpd", "cisbp",
                                  "psam", "xmatrix", "hocomoco"), 
                         to=c("auto", "pcm", "pfm", "pssm", "psam")){
  if(missing(filenames)){
    stop("filenames are required.")
  }
  stopifnot(is.character(filenames) ||
              is(filenames, "XMatrixList") ||
              is(filenames, "XMatrix"))
  
  format <- match.arg(format)
  to <- match.arg(to)
  
  if(is(filenames, "XMatrixList") ||
     is(filenames, "XMatrix")){
    if(!format %in% c("auto", "xmatrix")){
      message("format will be set to xmatrix")
    }
    format <- "xmatrix"
    ## check the format of XMatrix
    if(is(filenames, "XMatrix")){
      return(importM_xmatrix(list(filenames)))
    }
  }else{
    stopifnot(all(file.exists(filenames)))
    fi <- file.info(filenames)
    if(any(fi$isdir)){
      stop("filenames could not contain folders.")
    }
    if(format=="auto"){
      getFileNameExtension <- function(fn){
        fn <- basename(fn)
        fn <- strsplit(fn, "\\.")
        ext <- lapply(fn, function(.ele){
          l <- length(.ele)
          if(l==1){
            NA
          }else{
            .ele[l]
          }
        })
        unlist(ext)
      }
      ext <- getFileNameExtension(filenames)
      if(any(is.na(ext))){
        stop("Can not determine the format of inputs by its extensions.")
      }
      ext <- unique(ext)
      if(length(ext)!=1){
        stop("There are multiple file formats in your inputs.")
      }
      format <- c("pfm", "cm", "pcm", "meme", "transfac", "jaspar", "scpd", "cisbp", "psam")
      format <- format[format==ext]
      if(length(format)!=1){
        stop("Can not determine the format of inputs by its extensions.")
      }
    }
  }
  
  
  ## importM_... will output a list of matrix, 
  ## matrix rownames must be symbols, such as c(A, C, G, T)
  m <- do.call(paste0("importM_", format), list(fns=filenames))
  if(format=="meme"){
    return(m)
  }
  if(format=="psam"){
    return(m)
  }
  ## check is counts
  isCounts <- function(cnt){
    cnt <- cnt$mat
    if(typeof(cnt)=="integer"){
      return(TRUE)
    }else{
      cnt1 <- round(cnt, digits = 0)
      if(all(cnt==cnt1)){
        return(TRUE)
      }
    }
    return(FALSE)
  }
  isCnt <- sapply(m, isCounts)
  # check if position frequency matrix
  isPFMmatrix <- function(cnt){
    if (any(abs(1 - colSums(cnt)) > 0.01)) return(FALSE)
    return(TRUE)
  }
  if(to=="auto"){
    if(all(isCnt)){
      to <- "pcm"
    }else{
      to <- "pfm"
    }
  }
  mapply(function(.m, .type){
    .m$mat <- as.matrix(.m$mat)
    c2f <- FALSE
    if(to=="pcm"){
      if(!.type){
        stop("Can not import ", .m$name, " to pcm format!")
      }
      .m$Class <- "pcm"
    }else{
      if(isPFMmatrix(.m$mat)){
        .m$Class <- "pfm"
      }else{
        if(.type){
          message("trying to convert data into position frequency matrix from count matrix.")
          .m$Class <- "pcm"
          c2f <- TRUE
        }else{
          stop("Can not import data into PFM. Columns of PFM must add up to 1.0")
        }
      }
    }
    .m <- do.call(new, .m)
    if(c2f){
      .m <- pcm2pfm(.m)
    }
    .m
  }, m, isCnt)
}

## output named list of matrix
importFASTAlikeFile <- function(fn, comment.char=">", vertical=FALSE){
  stopifnot(length(fn)==1)
  lines <- readLines(fn)
  lines <- lines[!grepl("^\\s*$", lines)]
  sep <- grepl(paste0("^", comment.char), lines)
  if(sum(sep)<1){
    ## not fasta like file
    ## insert the filename as fasta like file
    ## check point: only four rows
    if(length(lines)!=4){
      stop("Trying to convert the file into fasta like file.",
           "But the lines in file is not 4.")
    }
    lines <- c(paste0(comment.char, sub("\\.(pcm|pfm|cm|jaspar|scpd|beeml|cisbp)$", "", basename(fn))), lines)
    sep <- grepl(paste0("^", comment.char), lines)
  }
  tfNames <- sub(paste0("^", comment.char, "\\s*"), "", lines[sep])
  names(tfNames) <- make.names(tfNames, unique = TRUE, allow_ = TRUE)
  if(vertical){
    ## format is
    # >AHCTF1.H13CORE.0.B.B
    # 250.0	118.0	145.0	168.0
    # 332.0	76.0	67.0	206.0
    # 681.0	0.0	0.0	0.0
    # 681.0	0.0	0.0	0.0
    # 681.0	0.0	0.0	0.0
    # 0.0	0.0	0.0	681.0
    # 281.0	91.0	113.0	196.0
    header_idx <- which(sep)
    tfData <- lapply(seq_along(header_idx), function(i){
      start <- header_idx[i] +1
      end <- ifelse(i < length(header_idx),
                    header_idx[i + 1] - 1,
                    length(lines))
      lines[seq(from=start, to=end)]
    })
    coln <- c("A", "C", "G", "T")
    motifs <- mapply(tfData, tfNames, FUN=function(.ele, .name){
      ## check ACGT
      header <-all(vapply(coln, function(.n){
        grepl(.n, .ele[1])
      }, logical(1L)))
      .ele <- read.table(text = .ele, header = header)
      if(header){
        if(!all(coln %in% colnames(.ele))){
          stop("unexpect cols. The cols should be A, C, G and T.")
        }
      }else{
        if(ncol(.ele)!=4){
          stop("unexpect cols. The cols should be 4.")
        }
        colnames(.ele) <- coln
      }
      .ele <- t(.ele[, coln])
      list(mat=.ele, tags=list(), name=.name)
    },SIMPLIFY = FALSE)
    return(motifs)
  }
  sep.f <- diff(c(which(sep), length(lines)+1))
  if(any(sep.f!=5)){
    stop("The file contain unexpect lines.",
         "The file should be fasta-like file.",
         "The first line is start with >",
         "and followed with four lines indicates the A, C, G, T counts")
  }
  lines <- lines[!sep]
  seq.f <- rep(names(tfNames), each=4)
  tfData <- split(lines, seq.f)
  rown <- c("A", "C", "G", "T")
  mapply(tfData, tfNames[names(tfData)], FUN=function(.ele, .name){
    ## check ACGT
    .rown <- substr(.ele, 1, 1)
    if(any(grepl("[a-zA-Z]", .rown))){
      if(all(.rown==rown)){
        ## remove the characters
        .ele <- gsub("^[^0-9\\-\\.]*([0-9\\-\\.].*[0-9a-eA-E\\.])[^0-9a-eA-E\\.]*$", "\\1", gsub("\\t", " ", .ele))
      }else{
        if(all(.rown %in% rown)){
          .ele <- .ele[order(.rown)]
          .ele <- gsub("^[^0-9\\-\\.]*([0-9\\-\\.].*[0-9a-eA-E\\.])[^0-9a-eA-E\\.]*$", "\\1", gsub("\\t", " ", .ele))
        }else{
          stop("unexpect rows. The rows should be A, C, G and T.")
        }
      }
    }
    .ele <- matrix(scan(text=.ele, what=double(), quiet=TRUE), nrow=4, byrow = TRUE)
    rownames(.ele) <- rown
    list(mat=.ele, tags=list(), name=.name)
  }, SIMPLIFY = FALSE)
}
importMulFASTAlike <- function(fns, comment.char=">", vertical=FALSE){
  d <- lapply(fns, function(.ele){
    importFASTAlikeFile(.ele, comment.char, vertical = vertical)
  })
  do.call(c, d)
}

importTRANSFAClikeFile <- function(fn){
  stopifnot(length(fn)==1)
  lines <- readLines(fn)
  lines <- lines[!grepl("^\\s*$", lines)]
  ## check PO and XX
  POs <- grepl("^P[O0]\\s", lines)
  XXs <- grepl("^XX", lines)
  if(sum(XXs)<1 || sum(POs)<1){
    ## not TRANSFAC like file
    stop("File is not TRANSFAC like file.")
  }
  ## find the data blocks
  sep <- data.frame(id=c(which(POs), which(XXs)), 
                    group=rep(c("PO","XX"), c(sum(POs), sum(XXs))),
                    stringsAsFactors = FALSE)
  sep <- sep[order(sep$id), ]
  sep <- sep[sep$group=="XX" & c("XX", sep$group[-nrow(sep)])=="PO", "id"]
  sep <- rep(sep, diff(c(0, sep)))
  lines <- split(lines[seq_along(sep)], sep)
  m <- lapply(lines, function(.ele){
    ## check lines with ID, AC, DE, BF
    getMarker <- function(s) sub(paste0("^", s, "\\s+"), "", .ele[grepl(paste0("^", s, "\\s"), .ele)])
    ID <- getMarker("ID")
    AC <- getMarker("AC")
    DE <- getMarker("DE")
    BF <- getMarker("BF")
    CC <- getMarker("CC")
    tags <- list("ID"=ID, "AC"=AC, "DE"=DE, "BF"=BF, "CC"=CC)
    tfName <- c(ID, AC, DE, BF)[1]
    ## check P0
    Po <- which(grepl("^P[O0]\\s", .ele))
    .ele <- .ele[Po:(length(.ele)-1)]
    ## check A C G T
    if(!grepl("^P[O0]\\s+A\\s+C\\s+G\\s+T", .ele[1], ignore.case = TRUE)){
      stop("PO line must be in the order of A, C, G and T")
    }
    .ele <- .ele[-1]
    ## remove last column if there is consensus
    .ele <- gsub("[a-zA-Z]*\\s*$", "", .ele)
    .ele <- matrix(scan(text=.ele, what = double(), quiet=TRUE), ncol = 5, byrow=TRUE)
    ## check first column
    if(!all(.ele[, 1]==seq_along(.ele[, 1]))){
      stop("In counts section, rownname should be from 01 to n.")
    }
    .ele <- .ele[, -1]
    colnames(.ele) <- c("A", "C", "G", "T")
    .ele <- t(.ele)
    list(name=tfName, mat=.ele, tags=tags)
  })
  names(m) <- make.names(sapply(m, function(.ele) .ele$name), unique = TRUE, allow_ = TRUE)
  m
}

importMulTRANSFAClike <- function(fns){
  d <- lapply(fns, function(.ele){
    importTRANSFAClikeFile(.ele)
  })
  do.call(c, d)
}

importCisBP <- function(fn){
  stopifnot(length(fn)==1)
  lines <- readLines(fn)
  lines <- lines[!grepl("^\\s*$", lines)]
  ## check Pos and XX
  POs <- grepl("^Pos\\s", lines)
  TFs <- grepl("^TF", lines) & !grepl("Name", lines)
  if(sum(TFs)<1 || sum(POs)<1){
    stop("File is not CisBP PWM file.")
  }
  ## find the data blocks
  sep <- which(TFs)
  if(sep[1]!=1){
    stop("File is not CisBP PWM file.")
  }
  sep <- c(sep, length(lines)+1)
  sep <- diff(sep)
  sep <- rep(seq_along(sep), sep)
  lines <- split(lines[seq_along(sep)], sep)
  m <- lapply(lines, function(.ele){
    ## check lines with ID, AC, DE, BF
    getMarker <- function(s) sub(paste0("^", s, "\\s+"), "", .ele[grepl(paste0("^", s, "\\s"), .ele)])
    TF <- getMarker("TF")[1]
    TFn <- getMarker("TF\\s+Name")
    Motif <- getMarker("Motif")
    Family <- getMarker("Family")
    tags <- list("TF"=TF, "TFn"=TFn, "Motif"=Motif, "Family"=Family)
    tfName <- c(TFn, TF, Motif)[1]
    ## check P0
    Po <- which(grepl("^Pos\\s", .ele))
    .ele <- .ele[Po:(length(.ele)-1)]
    ## check A C G T
    if(!grepl("^Pos\\s+A\\s+C\\s+G\\s+T", .ele[1], ignore.case = TRUE)){
      stop("Pos line must be in the order of A, C, G and T")
    }
    .ele <- .ele[-1]
    ## remove last column if there is consensus
    .ele <- gsub("[a-zA-Z]*\\s*$", "", .ele)
    .ele <- tryCatch(matrix(scan(text=.ele, what = double(), quiet=TRUE), ncol = 5, byrow=TRUE),
             error = function(.e){
               NULL
             })
    if(is.null(.ele)){
      return(NULL)
    }
    ## check first column
    if(!all(.ele[, 1]==seq_along(.ele[, 1]))){
      stop("In counts section, rownname should be from 01 to n.")
    }
    .ele <- .ele[, -1]
    colnames(.ele) <- c("A", "C", "G", "T")
    .ele <- t(.ele)
    list(name=tfName, mat=.ele, tags=tags)
  })
  m <- m[sapply(m, function(.ele) !is.null(.ele[1]))]
  names(m) <- make.names(sapply(m, function(.ele) .ele$name), unique = TRUE, allow_ = TRUE)
  m
}

importMulCisBP <- function(fns){
  d <- lapply(fns, function(.ele){
    importCisBP(.ele)
  })
  do.call(c, d)
}


importM_pfm <- function(fns){
  importMulFASTAlike(fns)
}

importM_jaspar <- function(fns){
  importMulFASTAlike(fns)
}

importM_hocomoco <- function(fns){
  importMulFASTAlike(fns, vertical = TRUE)
}

importM_cm <- function(fns){
  importMulFASTAlike(fns)
}

importM_pcm <- function(fns){
  importMulFASTAlike(fns)
}

importM_transfac <- function(fns){
  importMulTRANSFAClike(fns)
}

importM_cisbp <- function(fns){
  importMulCisBP(fns)
}

importM_beeml <- function(fns){
  importMulFASTAlike(fns, comment.char="#")
}

importM_scpd <- function(fns){
  importMulFASTAlike(fns)
}

importM_meme <- function(fns){
  m <- lapply(fns, function(fn){
    lines <- readLines(fn)
    ## MEME version
    if(!any(grepl("MEME\\s+version\\s", lines))){
      stop("MEME version is required in first line.")
    }
    lines <- lines[-1]
    alphabet <- lines[grepl("^ALPHABET", lines, ignore.case = TRUE)]
    alphabet <- sub("^.*(AC.*)\\s*$", "\\1", alphabet)
    alphabet <- unique(alphabet)
    if(length(alphabet)>1){
      stop("mixed alphabet in your input file.")
    }
    if(length(alphabet)==0){
      stop("Can not detect the alphabet in your input file.")
    }
    alphabet <- switch(alphabet, ACGT="DNA", ACGU="RNA", ACDEFGHIKLMNPQRSTVWY="AA", "others")
    letters <- switch(alphabet, DNA=c("A", "C", "G", "T"),
                      RNA=c("A", "C", "G", "U"),
                      AA=c("A","C","D","E","F","G","H","I","K","L","M","N","P","Q","R","S","T","V","W","Y"),
                      others={
                        fr <- which(grepl("^ALPHABET", lines))
                        to <- which(grepl("^END\\s+ALPHABET", lines))
                        substr(lines[(fr+1):(to-1)], 1, 1)
                      })
    
    tfNames <- sub("^MOTIF\\s+", "", lines[grepl("^MOTIF\\s+", lines)])
    mat_frs <- which(grepl("^letter-probability matrix", lines))
    if(length(tfNames)!=length(mat_frs)){
      stop("Can not convert the MEME file.", fn)
    }
    mat_frs_end <- c((mat_frs - 2)[-1], length(lines))
    motifs <- mapply(mat_frs, mat_frs_end, FUN=function(mat_fr, mat_fr_end){
      mat.info <- lines[mat_fr]
      alength <- sub("^.*?alength=\\s*(\\d+)[^0-9]*.*$", "\\1", mat.info)
      if(length(letters)!=as.numeric(alength)){
        warning("alength is not as same as length of letters")
        alength <- length(letters)
      }
      if(grepl('w=', mat.info)){
        w <- sub("^.*?w=\\s*(\\d+)\\s.*$", "\\1", mat.info)
        mat.lines <- lines[(mat_fr+1):(mat_fr+as.numeric(w))]
      }else{
        mat.lines <- lines[(mat_fr+1):mat_fr_end]
        ## remove empty lines
        mat.lines <- mat.lines[!grepl('^\\s+$', mat.lines)]
        ## remove the lines not start with number
        mat.lines <- sub("^\\s+", "", mat.lines)
        mat.lines <- mat.lines[grepl('^\\d+', mat.lines)]
        w <- length(mat.lines)
      }
      mat <- matrix(scan(text=mat.lines, what = double(), quiet=TRUE),
                    ncol = as.numeric(alength), byrow=TRUE)
      mat <- t(mat)
      rownames(mat) <- letters
      mat
    }, SIMPLIFY = FALSE)
    names(motifs) <- make.names(tfNames, unique = TRUE, allow_ = TRUE)
    
    ## background
    background <- NA
    if(any(grepl("^Background\\s+letter\\s+frequencies", lines))){
      bcklines.fr <- which(grepl("^Background\\s+letter\\s+frequencies", lines))+1
      if(length(bcklines.fr)!=length(mat_frs)){
        if(length(bcklines.fr)==1){
          bcklines <- lines[bcklines.fr:(length(lines))]
          bcklines.keep <- which(grepl("^[a-zA-Z]\\s+[0-9\\.]+", bcklines))
          bcklines.keep.diff <- diff(c(0, bcklines.keep))
          bcklines.keep.to <- which(bcklines.keep.diff!=1)
          if(length(bcklines.keep.to)<1){
            bcklines.keep.to <- length(bcklines.keep.to)
          }else{
            bcklines.keep.to <- bcklines.keep.to[1]-1
          }
          bcklines <- bcklines[seq.int(bcklines.keep.to)]
          if(length(bcklines)>0){
            bcklines <- paste(bcklines, collapse = " ")
            bcklines <- sub("\\s*$", "", bcklines)
            bcklines <- strsplit(bcklines, "\\s+")[[1]]
            bcklines <- matrix(bcklines, nrow=2)
            background <- as.numeric(bcklines[2, ])
            names(background) <- bcklines[1, ]
          }
          mapply(function(mat, tfName) new("pfm", mat=mat, name=tfName, alphabet=alphabet),
                 motifs, names(motifs))
        }else{
          stop("Not all the matrix have background")
        }
      }else{
        background <- mapply(function(bckline.fr, mat_fr){
          bcklines <- lines[bckline.fr:mat_fr]
          bcklines.keep <- which(grepl("^[a-zA-Z]\\s+[0-9\\.]+", bcklines))
          bcklines.keep.diff <- diff(c(0, bcklines.keep))
          bcklines.keep.to <- which(bcklines.keep.diff!=1)
          if(length(bcklines.keep.to)<1){
            bcklines.keep.to <- length(bcklines.keep.to)
          }else{
            bcklines.keep.to <- bcklines.keep.to[1]-1
          }
          bcklines <- bcklines[seq.int(bcklines.keep.to)]
          if(length(bcklines)>0){
            bcklines <- paste(bcklines, collapse = " ")
            bcklines <- sub("\\s*$", "", bcklines)
            bcklines <- strsplit(bcklines, "\\s+")[[1]]
            bcklines <- matrix(bcklines, nrow=2)
            bck <- as.numeric(bcklines[2, ])
            names(bck) <- bcklines[1, ]
          }else{
            bck <- NULL
          }
          bck
        }, bcklines.fr, mat_frs, SIMPLIFY = FALSE)
        mapply(function(mat, tfName, thisBck) {
          if(length(thisBck)>0){
            new("pfm", mat=mat, name=tfName, alphabet=alphabet, background=thisBck)
          }else{
            new("pfm", mat=mat, name=tfName, alphabet=alphabet)
          }
        }, motifs, names(motifs), background)
      }
    }else{
      mapply(function(mat, tfName) new("pfm", mat=mat, name=tfName, alphabet=alphabet),
             motifs, names(motifs))
    }
  })
  m <- unlist(m)
  m
}

#' @importFrom XML xmlToList xmlParse
#' @importFrom utils read.delim
importM_psam <- function(fns){
  m <- lapply(fns, function(fn){
    lines <- xmlToList(xmlParse(fn))
    psam <- trimws(lines$psam) ## now ACGT only, don't know what is exactly format of MatrixREDUCE 2.0
    psam <- read.delim(text = psam, header = FALSE, skip = 2)
    psam <- t(psam)
    rownames(psam) <- c("A", "C", "G", "T")
    new("psam", mat=psam, name=basename(fn))
  })
  names(m) <- make.names(sapply(m, function(.ele) .ele@name), unique = TRUE, allow_ = TRUE)
  m
}

#' @importMethodsFrom TFBSTools name bg tags Matrix
importM_xmatrix <- function(fns){
  m <- lapply(fns, function(.ele){
    list(name=name(.ele), mat=Matrix(.ele),
         tags=tags(.ele), background=bg(.ele))
  })
  m
}

###############################################################################
######## phylog style stack
######## 
###############################################################################



#' plot sequence logo stacks with a ape4-style phylogenic tree
#' 
#' plot sequence logo stacks with a ape4-style phylogenic tree
#' 
#' 
#' @param phylog an object of class phylog
#' @param pfms a list of objects of class pfm
#' @param f.phylog a size coefficient for tree size (a parameter to draw the
#' tree in proportion to leaves label)
#' @param f.logo a size coefficient for the motif
#' @param cleaves a character size for plotting the points that represent the
#' leaves, used with par("cex")*cleaves. If zero, no points are drawn
#' @param cnodes a character size for plotting the points that represent the
#' nodes, used with par("cex")*cnodes. If zero, no points are drawn
#' @param labels.leaves a vector of strings of characters for the leaves labels
#' @param clabel.leaves a character size for the leaves labels, used with
#' par("cex")*clavel.leaves
#' @param labels.nodes a vector of strings of characters for the nodes labels
#' @param clabel.nodes a character size for the nodes labels, used with
#' par("cex")*clabel.nodes. If zero, no nodes labels are drawn
#' @param font font of logo
#' @param ic.scale logical If TRUE, the height of each column is proportional
#' to its information content. Otherwise, all columns have the same height.
#' @param ... not used.
#' @return none
#' @seealso \link[ade4:plot.phylog]{plot.phylog}
#' @export
#' @importFrom grid grid.newpage pushViewport viewport grid.text gpar
#' grid.segments popViewport grid.points
#' @importFrom graphics par
#' @importFrom grDevices grey
#' @examples
#' 
#'   if(interactive() || Sys.getenv("USER")=="jianhongou"){
#'     library("MotifDb")
#'     matrix.fly <- query(MotifDb, "Dmelanogaster")
#'     motifs <- as.list(matrix.fly)
#'     motifs <- motifs[grepl("Dmelanogaster-FlyFactorSurvey-", names(motifs), fixed=TRUE)]
#'     names(motifs) <- gsub("Dmelanogaster_FlyFactorSurvey_", "", 
#'                 gsub("_FBgn[0-9]+$", "", 
#'                   gsub("[^a-zA-Z0-9]","_", 
#'                      gsub("(_[0-9]+)+$", "", names(motifs)))))
#'     motifs <- motifs[unique(names(motifs))]
#'     pfms <- sample(motifs, 50)
#'     hc <- clusterMotifs(pfms)
#'     library(ade4)
#'     phylog <- ade4::hclust2phylog(hc)
#'     leaves <- names(phylog$leaves)
#'     pfms <- pfms[leaves]
#'     pfms <- mapply(pfms, names(pfms), FUN=function(.ele, .name){
#'                  new("pfm",mat=.ele, name=.name)})
#'     pfms <- DNAmotifAlignment(pfms, minimalConsensus=3)
#'     plotMotifStackWithPhylog(phylog, pfms, f.phylog=0.3, 
#'                              cleaves = 0.5, clabel.leaves = 0.7)
#'   }
#' 
plotMotifStackWithPhylog <- function(phylog, pfms=NULL,
                                     f.phylog = 0.3, f.logo = NULL, 
                                     cleaves =1, cnodes =0,
                                     labels.leaves = names(phylog$leaves), 
                                     clabel.leaves=1,
                                     labels.nodes = names(phylog$nodes), 
                                     clabel.nodes = 0, 
                                     font="sans", ic.scale=TRUE,
                                     ...
){
  if(!inherits(phylog, "phylog")) stop("phylog must be an object of phylog")
  n<-length(pfms)
  if(all(sapply(pfms, function(.ele) is(.ele, "pcm")))) {
    pfms <- lapply(pfms, pcm2pfm)
  }
  lapply(pfms,function(.ele){
    if(!inherits(.ele, c("pfm", "psam"))) stop("pfms must be a list of pfm or psam objects.")
  })
  leaves.number <- length(phylog$leaves)
  leaves.names<- names(phylog$leaves)
  nodes.number <- length(phylog$nodes)
  nodes.names <- names(phylog$nodes)
  if (length(labels.leaves) != leaves.number) labels.leaves <- names(phylog$leaves)
  if (length(labels.nodes) != nodes.number) labels.nodes <- names(phylog$nodes)
  leaves.car <- gsub("[_]"," ",labels.leaves)
  nodes.car <- gsub("[_]"," ",labels.nodes)
  #opar <- par(mar = c(0, 0, 0, 0))
  #on.exit(par(opar))
  
  if (f.phylog < 0.05) f.phylog <- 0.05 
  if (f.phylog > 0.75) f.phylog <- 0.75
  
  maxx <- max(phylog$droot)
  # plot.default(0, 0, type = "n", xlab = "", ylab = "", xaxt = "n", 
  #              yaxt = "n", xlim = c(-maxx*0.15, maxx/f.phylog), ylim = c(-0, 1), xaxs = "i", 
  #              yaxs = "i", frame.plot = FALSE)
  plot <- gList()
  vp <- viewport(xscale = c(-maxx*0.15, maxx/f.phylog))

  x.leaves <- phylog$droot[leaves.names]
  x.nodes <- phylog$droot[nodes.names]
  
  y <- (leaves.number:1)/(leaves.number + 1)
  names(y) <- leaves.names
  
  xcar <- maxx*1.05
  xx <- c(x.leaves, x.nodes)
  
  assign("tmp_motifStack_symbolsCache", list(), envir=.globals)
  vpheight <- y[length(y)] * .95
  if(is.null(f.logo)){
    f.logo <- max(unlist(lapply(leaves.names, strwidth, units="figure", cex=clabel.leaves)))
    if(!is.null(pfms)){
      pfms.width <- max(sapply(pfms, function(x) ncol(x@mat)))
      pfms.width <- strwidth(paste(rep("M", pfms.width), collapse=""), units="figure")
      f.logo <- max(f.logo, pfms.width)
    }
    if(clabel.leaves>0) f.logo <- f.phylog+f.logo+.01 else f.logo <- f.phylog+.05
  }else{
    if (f.logo > 0.85) f.logo <- 0.85
    if (f.logo < f.phylog) f.logo <- f.phylog+.05 
  }
  subplot <- gList()
  for (i in seq.int(leaves.number)) {
    if(clabel.leaves>0) 
      subplot <- 
        gList(subplot, 
              textGrob(x=xcar, y=y[i], label=leaves.car[i], just = 0, 
                gp=gpar(cex = par("cex") * clabel.leaves),
                default.units = "native"))
    subplot <- gList(subplot, 
                          segmentsGrob(x0=xcar, y0=y[i], x1=xx[i], y1=y[i], 
                                       gp = gpar(col = grey(0.7)), 
                                       default.units = "native"))
    
    if(!is.null(pfms)){
      vpwidth <- vpheight * ncol(pfms[[i]]@mat) / 2
      if(!is.null(pfms[[i]])) 
        if(!is(pfms[[i]], "psam")){
          subplot <- 
            gList(subplot,
                  gTree(children = plotMotifLogoA(pfms[[i]],
                                                  font=font,
                                                  ic.scale=ic.scale,
                                                  draw = FALSE),
                        vp = viewport(x=f.logo, y=y[i],
                                      width=vpwidth,
                                      height=vpheight,
                                      just=c(0, .5))))
        }else{
          subplot <- 
            gList(subplot,
                  gTree(children = plotAffinityLogo(pfms[[i]],
                                                    font=font,
                                                    newpage=FALSE,
                                                    draw = FALSE),
                        vp = viewport(x=f.logo,
                                      y=y[i],
                                      width=vpwidth,
                                      height=vpheight,
                                      just=c(0, .5))))
        }
    }
  }
  rm(list="tmp_motifStack_symbolsCache", envir=.globals)
  
  yleaves <- y[1:leaves.number]
  xleaves <- xx[1:leaves.number]
  if (cleaves > 0) {
    for (i in seq.int(leaves.number)) {
      subplot <- gList(subplot,
                       pointsGrob(x=xx[i], y=y[i], pch = 21,
                                  gp=gpar(fill=1,
                                          cex = par("cex") * cleaves * .5), 
                                   default.units = "native"))
    }
  }
  yn <- rep(0, nodes.number)
  names(yn) <- nodes.names
  y <- c(y, yn)
  for (i in seq_along(phylog$parts)) {
    w <- phylog$parts[[i]]
    but <- names(phylog$parts)[i]
    y[but] <- mean(y[w])
    b <- range(y[w])
    subplot <- gList(subplot,
                     segmentsGrob(x0=xx[but],
                                  y0=b[1],
                                  x1=xx[but],
                                  y1=b[2],
                                  default.units = "native"))
    x1 <- xx[w]
    y1 <- y[w]
    x2 <- rep(xx[but], length(w))
    subplot <- gList(subplot,
                     segmentsGrob(x0=x1,
                                  y0=y1,
                                  x1=x2,
                                  y1=y1, 
                                  default.units = "native"))
  }
  if (cnodes > 0) {
    for (i in nodes.names) {
      subplot <- gList(subplot,
                       pointsGrob(x=xx[i], y=y[i],
                                  pch = 21,
                                  gp=gpar(fill="white", cex = cnodes)))
    }
  }
  if (clabel.nodes > 0) {
    subplot <- gList(subplot,
                     grid.eti(xx[names(x.nodes)],
                              y[names(x.nodes)],
                              nodes.car,
                              clabel.nodes,
                              draw = FALSE))
  }
  if (cleaves > 0){
    subplot <- gList(subplot,
                     pointsGrob(x=xleaves, y=yleaves, pch = 21, 
                                gp = gpar(fill=1, cex = par("cex") * cleaves *.5),
                                default.units = "native"))
  } 
  plot <- gTree(children = subplot, vp = vp)
  suppressWarnings(grid.draw(plot))
  return(invisible(plot))
}

## ----checkplatform, include=FALSE---------------------------------------------
library(knitr)
library(motifStack)
library(MotifDb)
library(ade4)
library(ggplot2)
library(TFBSTools)
library(JASPAR2020)
if(.Platform$OS.type=="windows"){
  opts_chunk$set(eval=FALSE)
}

## ----importMatrix,fig.cap="import data from PFMatrixList",fig.width=6,fig.height=3----
library(motifStack)
library(JASPAR2020)
motifs <- importMatrix(getMatrixSet(JASPAR2020, 
                                    list(species="Mus musculus")))
plot(motifs[[1]])

## ----importFromFiles,fig.cap="import data from file",fig.width=6,fig.height=3----
RUNX1 <- importMatrix(system.file("extdata", "MA0002.1.jaspar",
                                  package = "motifStack",
                                  mustWork = TRUE))[[1]]
plot(RUNX1)

## ----DNAseqLogo,fig.cap="Plot a DNA sequence logo with different fonts and colors",fig.width=8,fig.height=2.5----
library(motifStack)
pcm <- read.table(file.path(find.package("motifStack"), 
                            "extdata", "bin_SOLEXA.pcm"))
pcm <- pcm[,3:ncol(pcm)]
rownames(pcm) <- c("A","C","G","T")
motif <- new("pcm", mat=as.matrix(pcm), name="bin_SOLEXA")
##pfm object
#motif <- pcm2pfm(pcm)
#motif <- new("pfm", mat=motif, name="bin_SOLEXA")
plot(motif)
#plot the logo with same height
plot(motif, ic.scale=FALSE, ylab="probability")
#try a different font and a different color group
motif@color <- colorset(colorScheme='basepairing')
plot(motif,font="serif")

## ----seqLogoMarkers, fig.cap="Plot a DNA sequence logo with markers", fig.width=8,fig.height=2.5----
markerRect <- new("marker", type="rect", start=6, stop=7, gp=gpar(lty=2, fill=NA, col="orange"))
markerLine <- new("marker", type="line", start=2, stop=7, gp=gpar(lwd=2, col="red"))
markerText <- new("marker", type="text", start=c(1, 5), 
                  label=c("*", "core"), gp=gpar(cex=2, col="red"))
motif <- new("pcm", mat=as.matrix(pcm), name="bin_SOLEXA", 
             markers=c(markerRect, markerLine, markerText))
plot(motif)

## ----seqLogoXaxis, fig.cap="Plot a DNA sequence logo with pre-defined xlabels", fig.width=8,fig.height=2.5----
plot(motif, xaxis=paste0("pos", seq.int(7)+10))

## ----RNAseqLogo,fig.cap="Plot an RNA sequence logo",fig.width=6,fig.height=3----
rna <- pcm
rownames(rna)[4] <- "U"
motif <- new("pcm", mat=as.matrix(rna), name="RNA_motif")
plot(motif)

## ----AAseqLogo,fig.cap="Plot an sequence logo with any symbols as you want such as amino acid sequence logo",fig.width=6,fig.height=3----
library(motifStack)
protein<-read.table(file.path(find.package("motifStack"),"extdata","cap.txt"))
protein<-t(protein[,1:20])
motif<-pcm2pfm(protein)
motif<-new("pfm", mat=motif, name="CAP", 
            color=colorset(alphabet="AA",colorScheme="chemistry"))
plot(motif)

## ----affinityLogo,fig.cap="Plot an affinity logo",fig.width=6,fig.height=3----
library(motifStack)
motif<-matrix(
  c(
    .846, .631, .593, .000, .000, .000, .434, .410, 1.00, .655, .284, .000, .000, .771, .640, .961,
    .625, .679, .773, 1.00, 1.00, .000, .573, .238, .397, 1.00, 1.00, .000, .298, 1.00, 1.00, .996,
    1.00, 1.00, 1.00, .228, .000, 1.00, 1.00, .597, .622, .630, .000, 1.00, 1.00, .871, .617, 1.00,
    .701, .513, .658, .000, .000, .247, .542, 1.00, .718, .686, .000, .000, .000, .595, .437, .970
  ), nrow=4, byrow = TRUE)
rownames(motif) <- c("A", "C", "G", "T")
motif<-new("psam", mat=motif, name="affinity logo", 
           markers=list(new("marker", type="rect",
                            start=c(4, 11), stop=c(6, 13),
                            gp=gpar(col="#009E73", fill=NA, lty=2))))
plot(motif)

## ----logostack,fig.cap="Plot motifs with sequence logo stack style",fig.width=4,fig.height=6----
library(motifStack)
#####Input#####
motifs<-importMatrix(dir(file.path(find.package("motifStack"),
                                   "extdata"),"pcm$", 
                         full.names = TRUE))

## plot stacks
motifStack(motifs, layout="stack", ncex=1.0)

## ----rnalogostack,fig.cap="Plot RNA motifs with sequence logo stack style", fig.width=4,fig.height=6----
rnaMotifs <- DNAmotifToRNAmotif(motifs)
names(rnaMotifs)
motifStack(rnaMotifs, layout = "stack", 
           reorder=FALSE) ## we can also use reorder=FALSE to keep the order of input. 

## ----logostack2,fig.cap="Plot affinity logos with sequence logo stack style",fig.width=4,fig.height=3.5----
motif2 <- motif
motif2$mat <- motif$mat[, 5:12]
motif2$name <- "logo2"
psamMotifs <- list(motif, motif2)
motifStack(psamMotifs)

## ----treestack,fig.cap="Sequence logo stack with hierarchical cluster tree",fig.width=5,fig.height=6----
## plot stacks with hierarchical tree
motifStack(motifs, layout="tree")

## ----radialstack,fig.cap="Plot motifs in a radial style when the number of motifs is too much to be shown in a vertical stack",fig.width=6,fig.height=6----
## When the number of motifs is too much to be shown in a vertical stack, 
## motifStack can draw them in a radial style.
## random sample from MotifDb
library("MotifDb")
matrix.fly <- query(MotifDb, "Dmelanogaster")
motifs2 <- as.list(matrix.fly)
## use data from FlyFactorSurvey
motifs2 <- motifs2[grepl("Dmelanogaster\\-FlyFactorSurvey\\-",
                         names(motifs2))]
## format the names
names(motifs2) <- gsub("Dmelanogaster_FlyFactorSurvey_", "",
                       gsub("_FBgn\\d+$", "",
                            gsub("[^a-zA-Z0-9]","_",
                                 gsub("(_\\d+)+$", "", names(motifs2)))))
motifs2 <- motifs2[unique(names(motifs2))]
pfms <- sample(motifs2, 30)
## creat a list of object of pfm 
motifs2 <- mapply(pfms, names(pfms), FUN=function(.ele, .name){
  new("pfm",mat=.ele, name=.name)}, SIMPLIFY = FALSE)
## trim the motifs
motifs2 <- lapply(motifs2, trimMotif, t=0.4)
## setting colors
library(RColorBrewer)
color <- brewer.pal(10, "Set3")
## plot logo stack with radial style
motifStack(motifs2, layout="radialPhylog", 
           circle=0.3, cleaves = 0.2, 
           clabel.leaves = 0.5, 
           col.bg=rep(color, each=3), col.bg.alpha=0.3, 
           col.leaves=rep(color, each=3),
           col.inner.label.circle=rep(color, each=3), 
           inner.label.circle.width=0.05,
           col.outer.label.circle=rep(color, each=3), 
           outer.label.circle.width=0.02, 
           circle.motif=1.2,
           angle=350)

## ----motifCloud,fig.cap="Sequence logo cloud with rectangle packing layout",fig.width=6,fig.height=6----
## assign groups for motifs
groups <- rep(paste("group",1:5,sep=""), each=10)
names(groups) <- names(pfms)
## assign group colors
group.col <- brewer.pal(5, "Set3")
names(group.col)<-paste("group",1:5,sep="")
## create a list of pfm objects
pfms <- mapply(names(pfms), pfms, FUN=function(.ele, .pfm){
  new("pfm",mat=.pfm, name=.ele)}
               ,SIMPLIFY = FALSE)
## use matalign to calculate the distances of motifs
hc <- clusterMotifs(pfms)
## convert the hclust to phylog object
library(ade4)
phylog <- ade4::hclust2phylog(hc)
## reorder the pfms by the order of hclust
leaves <- names(phylog$leaves)
pfms <- pfms[leaves]
## extract the motif signatures
motifSig <- motifSignature(pfms, phylog, cutoffPval=0.0001, min.freq=1)
## draw the motifs with a tag-cloud style.
motifCloud(motifSig, scale=c(6, .5), 
           layout="rectangles", 
           group.col=group.col, 
           groups=groups, 
           draw.legend=TRUE)

## ----motifRadialPhylog,fig.cap="Grouped sequence logo with radialPhylog style layout",fig.width=6,fig.height=6----
## get the signatures from object of motifSignature
sig <- signatures(motifSig)
## set the inner-circle color for each signature
gpCol <- sigColor(motifSig)
## plot the logo stack with radial style.
plotMotifStackWithRadialPhylog(phylog=phylog, pfms=sig, 
                              circle=0.4, cleaves = 0.3, 
                              clabel.leaves = 0.5, 
                              col.bg=rep(color, each=3), col.bg.alpha=0.3, 
                              col.leaves=rep(rev(color), each=3),
                              col.inner.label.circle=gpCol, 
                              inner.label.circle.width=0.03,
                              angle=350, circle.motif=1.2, 
                              motifScale="logarithmic")

## ----motifCircos,fig.cap="Grouped sequence logo with circos style layout",fig.width=6,fig.height=6----
## plot the logo stack with cirsoc style.
motifCircos(phylog=phylog, pfms=pfms, pfms2=sig, 
            col.tree.bg=rep(color, each=5), col.tree.bg.alpha=0.3, 
            col.leaves=rep(rev(color), each=5),
            col.inner.label.circle=gpCol, 
            inner.label.circle.width=0.03,
            col.outer.label.circle=gpCol, 
            outer.label.circle.width=0.03,
            r.rings=c(0.02, 0.03, 0.04), 
            col.rings=list(sample(colors(), 30), 
                           sample(colors(), 30), 
                           sample(colors(), 30)),
            angle=350, motifScale="logarithmic")

## ----motifPilesHeatmap,fig.cap="Grouped sequence logo with a heatmap",fig.width=6,fig.height=6----
## plot the logo stack with heatmap.
df <- data.frame(A=runif(n = 30), B=runif(n = 30), C=runif(n = 30), D=runif(n = 30))
map2col <- function(x, pal){
  rg <- range(x)
  pal[findInterval(x, seq(rg[1], rg[2], length.out = length(pal)+1), 
                   all.inside = TRUE)]
}
dl <- lapply(df, map2col, pal=heat.colors(10))
## alignment of the pfms, this step will make the motif logos occupy 
## more space. Users can skip this alignment to see the difference.
pfmsAligned <- DNAmotifAlignment(pfms)
## plot motifs
motifPiles(phylog=phylog, pfms=pfmsAligned, 
            col.tree=rep(color, each=5),
            col.leaves=rep(rev(color), each=5),
            col.pfms2=gpCol, 
            r.anno=rep(0.02, length(dl)), 
            col.anno=dl,
            motifScale="logarithmic",
            plotIndex=TRUE,
            groupDistance=10)

## ----browseMotifs,fig.width=8,fig.height=8------------------------------------
browseMotifs(pfms = pfms, phylog = phylog, layout="tree", yaxis = FALSE, baseWidth=6, baseHeight = 15)

## ----browseMotifsRadialPhylog,fig.width=8,fig.height=8------------------------
browseMotifs(pfms = pfms, phylog = phylog, layout="radialPhylog", yaxis = FALSE, xaxis = FALSE, baseWidth=6, baseHeight = 15)

## ----geommotif,fig.width=8, fig.height=8--------------------------------------
pcm <- read.table(file.path(find.package("motifStack"), 
                            "extdata", "bin_SOLEXA.pcm"))
pcm <- pcm[,3:ncol(pcm)]
rownames(pcm) <- c("A","C","G","T")
markerRect <- new("marker", type="rect", start=6, stop=7, gp=gpar(lty=2, fill=NA, col="orange"))
markerLine <- new("marker", type="line", start=3, stop=5, gp=gpar(lwd=2, col="red"))
markerText <- new("marker", type="text", start=1, label="*", gp=gpar(cex=2, col="red"))
motif <- new("pcm", mat=as.matrix(pcm), name="bin_SOLEXA", 
             markers=c(markerRect, markerLine, markerText))
pfm <- pcm2pfm(motif)
df <- data.frame(xmin=c(.25, .25), ymin=c(.25, .75), xmax=c(.75, .75), ymax=c(.5, 1), 
                 fontfamily=c("serif", "mono"), fontface=c(2, 1))
df$motif <- list(pfm, pfm)

library(ggplot2)

ggplot(df, aes(xmin=xmin, ymin=ymin, xmax=xmax, ymax=ymax, motif=motif, 
               fontfamily=fontfamily, fontface=fontface)) + 
    geom_motif() + theme_bw() + ylim(0, 1) + xlim(0, 1)

df <- data.frame(x=.5, y=c(.25, .75), width=.5, height=.25, 
                 fontfamily=c("serif", "mono"), fontface=c(2, 1))
df$motif <- list(pfm, pfm)

ggplot(df, aes(x=x, y=y, width=width, height=height, motif=motif, 
               fontfamily=fontfamily, fontface=fontface)) + 
    geom_motif(use.xy=TRUE) + theme_bw() + ylim(0, 1) + xlim(0, 1)

## ----sessionInfo--------------------------------------------------------------
sessionInfo()

#' Class \code{ouNode}
#' 
#' An object of class \code{"ouNode"} represents a motif node in a cluster tree
#' 
#' 
#' @name ouNode-class
#' @aliases ouNode ouNode-class $,ouNode-method $<-,ouNode-method
#' @docType class
#' @section Objects from the Class: Objects can be created by calls of the form
#' \code{new("ouNode", left, right, parent, distl, distr, sizel, sizer)}.
#' @keywords classes
#' @export
#' @import methods
#' @examples
#' 
#'  new("ouNode", left="A", right="B", parent="Root", distl=1, distr=2, sizel=1, sizer=1)
#' 

setClass("ouNode", representation(left="character", 
                                  right="character", 
                                  parent="character", 
                                  distl="numeric", 
                                  distr="numeric",
                                  sizel="numeric",
                                  sizer="numeric"))
#' @rdname ouNode-class
#' @docType methods
#' @param x A ouNode object
#' @param name slot name of ouNode object
#' @exportMethod `$` `$<-`
setMethod("$", "ouNode", function(x, name) slot(x, name))
setReplaceMethod("$", "ouNode",
                 function(x, name, value){
                     slot(x, name, check = TRUE) <- value
                     x
                 })

#' Class \code{"motifSig"}
#' 
#' An object of class \code{"motifSig"} represents the output of function
#' \link{motifSignature}
#' 
#' 
#' @name motifSig-class
#' @aliases motifSig
#' @docType class
#' @section Objects from the Class: Objects can be created by calls of the form
#' \code{new("motifSig", signature, freq, nodelist, gpcol)}.
#' @keywords classes
#' @export
setClass("motifSig", representation(signatures="list", freq="numeric", 
                                    nodelist="list", gpcol="character"),
         validity=function(object){
             re<-TRUE
             if (any(unlist(lapply(object@nodelist, function(.ele) !inherits(.ele, "ouNode"))))) re<-"nodelist must be a list of ouNode objects"
             if (any(unlist(lapply(object@signatures, function(.ele) !inherits(.ele, "pfm"))))) re<-"signatures must be a list of pfm objects"
             if (length(object@signatures) != length(object@freq)) re<-"ength of signatures should be same as freq"
             re
         }
)

#' "motifSig" methods
#' 
#' methods for motifSig objects.
#' 
#' 
#' @rdname motifSig-class
#' @aliases signatures signatures,motifSig-method frequence
#' @docType methods
#' @param object An object of class \code{motifSig}.
#' @section Methods: \describe{ \item{signatures}{\code{signature(object =
#' "motifSig")} return the signatures of motifSig }
#' 
#' \item{frequence}{\code{signature(object = "motifSig")} return the frequency
#' of motifSig}
#' 
#' \item{nodelist}{\code{signature(object = "motifSig")} return the nodelist of
#' motifSig}
#' 
#' \item{sigColor}{\code{signature(object = "motifSig")} return the group color
#' sets of motifSig}
#' 
#' \item{$, $<-}{Get or set the slot of \code{\link{motifSig}}} }
#' @keywords classes
#' @exportMethod signatures
setGeneric("signatures", function(object) standarGeneric("signatures"))
setMethod("signatures", signature(object="motifSig"), function(object) object@signatures)

#' @rdname motifSig-class
#' @exportMethod frequence
#' @aliases frequence,motifSig-method
setGeneric("frequence", function(object) standarGeneric("frequence"))
setMethod("frequence", signature(object="motifSig"), function(object) object@freq)

#' @rdname motifSig-class
#' @exportMethod nodelist
#' @aliases nodelist nodelist,motifSig-method
setGeneric("nodelist", function(object) standarGeneric("nodelist"))
setMethod("nodelist", signature(object="motifSig"), function(object) object@nodelist)

#' @rdname motifSig-class
#' @exportMethod sigColor
#' @aliases sigColor sigColor,motifSig-method
setGeneric("sigColor", function(object) standarGeneric("sigColor"))
setMethod("sigColor", signature(object="motifSig"), function(object) object@gpcol)

#' @rdname motifSig-class
#' @exportMethod `$` `$<-`
#' @param x A motifSig object
#' @param name slot name of motifSig object
#' @aliases $,motifSig-method $<-,motifSig-method
setMethod("$", "motifSig", function(x, name) slot(x, name))
setReplaceMethod("$", "motifSig",
                 function(x, name, value){
                     slot(x, name, check = TRUE) <- value
                     x
                 })

#' Plot stacked logos for single or multiple DNA, RNA and amino acid sequence
#' 
#' motifStack is a package that is able to draw amino acid sequence as easy as
#' to draw DNA/RNA sequence. motifStack provides the flexibility for users to
#' select the font type and symbol colors. motifStack is designed for graphical
#' representation of multiple motifs.
#' 
#' 
#' @name motifStack-package
#' @aliases motifStack-package
#' @docType package
#' @author Jianhong Ou and Lihua Julie Zhu
#' 
#' Maintainer: Jianhong Ou <jianhong.ou@@umassmed.edu>
#' @keywords package
"_PACKAGE"

#' plot sequence logo stacks with a radial phylogenic tree and multiple color
#' rings
#' 
#' plot sequence logo stacks with a radial phylogenic tree and multiple color
#' rings. The difference from plotMotifStackWithRadialPhylog is that it has
#' more color setting and one more group of pfms.
#' 
#' 
#' @param phylog an object of class phylog
#' @param pfms a list of objects of class pfm
#' @param pfms2 a list of objects of class pfm
#' @param R radius of canvas
#' @param r.tree half width of the tree
#' @param col.tree.bg a vector of colors for tree background
#' @param col.tree.bg.alpha a alpha value [0, 1] of colors for tree background
#' @param cnodes a character size for plotting the points that represent the
#' nodes, used with par("cex")*cnodes. If zero, no points are drawn
#' @param labels.nodes a vector of strings of characters for the nodes labels
#' @param clabel.nodes a character size for the nodes labels, used with
#' par("cex")*clabel.nodes. If zero, no nodes labels are drawn
#' @param r.leaves width of the leaves
#' @param cleaves a character size for plotting the points that represent the
#' leaves, used with par("cex")*cleaves. If zero, no points are drawn
#' @param labels.leaves a vector of strings of characters for the leaves labels
#' @param clabel.leaves a character size for the leaves labels, used with
#' par("cex")*clavel.leaves
#' @param col.leaves a vector of colors for leaves labels
#' @param col.leaves.bg a vector of colors for background of leaves labels
#' @param col.leaves.bg.alpha alpha value [0, 1] for the colors of backgroud of
#' leaves labels
#' @param r.pfms width of the pfms
#' @param r.pfms2 width of the pfms2
#' @param r.rings a vector of width of color rings
#' @param col.rings a list of color rings
#' @param col.inner.label.circle a vector of colors for inner cirlce of pfms
#' @param inner.label.circle.width width for inner circle of pfms
#' @param col.outer.label.circle a vector of colors for outer circle of pfms
#' @param outer.label.circle.width width for outer circle of pfms
#' @param draw.box if TRUE draws a box around the current plot with the
#' function box()
#' @param clockwise a logical value indicating if slices are drawn clockwise or
#' counter clockwise
#' @param init.angle number specifying the starting angle (in degrees) for the
#' slices. Defaults to 0 (i.e., `3 o'clock`) unless clockwise is true where
#' init.angle defaults to 90 (degrees), (i.e., `12 o'clock`)
#' @param angle number specifying the angle (in degrees) for phylogenic tree.
#' Defaults 360
#' @param pfmNameSpliter spliter when name of pfms/pfms2 contain multiple node
#' of labels.leaves
#' @param rcpostfix the postfix for reverse complements
#' @param motifScale the scale of logo size
#' @param ic.scale logical. If TRUE, the height of each column is proportional
#' to its information content. Otherwise, all columns have the same height.
#' @param plotIndex logical. If TRUE, will plot index number in the motifLogo
#' which can help user to describe the motifLogo
#' @param IndexCol The color of the index number when plotIndex is TRUE.
#' @param IndexCex The cex of the index number when plotIndex is TRUE.
#' @param groupDistance show groupDistance on the draw
#' @param groupDistanceLineCol groupDistance line color, default: red
#' @param plotAxis logical. If TRUE, will plot distance axis.
#' @return none
#' @author Jianhong Ou
#' @seealso \code{\link{plotMotifStackWithRadialPhylog}}
#' @keywords misc
#' @export
#' @importFrom graphics par plot.default strwidth polygon text segments
#' points lines symbols box
#' @importFrom grDevices grey dev.size
#' @importFrom stats median
#' @importFrom grid pushViewport viewport popViewport grid.text gpar grid.xaxis
#' @examples
#' 
#' if(interactive() || Sys.getenv("USER")=="jianhongou"){
#'     library("MotifDb")
#'     matrix.fly <- query(MotifDb, "Dmelanogaster")
#'     motifs <- as.list(matrix.fly)
#'     motifs <- motifs[grepl("Dmelanogaster-FlyFactorSurvey-", 
#'                             names(motifs), fixed=TRUE)]
#'     names(motifs) <- gsub("Dmelanogaster_FlyFactorSurvey_", "", 
#'                 gsub("_FBgn[0-9]+$", "", 
#'                   gsub("[^a-zA-Z0-9]","_", 
#'                      gsub("(_[0-9]+)+$", "", names(motifs)))))
#'     motifs <- motifs[unique(names(motifs))]
#'     pfms <- sample(motifs, 50)
#'     hc <- clusterMotifs(pfms)
#'     library(ade4)
#'     phylog <- ade4::hclust2phylog(hc)
#'     leaves <- names(phylog$leaves)
#'     pfms <- pfms[leaves]
#'     pfms <- mapply(pfms, names(pfms), FUN=function(.ele, .name){
#'                  new("pfm",mat=.ele, name=.name)})
#'     pfms <- DNAmotifAlignment(pfms, minimalConsensus=3)
#'     library(RColorBrewer)
#'     color <- brewer.pal(12, "Set3")
#'     motifCircos(phylog, pfms, cleaves = 0.5, clabel.leaves = 0.7, 
#'                      col.tree.bg=rep(color, each=5), 
#'                      col.leaves=rep(color, each=5),
#'                       r.rings=c(0.02, 0.03, 0.04), 
#'                       col.rings=list(sample(colors(), 50), 
#'                                      sample(colors(), 50), 
#'                                      sample(colors(), 50)))
#'   }
#' 
motifCircos <- function (phylog, pfms=NULL, pfms2=NULL, R=2.5,
                         r.tree=1, col.tree.bg=NULL, col.tree.bg.alpha=1,
                         cnodes=0, labels.nodes=names(phylog$nodes), 
                         clabel.nodes=0,
                         r.leaves=NA,
                         cleaves=1, labels.leaves=names(phylog$leaves), 
                         clabel.leaves=1,
                         col.leaves=rep("black", length(labels.leaves)),
                         col.leaves.bg=NULL, col.leaves.bg.alpha=1,
                         r.pfms=NA, r.pfms2=NA,
                         r.rings=0, col.rings=list(),
                         col.inner.label.circle=NULL,
                         inner.label.circle.width=0.02,
                         col.outer.label.circle=NULL, 
                         outer.label.circle.width=0.02,
                         draw.box=FALSE,
                         clockwise =FALSE, init.angle=if(clockwise) 90 else 0,
                         angle=360, pfmNameSpliter=";", rcpostfix="(RC)", 
                         motifScale=c("linear","logarithmic","none"),
                         ic.scale=TRUE,
                         plotIndex=FALSE, IndexCol="black", IndexCex=.8,
                         groupDistance=NA, groupDistanceLineCol="red", 
                         plotAxis=FALSE)
{#TODO: change all graphics function to grid function
    if (!inherits(phylog, "phylog"))
        stop("Non convenient data")
    leaves.number <- length(phylog$leaves)
    checkLength <- function(tobechecked){
        !((length(tobechecked)>=leaves.number)||is.null(tobechecked))
    }
    checkNA <- function(tobechecked){
        if(is.null(tobechecked)) return(FALSE)
        return(any(is.na(tobechecked)))
    }
    for(tobechecked in c("col.leaves", "col.leaves.bg", "col.tree.bg", 
                         "col.inner.label.circle", "col.outer.label.circle")){
        if(checkLength(eval(as.symbol(tobechecked)))) {
            stop(paste("the length of", tobechecked, 
                       "should be same as the length of leaves"))
            }
        if(checkNA(eval(as.symbol(tobechecked)))) {
            stop(paste("contain NA in", tobechecked))
            }
    }
    if(length(r.rings)>length(col.rings)){
        if(r.rings!=0 & length(r.rings)!=1){
            stop("length of col.rings must be same as r.rings you input")
        }
    }
    if(length(col.rings)>0){
        if(!is(col.rings, "list")) stop("col.rings must be a object of list")
        for(i in 1:length(col.rings)){
            if(checkLength(col.rings[[i]])) {
                stop(paste("the length of col.rings[[", i,
                           "]]should be same as the length of leaves"))
            }
            if(checkNA(col.rings[[i]])) {
                stop(paste("contain NA in col.rings[[", i, "]]"))
            }
        }
    }
    motifScale <- match.arg(motifScale)
    leaves.names <- names(phylog$leaves)
    nodes.number <- length(phylog$nodes)
    nodes.names <- names(phylog$nodes)
    if (length(labels.leaves) != leaves.number)
        labels.leaves <- names(phylog$leaves)
    if (length(labels.nodes) != nodes.number)
        labels.nodes <- names(phylog$nodes)
    if (r.tree < 0)
        stop("'r.tree': non convenient value")
    leaves.car <- gsub("[_]", " ", labels.leaves)
    nodes.car <- gsub("[_]", " ", labels.nodes)
    opar <- par(mar = par("mar"), srt = par("srt"))
    on.exit(par(opar))
    par(mar = c(0.1, 0.1, 0.1, 0.1), mfrow=c(1,1))
    dis <- phylog$droot
    max_Dis <- max(dis)
    axis_pos <- r.tree
    if(!is.na(groupDistance)){
        groupDistance <- (max_Dis - groupDistance) * r.tree / max_Dis
    }
    dis <- dis/max_Dis
    dis <- dis * r.tree
    dist.leaves <- dis[leaves.names]
    dist.nodes <- dis[nodes.names]
    asp <- c(1, 1)
    pin <- dev.size("in")
    if (pin[1L] > pin[2L]){
        asp <- c(pin[2L]/pin[1L], 1)
    }else{
        asp <- c(1, pin[1L]/pin[2L])
    }
    plot.default(0, 0, type = "n", asp=1, xlab = "", ylab = "",
                 xaxt = "n", yaxt = "n", xlim = c(-1*R, R), ylim = c(-1*R, R),
                 xaxs = "i", yaxs = "i", frame.plot = FALSE)
    r.rayon <- r.tree/(nodes.number - 1)
    twopi <- if (clockwise) -2 * pi else 2 * pi
    alpha <-
        twopi * angle * (1:leaves.number)/leaves.number/360 + 
        init.angle * pi/180
    names(alpha) <- leaves.names
    x <- dist.leaves * cos(alpha)
    y <- dist.leaves * sin(alpha)
    xcar <- (r.tree + r.rayon) * cos(alpha)
    ycar <- (r.tree + r.rayon) * sin(alpha)
    
    r.rings.tot <- sum(r.rings)
    if(!inherits(r.leaves, c("numeric", "integer"))) 
        r.leaves <- max(unlist(lapply(leaves.names, strwidth, units="user",
                                      cex=clabel.leaves)))
    ##for logos position
    w.pfms <- r.tree + r.rayon + r.leaves + r.rings.tot + 
        inner.label.circle.width
    twoR <- 2*R
    beta <- alpha * 180 / pi
    if(!is.null(pfms)){
        vpheight <- 2 * pi * angle * w.pfms / 360 / leaves.number / twoR
        vpheight <- vpheight * asp[2L]
        xm <- w.pfms * cos(alpha) * asp[1L] / twoR + 0.5
        ym <- w.pfms * sin(alpha) * asp[2L] / twoR + 0.5
        if(!inherits(r.pfms, c("numeric", "integer"))){
            r.pfms <- 0
            pfmNamesLen <- sapply(pfms, function(.ele) 
                length(strsplit(.ele@name, pfmNameSpliter)[[1]]))
            if(motifScale=="linear"){
                vph <- R*vpheight*pfmNamesLen
            }else {
              if(motifScale=="logarithmic"){
                vph <- R*vpheight*(1+log2(pfmNamesLen+0.0001))
              }else{
                vph <- rep(R*vpheight, length(pfmNamesLen))
              }
            }
            r.pfms <- 
                max(mapply(function(.ele, f) ncol(.ele@mat)*f, pfms, vph))
        }
    }
    if(!inherits(r.pfms, c("numeric", "integer"))) r.pfms <- 0
    
    w.pfms2 <- w.pfms + r.pfms + outer.label.circle.width
    if(!is.null(pfms2)){
        vpheight2 <- 2 * pi * angle * w.pfms2 / 360 / leaves.number / twoR
        vpheight2 <- vpheight2 * asp[2L]
        xm2 <- w.pfms2 * cos(alpha) * asp[1L] / twoR + 0.5
        ym2 <- w.pfms2 * sin(alpha) * asp[2L] / twoR + 0.5
        if(!inherits(r.pfms2, c("numeric", "integer"))){
            r.pfms2 <- 0
            pfmNamesLen <- sapply(pfms2, function(.ele) 
                length(strsplit(.ele@name, pfmNameSpliter)[[1]]))
            if(motifScale=="linear"){
              vph <- R*vpheight2*pfmNamesLen
            }else{
              if(motifScale=="logarithmic"){
                vph <- R*vpheight2*(1+log2(pfmNamesLen+0.0001))
              }else{
                vph <- rep(R*vpheight2, length(pfmNamesLen))
              }
            } 
            r.pfms2 <- 
                max(mapply(function(.ele, f) ncol(.ele@mat)*f, pfms2, vph))
        }
    }
    if(!inherits(r.pfms2, c("numeric", "integer"))) r.pfms2 <- 0
    
    ratio <- R/(w.pfms2+r.pfms2)
    
    if(ratio < 1){
        x <- x * ratio
        y <- y * ratio
        xcar <- xcar * ratio
        ycar <- ycar * ratio
        dis <- dis * ratio
        groupDistance <- groupDistance * ratio
        if(!is.null(pfms)) {
            xm <- (xm-.5) * ratio + .5
            ym <- (ym-.5) * ratio + .5
            vpheight <- vpheight * ratio
        }
        if(!is.null(pfms2)) {
            xm2 <- (xm2-.5) * ratio + .5
            ym2 <- (ym2-.5) * ratio + .5
            vpheight2 <- vpheight2 * ratio
        }
        axis_pos <- axis_pos * ratio
        r.rings <- r.rings * ratio
        r.tree <- r.tree * ratio
        r.rayon <- r.rayon * ratio
        r.leaves <- r.leaves * ratio
        inner.label.circle.width <- inner.label.circle.width * ratio
        outer.label.circle.width <- outer.label.circle.width * ratio
        w.pfms <- w.pfms * ratio
        w.pfms2 <- w.pfms2 * ratio
        cleaves <- cleaves * ratio
        clabel.leaves <- clabel.leaves * ratio
        cnodes <- cnodes * ratio
        clabel.nodes <- clabel.nodes * ratio
        dist.leaves <- dist.leaves * ratio
        IndexCex <- IndexCex * ratio
    }else{
        ratio <- 1
    }
    ##for plot background
    gamma <- 
        twopi * angle * ((1:(leaves.number+1))-0.5)/leaves.number/360 +
        init.angle * pi/180
    n <- max(2, floor(200*360/leaves.number))
    plotBgArc <- function(r,bgcol,inr=0){
        t2xy <- function(rx, t, rx2=0) list(x=c(rx*cos(t), rx2*cos(rev(t))),
                                    y=c(rx*sin(t), rx2*sin(rev(t))))
        oldcol <- bgcol[1]
        start <- 1
        icnt <- 1
        for(i in 1:leaves.number){
            oldcol <- bgcol[i]
            if(i==leaves.number || bgcol[i+1]!=oldcol){
                P <- t2xy(r, seq.int(gamma[start], gamma[start+icnt], 
                                     length.out=n*icnt), inr)
                polygon(P$x, P$y, border=bgcol[i], col=bgcol[i])
                start <- i+1
                icnt <- 1
            } else {
                icnt <- icnt + 1
            }
        }
    }
    if(!is.null(col.outer.label.circle)) ##plot outer.label.circle
        plotBgArc(w.pfms2, col.outer.label.circle, 
                  w.pfms2-outer.label.circle.width)
    if(!is.null(col.inner.label.circle)) #plot inner.label.circle
        plotBgArc(w.pfms, col.inner.label.circle, 
                  w.pfms-inner.label.circle.width)
    if(!is.null(col.tree.bg)) col.tree.bg <- 
        highlightCol(col.tree.bg, col.tree.bg.alpha)
    if(!is.null(col.leaves.bg)) col.leaves.bg <-
        highlightCol(col.leaves.bg, col.leaves.bg.alpha)
    if(!is.null(col.tree.bg)) ##plot center bg
        plotBgArc(ifelse(mean(dist.leaves)/max(dis) > .9,
                         mean(dist.leaves), max(dis)-r.rayon), 
                  col.tree.bg, 0)
    if(!is.null(col.leaves.bg)) ##plot leaves bg
        plotBgArc(r.tree + r.rayon + r.leaves, col.leaves.bg, r.tree + r.rayon)
    if(r.rings.tot>0){
        r.rings.diff <- c(0, 0, cumsum(r.rings[-length(r.rings)]))
        r.rings <- r.tree + r.rayon + r.leaves + c(0, r.rings) + r.rings.diff
        for(i in 2:length(r.rings)){
            plotBgArc(r.rings[i], col.rings[[i-1]], r.rings[i-1])
        }
    }
    #axis(1, pos=0)
    #axis(2, pos=0)
    if (clabel.leaves > 0) {
        for(i in 1:leaves.number) {
            par(srt = alpha[i] * 180/pi)
            text(xcar[i], ycar[i], leaves.car[i], adj = 0,
                 col=col.leaves[i], cex = par("cex") *
                     clabel.leaves)
            segments(xcar[i], ycar[i], x[i], y[i], col = grey(0.7))
        }
        
        assign("tmp_motifStack_symbolsCache", list(), envir=.globals)
        for(metaChar in c("\\","$","*","+",".","?",
                          "[","]","^","{","}","|","(",")"))
        {
            rcpostfix <- gsub(metaChar,paste("\\",metaChar,sep=""),
                              rcpostfix,fixed=TRUE)
        }
        drawPFMcir <- function(pfms, xm, ym, vpheight, .plotIndex){
            ##extract names
            pfmNames <- lapply(pfms, function(.ele) .ele@name)
            for(i in 1:length(pfmNames)){
                pfmname <- unlist(strsplit(pfmNames[[i]], pfmNameSpliter))
                pfmname <- gsub(paste(rcpostfix,"$",sep=""),"",pfmname)
                pfmIdx <- which(makeLeaveNames(labels.leaves) %in% 
                                    makeLeaveNames(pfmname))
                if(length(pfmIdx)==0) 
                    pfmIdx <- which(makeLeaveNames(names(phylog$leaves)) 
                                    %in% makeLeaveNames(pfmname))
                if(length(pfmIdx)>0){
                    vph <- ifelse(motifScale=="linear",
                                  vpheight*length(pfmname),
                                  ifelse(motifScale=="logarithmic", 
                                         vpheight*(1+log2(length(pfmname))),
                                         vpheight))
                    vpw <- vph * ncol(pfms[[i]]@mat) / 2
                    vpd <- sqrt(vph*vph+vpw*vpw) / 2
                    angle <- median(beta[pfmIdx])
                    if(length(pfmIdx)%%2==1){
                        this.pfmIdx <- which(beta[pfmIdx] == angle)[1]
                        vpx <- xm[pfmIdx[this.pfmIdx]] + 
                            vpd * cos(alpha[pfmIdx[this.pfmIdx]]) * asp[1L]
                        vpy <- ym[pfmIdx[this.pfmIdx]] + 
                            vpd * sin(alpha[pfmIdx[this.pfmIdx]]) * asp[2L]
                        vpx1 <- xm[pfmIdx[this.pfmIdx]] - 
                            inner.label.circle.width * 
                            cos(alpha[pfmIdx[this.pfmIdx]]) * 
                            asp[1L] *1.1/twoR
                        vpy1 <- ym[pfmIdx[this.pfmIdx]] - 
                            inner.label.circle.width * 
                            sin(alpha[pfmIdx[this.pfmIdx]]) * 
                            asp[2L] *1.1/twoR
                    }else{
                        this.pfmIdx <- order(abs(beta[pfmIdx] - angle))[1:2]
                        vpx <- median(xm[pfmIdx[this.pfmIdx]]) + 
                            vpd * cos(median(alpha[pfmIdx[this.pfmIdx]])) * 
                            asp[1L]
                        vpy <- median(ym[pfmIdx[this.pfmIdx]]) + 
                            vpd * sin(median(alpha[pfmIdx[this.pfmIdx]])) *
                            asp[2L]
                        vpx1 <- median(xm[pfmIdx[this.pfmIdx]]) - 
                            inner.label.circle.width * 
                            cos(median(alpha[pfmIdx[this.pfmIdx]])) * 
                            asp[1L] *1.1/twoR
                        vpy1 <- median(ym[pfmIdx[this.pfmIdx]]) - 
                            inner.label.circle.width * 
                            sin(median(alpha[pfmIdx[this.pfmIdx]])) * 
                            asp[2L] *1.1/twoR
                    }
                    pushViewport(viewport(x=vpx, y=vpy, width=vpw, 
                                          height=vph, angle=angle))
                    plotMotifLogoA(pfms[[i]], ic.scale=ic.scale)
                    popViewport()
                    if(.plotIndex) {
                        grid.text(label=i, x=vpx1, 
                                  y=vpy1, 
                                  gp=gpar(col=IndexCol, cex=IndexCex), 
                                  rot=angle, just="right")
                    }
                }else{
                    warning(paste("No leave named as ",
                                  paste(pfmname, collapse=", ")), 
                            sep="")
                }
            }
        }
        if(!is.null(pfms)){
            drawPFMcir(pfms, xm, ym, vpheight, plotIndex[1])
        }
        if(!is.null(pfms2)){
            if(length(plotIndex)<2) plotIndex[2] <- plotIndex[1]
            drawPFMcir(pfms2, xm2, ym2, vpheight2, plotIndex[2])
        }
        
        rm(list="tmp_motifStack_symbolsCache", envir=.globals)
    }
    if (cleaves > 0) {
        for (i in 1:leaves.number) points(x[i], y[i], pch = 21,
                                          col=col.leaves[i],
                                          bg = col.leaves[i], 
                                          cex = par("cex") * cleaves)
    }
    ang <- rep(0, length(dist.nodes))
    names(ang) <- names(dist.nodes)
    ang <- c(alpha, ang)
    for (i in 1:length(phylog$parts)) {
        w <- phylog$parts[[i]]
        but <- names(phylog$parts)[i]
        ang[but] <- mean(ang[w])
        b <- range(ang[w])
        a.seq <- c(seq(b[1], b[2], by = pi/180), b[2])
        lines(dis[but] * cos(a.seq), dis[but] * sin(a.seq), 
              col="#222222", lwd=par("cex") * clabel.leaves)
        x1 <- dis[w] * cos(ang[w])
        y1 <- dis[w] * sin(ang[w])
        x2 <- dis[but] * cos(ang[w])
        y2 <- dis[but] * sin(ang[w])
        segments(x1, y1, x2, y2, col="#222222", lwd=par("cex") * clabel.leaves)
    } 
    if(!is.na(groupDistance)){
        if(length(groupDistanceLineCol)!=length(groupDistance)){
            groupDistanceLineCol <- 
                rep(groupDistanceLineCol, 
                    ceiling(length(groupDistance)/
                                length(groupDistanceLineCol
                                       )))[seq_along(groupDistance)]
        }
        for(i in 1:length(groupDistance)){
            if(groupDistance[i] > 0)
                symbols(x=0, y=0, circles=groupDistance[i],
                        fg=groupDistanceLineCol[i], lty=2, 
                        inches=FALSE, add=TRUE)
        }
    }
    if (cnodes > 0) {
        for (i in 1:length(phylog$parts)) {
            w <- phylog$parts[[i]]
            but <- names(phylog$parts)[i]
            ang[but] <- mean(ang[w])
            points(dis[but] * cos(ang[but]), dis[but] * sin(ang[but]),
                   pch = 21, bg = "white", cex = par("cex") * cnodes)
        }
    }
    
    ## draw distance indix  
    if(plotAxis){
        wd <- twoR
        if(clockwise){
            vp <- viewport(x=0.5, y=0.5, width=axis_pos/wd, height=.1, 
                           xscale=c(0, max_Dis), angle=init.angle, just=c(0, 0))
            pushViewport(vp)
            grid.xaxis(gp=gpar(cex = par("cex") * clabel.leaves, 
                               col="lightgray"),
                       main=TRUE)
            popViewport()
        }else{
            vp <- viewport(x=0.5, y=0.5, width=axis_pos/wd, height=.1, 
                           xscale=c(0, max_Dis), angle=init.angle, just=c(0, 1))
            pushViewport(vp)
            grid.xaxis(gp=gpar(cex = par("cex") * clabel.leaves, 
                               col="lightgray"),
                       main=FALSE)
            popViewport()
        }
    }
    
    points(0, 0, pch = 21, cex = par("cex") * 2 * ratio * clabel.leaves, 
           bg = "red")
    if (clabel.nodes > 0) {
        delta <- strwidth(as.character(length(dist.nodes)), cex = par("cex") *
                              clabel.nodes)
        for (j in 1:length(dist.nodes)) {
            i <- names(dist.nodes)[j]
            par(srt = (ang[i] * 360/2/pi + 90))
            x1 <- dis[i] * cos(ang[i])
            y1 <- dis[i] * sin(ang[i])
            symbols(x1, y1, delta, bg = "white", add = TRUE,
                    inches = FALSE)
            text(x1, y1, nodes.car[j], adj = 0.5, cex = par("cex") *
                     clabel.nodes)
        }
    }
    
    if (draw.box)
        box()
    return(invisible())
}

#' convert DNA motif into RNA motif
#'
#' convert DNA motif into RNA motif
#' @param pfm An object of "pcm" or "pfm"
#' @return An object of "pcm" or "pfm" of RNA motif
#' @export
#' @examples 
#' motifs<-importMatrix(dir(file.path(find.package("motifStack"),
#'                          "extdata"),"pcm$", full.names = TRUE))
#' rnaMotifs <- DNAmotifToRNAmotif(motifs)
DNAmotifToRNAmotif <- function(pfm){
  if(is.list(pfm)){
    return(lapply(pfm, DNAmotifToRNAmotif))
  }
  stopifnot(inherits(pfm, c("pcm", "pfm")))
  pfm@alphabet <- "RNA"
  rn <- rownames(pfm@mat)
  rn[rn=="T"] <- "U"
  rownames(pfm@mat) <- rn
  pfm@background["U"] <- pfm@background["T"]
  pfm@background <- pfm@background[rownames(pfm@mat)]
  pfm@color["U"] <- pfm@color["T"]
  pfm@color <- pfm@color[rownames(pfm@mat)]
  pfm
}

#' plot sequence logos stack with hierarchical cluster tree
#' 
#' plot sequence logos stack with hierarchical cluster tree
#' 
#' 
#' @param pfms a list of position frequency matrices, pfms must be a list of
#' class pfm
#' @param hc an object of the type produced by stats::hclust
#' @param treewidth the width to show tree
#' @param trueDist logical flags to use hclust height or not.
#' @param ... other parameters can be passed to plotMotifLogo function
#' @return none
#' @export
#' @importFrom grid grid.newpage grid.lines viewport pushViewport convertUnit 
#' unit grid.text popViewport
#' @examples
#' 
#'   #####Input#####
#'   pcms<-readPCM(file.path(find.package("motifStack"), "extdata"),"pcm$")
#' 
#'   #####Clustering#####
#'   hc <- clusterMotifs(pcms)
#' 
#'   ##reorder the motifs for plotMotifLogoStack
#'   motifs<-pcms[hc$order]
#'   motifs <- lapply(motifs, pcm2pfm)
#'   ##do alignment
#'   motifs<-DNAmotifAlignment(motifs)
#'   ##plot stacks
#'   plotMotifLogoStack(motifs, ncex=1.0)
#'   plotMotifLogoStackWithTree(motifs, hc=hc)
#' 
plotMotifLogoStackWithTree<-function(pfms, hc, treewidth=1/8, trueDist=FALSE, ...){
  n<-length(pfms)
  if(all(sapply(pfms, function(.ele) is(.ele, "pcm")))) {
    pfms <- lapply(pfms, pcm2pfm)
  }
  lapply(pfms,function(.ele){
    if(!inherits(.ele, c("pfm", "psam"))) stop("pfms must be a list of pfm or psam objects")
  })
  if(!is(hc, "hclust")) stop("hc must be hclust object")
  if(treewidth>0.5) stop("treewidth can not greater than 0.5")
  #opar<-par(mar=c(0,0,0,0), mfrow=par("mfrow"))
  #layout(matrix(c(rep(1,n),rep(2:(n+1),ceiling(1/treewidth)-1)),nrow=n,ncol=ceiling(1/treewidth)))
  #plot tree
  
  dots <- list(...)
  if(is.null(dots$draw)) dots$draw <- TRUE
  if(is.null(dots$newpage)) dots$newpage <- TRUE
  
  if(trueDist) h <- hc$height / max(hc$height) / 1.05
  else h<- seq(0.01, 0.95, length.out=length(hc$height))[order(hc$height)]
  m <- hc$merge
  o <- hc$order
  
  m[m > 0] <- n + m[m > 0] 
  m[m < 0] <- abs(m[m < 0])
  
  dist <- matrix(0, nrow = 2 * n - 1, ncol = 2, dimnames = list(NULL, c("x", "y"))) 
  dist[1:n, 2] <- 1 / n / 2 + (1 / n) * (match(1:n, o) - 1)
  
  for(i in 1:nrow(m)){
    dist[n + i, 2] <- (dist[m[i, 1], 2] + dist[m[i, 2], 2]) / 2
    dist[n + i, 1] <- h[i]
  }
  
  trx <- function(x) 0.9*treewidth*(1 - x)+ 0.01
  for(i in 1:nrow(dist)){
    dist[i, 1] <- trx(dist[i, 1])
    #dist[i, 2] <- dist[i, 2] + 1/(4*n)
  }
  
  draw_connection <- function(x1, x2, y1, y2, x){
    gList(
      linesGrob(x = c(x1, x), y = c(y1, y1)),
      linesGrob(x = c(x2, x), y = c(y2, y2)),
      linesGrob(x = c(x, x), y = c(y1, y2))
    )
  }
  plot <- gList()
  for(i in 1:nrow(m)){
    plot <- gList(plot, 
                  draw_connection(dist[m[i, 1], 1],
                                  dist[m[i, 2], 1],
                                  dist[m[i, 1], 2],
                                  dist[m[i, 2], 2], trx(h[i])))
  }
  
  #plot logo
  subplots <- gList()
  if(all(sapply(pfms, function(.ele) is(.ele, "psam")))){
    .local <- function(..., newpage, draw){
      plotAffinityLogo(..., newpage = FALSE, draw = FALSE)
    }
    ht <- 1/n
    y0 <- .5 * ht
    for(i in seq.int(n)){
      ht.title <- convertUnit(unit(1.5, "lines"), unitTo = "npc", valueOnly = TRUE)
      ht.body <- 1 - ht.title
      plotsub <- gTree(children = .local(psam=pfms[[i]], ...), 
                       vp = viewport(y=ht.body*.5, height=ht.body))
      subplots <- gList(subplots, 
                    gTree(children = gList(textGrob(label=pfms[[i]]@name,
                                                     y=1-.5*ht.title),
                                           plotsub),
                          vp = viewport(y=y0, height=ht)))
      y0 <- y0 + ht
    }
  }else{
    lapply(pfms,function(.ele){
      if(!is(.ele, "pfm")) stop("pfms must be a list of pfm objects.")
    })
    assign("tmp_motifStack_symbolsCache", list(), envir=.globals)
    .local <- function(..., newpage, draw){
      plotMotifLogo(..., newpage = FALSE, draw = FALSE)
    }
    ht <- 1/n
    y0 <- .5 * ht
    for(i in seq.int(n)){
      subplots <- 
        gList(subplots, gTree(children=
                            .local(pfm=pfms[[i]], motifName=pfms[[i]]@name, 
                                   p=pfms[[i]]@background,
                                   colset = pfms[[i]]@color,
                                   xlab=NA, newpage=FALSE,
                                   margins=c(1.5, 4.1, 1.1, .1), ...),
                          vp= viewport(y=y0, height=ht)))
      y0 <- y0 + ht
    }
    rm(list="tmp_motifStack_symbolsCache", envir=.globals)
  }
  plot <- 
    gList(plot, gTree(children = subplots,
                      vp = viewport(x = .5 + treewidth/2, y = .5,
                                    width = 1-treewidth, height = 1)))
  if(dots$draw){
    if(dots$newpage) grid.newpage()
    suppressWarnings(grid.draw(plot))
  }else{
    plot
  }
}

#' Class \code{"pcm"}
#' 
#' An object of class \code{"pcm"} represents the position count matrix of a
#' DNA/RNA/amino-acid sequence motif. The entry stores a matrix, which in row
#' i, column j gives the counts of observing nucleotide/or amino acid i in
#' position j of the motif.
#' 
#' 
#' @name pcm-class
#' @aliases pcm
#' @docType class
#' @section Objects from the Class: Objects can be created by calls of the form
#' \code{new("pcm", mat, name, alphabet, color, background)}.
#' @keywords classes
#' @export
#' @examples
#' 
#' pcm <- read.table(file.path(find.package("motifStack"), "extdata", "bin_SOLEXA.pcm"))
#' pcm <- pcm[,3:ncol(pcm)]
#' rownames(pcm) <- c("A","C","G","T")
#' motif <- new("pcm", mat=as.matrix(pcm), name="bin_SOLEXA")
#' plot(motif)
#' pcm2pfm(pcm)
#' pcm2pssm(pcm)
setClass(
  "pcm", 
  representation(mat="matrix", name="character", alphabet="character", 
                 color="character", background="numeric", tags="list",
                 markers="list"),
  validity=function(object){
    re<-TRUE
    if (checkInteger(unlist(object@mat))) re<-"Columns of pcm must be integer"
    if (is.null(rownames(object@mat))) re<-"rownames of pcm is empty"
    if (is.null(names(object@color))) re<-"names of color is empty"
    if (length(setdif(rownames(object@mat), names(object@color)))>0) re<-"not every alphabet in pcm has a corresponding color"
    if (is.null(names(object@background))) re<-"names of background is empty"
    if (length(setdif(rownames(object@mat), names(object@background)))>0) re<-"not every alphabet in pcm has a background"
    if (!object@alphabet %in% c("DNA", "RNA", "AA", "others")) re<-"alphabet must be either DNA, RNA, AA or others"
    if (object@alphabet=="DNA" & !all(rownames(object@mat) %in% c("A","C","G","T"))) re<-"rownames of pcm for DNA motifs must be capital A, C, G and T"
    if (object@alphabet=="RNA" & !all(rownames(object@mat) %in% c("A","C","G","U"))) re<-"rownames of pcm for RNA motifs must be capital A, C, G and U"
    if (object@alphabet=="AA" & !all(rownames(object@mat) %in% LETTERS[1:26])) re<-"rownames of pcm for AA motifs must be capital letters"
    if (any(!is(object@markers, "marker"))) re<- "markers must be a list of marker object"
    re
  }
)


#' "pcm" methods
#' 
#' methods for pcm objects.
#' 
#' 
#' @rdname pcm-class
#' @aliases $,pcm-method $<-,pcm-method 
#' @docType methods
#' @param x An object of class \code{pcm}. For \code{getIC}, if parameter p is
#' followed, x should be an object of matrix.  For \code{pcm2pfm}, x also could
#' be an object of matrix.
#' @param y Not use.
#' @param p p is the background frequency.
#' @param n how many spaces should be added.
#' @param b logical value to indicate where the space should be added.
#' @param background a \code{"numeric"} vector. The background frequency.
#' @param t numeric value of information content threshold for trimming.
#' @param \dots Further potential arguments passed to \code{plotMotifLogo}.
#' @param row.names,optional see as.data.frame
#' @param name slot name of pcm object.
#' @section Methods: \describe{ \item{addBlank}{\code{signature(x="pcm",
#' n="numeric", b="logical")} add space into the position count matrix for
#' alignment. b is a bool value, if TRUE, add space to the 3' end, else add
#' space to the 5' end. n indicates how many spaces should be added.}
#' 
#' \item{coerce}{\code{signature(from = "pcm", to = "matrix")}: convert object
#' pcm to matrix }
#' 
#' \item{getIC}{\code{signature(x = "pcm",)} Calculate information content
#' profile for position frequency matrix. }
#' 
#' \item{matrixReverseComplement}{\code{signature(x = "pcm")} get the reverse
#' complement of position frequency matrix.}
#' 
#' \item{plot}{\code{signature(x = "pcm")} Plots the sequence logo of the
#' position count matrix. }
#' 
#' \item{trimMotif}{\code{signature(x = "pcm", t= "numeric")} trim motif by
#' information content. }
#' 
#' \item{$, $<-}{Get or set the slot of \code{\link{pcm-class}}}
#' 
#' \item{as.data.frame}{convert \code{\link{pcm-class}} to a data.frame}
#' \item{format}{return the name_pcm of \code{\link{pcm-class}}} }
#' @keywords classes
#' @examples
#' 
#' pcm <- read.table(file.path(find.package("motifStack"), "extdata", "bin_SOLEXA.pcm"))
#' pcm <- pcm[,3:ncol(pcm)]
#' rownames(pcm) <- c("A","C","G","T")
#' motif <- new("pcm", mat=as.matrix(pcm), name="bin_SOLEXA")
#' getIC(motif)
#' matrixReverseComplement(motif)
#' as(motif,"matrix")
#' pcm2pfm(motif)
#' as.data.frame(motif)
#' format(motif)
#' 
#' @exportMethod `$` `$<-`
setMethod("$", "pcm", function(x, name) slot(x, name))
setReplaceMethod("$", "pcm",
                 function(x, name, value){
                     slot(x, name, check = TRUE) <- value
                     x
                 })

#' @importFrom grDevices rainbow
setMethod("initialize","pcm",function(.Object, mat, name, alphabet, color, background, 
                                      tags, markers){
    if(mode(mat)!="numeric") stop("mat must be a numeric matrix")
    if(is.null(rownames(mat))) stop("rownames of pcm is empty")
    rownames(mat)<-toupper(rownames(mat))
    rname<-rownames(mat)
    if(missing(alphabet)){
        rname<-rname[order(rname)]
        if(all(rname %in% c("A","C","G","T"))) alphabet<-"DNA"
        else{
            if(all(rname %in% c("A","C","G","U"))) alphabet<-"RNA"
            else{
                if(all(rname %in% LETTERS[1:26]) & nrow(mat)==20) alphabet<-"AA"
                else alphabet<-"others"
            }
        }
    }
    if(missing(color)){
        if(alphabet!="others"){
          color<-colorset(alphabet, "auto")
        }else{
          color <- rainbow(nrow(mat))
          names(color) <- rname
        }
    }
    names(color) <- toupper(names(color))
    if(missing(background)){
        background<-rep(1/nrow(mat), nrow(mat))
        names(background)<-rname
    }
    if(length(background)<nrow(mat)){
        background <- rep(background, nrow(mat))[1:nrow(mat)]
        names(background) <- rname
    }
    .Object@mat            =    mat
    .Object@name        =    name
    .Object@alphabet    =    alphabet
    .Object@color        =    color
    .Object@background    =    background
    if(!missing(tags)) .Object@tags = tags
    if(!missing(markers)) .Object@markers = markers
    .Object
})

#' @name plot
#' @rdname pcm-class
#' @aliases plot plot,pcm,ANY-method
#' @importFrom stats4 plot
#' @exportMethod plot
setMethod("plot", signature(x="pcm"), 
          function(x, y="missing", ...){
              plot(pcm2pfm(x), ...)
          }
)

#' @name as
#' @rdname pcm-class
#' @aliases coerce,pcm,matrix-method
#' @exportMethod coerce
setAs(from="pcm", to="matrix", function(from){
    from@mat
})



#' @rdname pcm-class
#' @exportMethod trimMotif
#' @aliases trimMotif trimMotif,pcm,numeric-method
setGeneric("trimMotif", function(x, t) standardGeneric("trimMotif"))
setMethod("trimMotif", signature(x="pcm", t="numeric"), function(x, t){
    .sw <- c(0, 0)
    ic <- getIC(x)
    for(i in 1:ncol(x@mat)){
        if(ic[i]>=t){
            .flag <- FALSE
            if(i<ncol(x@mat)){
                if(ic[i+1]>=t) .flag<-TRUE
                else if(ic[i]>=min(2*t, 0.5)) .flag<-TRUE
            }else{
                .flag<-TRUE
            }
            if(.flag){
                if(.sw[1]==0) .sw[1] <- i
                else .sw[2] <- i
            }
        }
    }
    if(.sw[1]<.sw[2]-1) x@mat <- x@mat[, .sw[1]:.sw[2]]
    else x <- NA
    x
})

#' @rdname pcm-class
#' @exportMethod matrixReverseComplement
#' @aliases matrixReverseComplement matrixReverseComplement,pcm-method
setGeneric("matrixReverseComplement", 
           function(x) standardGeneric("matrixReverseComplement"))
setMethod("matrixReverseComplement", "pcm", function(x){
    if(x@alphabet!="DNA") stop("alphabet of pcm must be DNA")
    mat<-x@mat
    ## double check the rownames to A, C, G, T.
    if(!all(toupper(rownames(mat))==c("A", "C", "G", "T"))){
      mat <- mat[match(c("A", "C", "G", "T"), toupper(rownames(mat))), ]
    }
    rc<-matrix(nrow=nrow(mat),ncol=ncol(mat))
    complements<-c(4,3,2,1)
    for(i in 1:nrow(mat)){
        for(j in 1:ncol(mat)){
            rc[complements[i],(ncol(mat)+1-j)]<-mat[i,j]
        }
    }
    rownames(rc)<-rownames(mat)
    x@mat<-rc
    x
})

#' @rdname pcm-class
#' @exportMethod addBlank
#' @aliases addBlank addBlank,pcm,numeric,logical-method
setGeneric("addBlank", function(x, n, b) standardGeneric("addBlank"))
setMethod("addBlank", signature(x="pcm", n="numeric", b="logical"), function(x, n, b){
    #if(x@alphabet!="DNA") stop("alphabet of pfm must be DNA")
    N<-matrix(rep(rep(0,nrow(x@mat)), n), nrow=nrow(x@mat))
    rownames(N) <- rownames(x@mat)
    if(b){
        N<-cbind(x@mat,N)
    }else{
        N<-cbind(N,x@mat)
        if(length(x@markers)>0){
          x@markers <- lapply(x@markers, function(.ele){
            .ele@start <- .ele@start+n
            .ele@stop <- .ele@stop+n
            .ele
          })
        }
    }
    rownames(N)<-rownames(x@mat)
    x@mat<-N
    x
})

#' @rdname pcm-class
#' @exportMethod getIC
#' @aliases getIC getIC,pcm,ANY-method
setGeneric("getIC", function(x, p) standardGeneric("getIC"))
setMethod("getIC", signature(x="pcm"), function(x, p="missing"){
    mat<-pcm2pfm(x@mat)
    colSums(mat * (addPseudolog2(mat) - addPseudolog2(x@background)))
})

#' @rdname pcm-class
#' @exportMethod pcm2pfm
#' @aliases pcm2pfm pcm2pfm,pcm,ANY-method pcm2pfm,matrix,ANY-method
#' pcm2pfm,matrix,numeric-method pcm2pfm,data.frame,ANY-method
#' pcm2pfm,data.frame,numeric-method pcm2pfm,list,ANY-method
#' pcm2pfm,list,numeric-method 
setGeneric("pcm2pfm", function(x, background) standardGeneric("pcm2pfm"))
setMethod("pcm2pfm", signature(x="matrix", background="numeric"), function(x, background){
    s <- max(colSums(x, na.rm = TRUE), na.rm = TRUE)
    bck <- background/sum(background)
    if(s==0){
      mat <- matrix(rep(bck, ncol(x)), nrow = nrow(x), ncol = ncol(x))
      rownames(mat) <- rownames(x)
      colnames(mat) <- colnames(x)
      return(mat)
    }
    p <- x/s
    cs <- colSums(p)
    cs[is.na(cs)] <- 0
    p[, cs < 1] <- p[, cs < 1] + rep((1-cs[cs < 1]), each=nrow(x))*bck
    p
})

setMethod("pcm2pfm", signature(x="matrix"), function(x, background="missing"){
    pcm2pfm(x, rep(1/nrow(x), nrow(x)))
})

setMethod("pcm2pfm", signature(x="data.frame", background="numeric"), function(x, background){
    pcm2pfm(as.matrix(x), background)
})

setMethod("pcm2pfm", signature(x="data.frame"), function(x, background="missing"){
    pcm2pfm(as.matrix(x), rep(1/nrow(x), nrow(x)))
})

## pcm to pfm from pcm object
setMethod("pcm2pfm", signature(x="pcm"), function(x, background="missing"){
  bck <- x@background[rownames(x@mat)]
  if(any(is.na(bck))) stop("some elements does not have background value", bck)
    .mat <- pcm2pfm(x@mat, bck)
    new("pfm", mat=.mat, name=x@name, alphabet=x@alphabet, 
        color=x@color, background=x@background, tags=x@tags,
        markers=x@markers)
})

setMethod("pcm2pfm", signature(x="list"), function(x, background="missing"){
  lapply(x, pcm2pfm)
})
setMethod("pcm2pfm", signature(x="list", background="numeric"), function(x, background){
  lapply(x, pcm2pfm, background=background)
})

#' @rdname pcm-class
#' @exportMethod pcm2pssm
#' @aliases pcm2pssm pcm2pssm,pcm,ANY-method pcm2pssm,matrix,ANY-method
#' pcm2pssm,matrix,numeric-method pcm2pssm,data.frame,ANY-method
#' pcm2pssm,data.frame,numeric-method pcm2pssm,list,ANY-method
#' pcm2pssm,list,numeric-method
setGeneric("pcm2pssm", function(x, background) standardGeneric("pcm2pssm"))
setMethod("pcm2pssm", signature(x="matrix", background="numeric"), function(x, background){
  ## check the background order, first order, length=4; second order, length=16
  ord <- 0
  if(length(background)==nrow(x)){
    ord <- 1
  }
  if(length(background)==2^nrow(x)+nrow(x)){
    ord <- 2
  }
  if(ord==0){
    stop("The background dimention is incorrect. For example, if it is DNA motif,
         4 or 20 (16 (2nd order) + 4(1st order)) named backgrounds are expected.")
  }
  m <- pcm2pfm(x, background)
  stopifnot(all(rownames(m)==rownames(x)))
  if(length(names(background))!=length(background)){
    stop("background must be a named vector.")
  }
  if(ord==1){
    m1 <- addPseudolog2(m) - addPseudolog2(background[rownames(m)])
  }else{
    ## 2 order background
    ## 2*log2(sum(p_i*(p_ij/q_ij)))
    letters <- rownames(m)
    ## calculate 1 order of the motif
    total <- sum(x, na.rm = TRUE)
    P1 <- rowSums(x, na.rm = TRUE)
    names(P1) <- letters
    P1 <- addPseudolog2(P1)
    ## calculate 2 order of the motif
    P2 <- lapply(letters, function(.ele){
      mat <- t(t(cbind(background[rownames(m)], m[, -ncol(m)])) *
                 m[.ele, , drop=TRUE]) 
      rownames(mat) <- paste0(letters, .ele)
      mat
    })
    names(P2) <- letters
    ## 2 order matrix
    bg <- split(background[paste0(rep(letters, length(letters)),
                                  rep(letters, each=length(letters)))], 
                rep(letters, each=length(letters)))[letters]
    Pq <- mapply(FUN=function(p, b){
      addPseudolog2(p) - addPseudolog2(b)
    }, P2[letters], bg[letters], SIMPLIFY = FALSE)
    m1 <- lapply(Pq, function(.ele){## .ele is a matrix, eg 4 X len
      colSums(.ele + P1)
    })
    m1 <- do.call(rbind, m1)
    rownames(m1) <- letters
  }
  return(m1)
})

setMethod("pcm2pssm", signature(x="matrix"), function(x, background="missing"){
  background <- rep(1/nrow(x), nrow(x))
  names(background) <- rownames(x)
  pcm2pssm(x, background)
})

setMethod("pcm2pssm", signature(x="data.frame", background="numeric"), function(x, background){
  pcm2pssm(as.matrix(x), background)
})

setMethod("pcm2pssm", signature(x="data.frame"), function(x, background="missing"){
  background <- rep(1/nrow(x), nrow(x))
  names(background) <- rownames(x)
  pcm2pssm(as.matrix(x), background)
})
## pcm to pssm from pcm object
setMethod("pcm2pssm", signature(x="pcm"), function(x, background="missing"){
  .mat <- pcm2pssm(x@mat, x@background)
  new("pssm", mat=.mat, name=x@name, alphabet=x@alphabet, 
      color=x@color, background=x@background, tags=x@tags,
      markers=x@markers)
})

setMethod("pcm2pssm", signature(x="list"), function(x, background="missing"){
  lapply(x, pcm2pssm)
})
setMethod("pcm2pssm", signature(x="list", background="numeric"), function(x, background){
  lapply(x, pcm2pssm, background=background)
})


#' @rdname pcm-class
#' @exportMethod as.data.frame
#' @aliases as.data.frame,pcm-method 
setMethod("as.data.frame", signature(x="pcm"), function(x, row.names = NULL, optional = FALSE, ...){
  as.data.frame(x@mat, ...)
})

#' @rdname pcm-class
#' @exportMethod format
#' @aliases format,pcm-method
setMethod("format", signature(x="pcm"), function(x, ...){
  paste0(x@name, "_pcm")
})

#' align AA motifs
#' 
#' align AA motifs for plotting motifs stack
#' 
#' 
#' @param pcms a list of position frequency matrices, pfms must be a list of
#' class pcm
#' @param threshold information content cutoff threshold for useful postions
#' @param minimalConsensus minimal length of consensus for alignment
#' @return a list of aligned motifs
#' @export
#' @examples
#' 
#' pcms<-importMatrix(system.file("extdata", "prot.meme", package="motifStack"),
#'                    format="meme", to="pfm")
#' motifs<-AAmotifAlignment(pcms)
#'
AAmotifAlignment <- function(pcms, threshold=0.4, minimalConsensus = 0){
  if(length(pcms)<2) stop("less than 2 motifs")
  ## check rownames of the mat
  alphabet_letters <- rownames(pcms[[1]]@mat)
  if(length(alphabet_letters)!=nrow(pcms[[1]]@mat)){
    stop("not correct alphabet in matrix")
  }
  pcms <- lapply(pcms,function(.ele){
    if(!inherits(.ele, c("pfm", "pcm"))) {
      stop("pcms must be a list of pcm objects.")
    }
    if(.ele@alphabet!="AA") {
      stop("the alphabet of pcm must be AA")
    }
    if(!identical(rownames(.ele@mat), alphabet_letters)){
      stop("the alphabet of the matrix are not identical.",
           "The alphabet (", alphabet_letters,
           ") is not identical with (", rownames(.ele@mat),
           ")")
    }
    if(is(.ele, 'pfm')){
      .ele <- pfm2pcm(.ele)
    }
    .ele
  })
  pcmcopy<-list(length=length(pcms))
  pcmcopy[[1]]<-pcms[[1]]
  for(i in 2:length(pcms)){
    pcmcopy[[i]]<-pcms[[i]]
    pcmcopy<-UngappedAlignmentAA(pcmcopy, i, 
                                 threshold=threshold,
                                 minimalConsensus = minimalConsensus)
  }
  l<-unlist(lapply(pcmcopy,function(.ele) ncol(.ele@mat)))
  l<-max(l)-l
  for(i in 1:length(pcmcopy)){
    pcmcopy[[i]]<-addBlank(pcmcopy[[i]],l[i],TRUE)
  }
  pcmcopy
}

#' plot sequence logo stacks with a linear phylogenic tree and multiple color
#' sets
#' 
#' plot sequence logo stacks with a linear phylogenic tree and multiple color
#' sets.
#' 
#' 
#' @param phylog an object of class phylog
#' @param pfms a list of objects of class pfm
#' @param pfms2 a list of objects of class pfm
#' @param r.tree width of the tree
#' @param col.tree a vector of colors for tree
#' @param cnodes a character size for plotting the points that represent the
#' nodes, used with par("cex")*cnodes. If zero, no points are drawn
#' @param labels.nodes a vector of strings of characters for the nodes labels
#' @param clabel.nodes a character size for the nodes labels, used with
#' par("cex")*clabel.nodes. If zero, no nodes labels are drawn
#' @param cleaves a character size for plotting the points that represent the
#' leaves, used with par("cex")*cleaves. If zero, no points are drawn
#' @param labels.leaves a vector of strings of characters for the leaves labels
#' @param clabel.leaves a character size for the leaves labels, used with
#' par("cex")*clavel.leaves
#' @param col.leaves a vector of colors for leaves labels
#' @param col.leaves.bg a vector of colors for background of leaves labels
#' @param col.leaves.bg.alpha alpha value [0, 1] for the colors of backgroud of
#' leaves labels
#' @param r.pfms width of the pfms
#' @param r.pfms2 width of the pfms2
#' @param motifScale the scale of logo size
#' @param col.pfms a vector of colors for inner pile of pfms
#' @param col.pfms.width width for inner pile of pfms
#' @param col.pfms2 a vector of colors for outer pile of pfms
#' @param col.pfms2.width width for outer pile of pfms
#' @param r.anno a vector of width of color sets
#' @param col.anno a list of color sets
#' @param pfmNameSpliter spliter when name of pfms/pfms2 contain multiple node
#' of labels.leaves
#' @param rcpostfix the postfix for reverse complements
#' @param ic.scale logical. If TRUE, the height of each column is proportional
#' to its information content. Otherwise, all columns have the same height.
#' @param plotIndex logical. If TRUE, will plot index number in the motifLogo
#' which can help user to describe the motifLogo
#' @param IndexCol The color of the index number when plotIndex is TRUE.
#' @param IndexCex The cex of the index number when plotIndex is TRUE.
#' @param groupDistance show groupDistance on the draw
#' @param groupDistanceLineCol groupDistance line color, default: red
#' @return none
#' @export
#' @importFrom graphics par plot.default strwidth points segments 
#' abline rect text 
#' @importFrom grDevices grey col2rgb rgb dev.size
#' @importFrom ade4 scatterutil.eti
#' @importFrom grid pushViewport viewport popViewport grid.text gpar
#' @author Jianhong Ou
#' @seealso \code{\link{motifCircos}}
#' @keywords misc
#' @examples
#' 
#' if(interactive() || Sys.getenv("USER")=="jianhongou"){
#'     library("MotifDb")
#'     matrix.fly <- query(MotifDb, "Dmelanogaster")
#'     motifs <- as.list(matrix.fly)
#'     motifs <- motifs[grepl("Dmelanogaster-FlyFactorSurvey-", 
#'                            names(motifs), fixed=TRUE)]
#'     names(motifs) <- gsub("Dmelanogaster_FlyFactorSurvey_", "", 
#'                 gsub("_FBgn[0-9]+$", "", 
#'                   gsub("[^a-zA-Z0-9]","_", 
#'                      gsub("(_[0-9]+)+$", "", names(motifs)))))
#'     motifs <- motifs[unique(names(motifs))]
#'     pfms <- sample(motifs, 50)
#'     hc <- clusterMotifs(pfms)
#'     library(ade4)
#'     phylog <- ade4::hclust2phylog(hc)
#'     leaves <- names(phylog$leaves)
#'     pfms <- pfms[leaves]
#'     pfms <- mapply(pfms, names(pfms), FUN=function(.ele, .name){
#'                  new("pfm",mat=.ele, name=.name)})
#'     pfms <- DNAmotifAlignment(pfms, minimalConsensus=3)
#'     library(RColorBrewer)
#'     color <- brewer.pal(12, "Set3")
#'     motifPiles(phylog, pfms, cleaves = 0.5, clabel.leaves = 0.7, 
#'              col.leaves=rep(color, each=5), 
#'              col.leaves.bg = sample(colors(), 50),
#'              col.tree=rep(color, each=5),
#'              r.anno=c(0.02, 0.03, 0.04), 
#'              col.anno=list(sample(colors(), 50), 
#'                             sample(colors(), 50), 
#'                             sample(colors(), 50)))
#'   }
#' 
motifPiles <- function (phylog, pfms=NULL, pfms2=NULL, 
                        r.tree=.45, col.tree=NULL,
                        cnodes=0, labels.nodes=names(phylog$nodes), 
                        clabel.nodes=0,
                        cleaves=.2, labels.leaves=names(phylog$leaves),
                        clabel.leaves=1,
                        col.leaves=rep("black", length(labels.leaves)),
                        col.leaves.bg=NULL, col.leaves.bg.alpha=1,
                        r.pfms=NA, r.pfms2=NA, 
                        motifScale=c("logarithmic", "linear", "none"),
                        col.pfms=NULL, col.pfms.width=0.02,
                        col.pfms2=NULL, col.pfms2.width=0.02,
                        r.anno=0, col.anno=list(),
                        pfmNameSpliter=";", rcpostfix="(RC)", ic.scale=TRUE,
                        plotIndex=FALSE, IndexCol="black", IndexCex=.8,
                        groupDistance=NA, groupDistanceLineCol="red"){
    if (!inherits(phylog, "phylog"))
        stop("Non convenient data")
    leaves.number <- length(phylog$leaves)
    checkLength <- function(tobechecked){
        !((length(tobechecked)>=leaves.number)||is.null(tobechecked))
    }
    checkNA <- function(tobechecked){
        if(is.null(tobechecked)) return(FALSE)
        return(any(is.na(tobechecked)))
    }
    for(tobechecked in c("col.leaves", "col.leaves.bg", "col.tree")){
        if(checkLength(eval(as.symbol(tobechecked)))) {
            stop(paste("the length of", tobechecked, 
                       "should be same as the length of leaves"))
        }
        if(checkNA(eval(as.symbol(tobechecked)))) {
            stop(paste("contain NA in", tobechecked))
            }
    }
    if(length(r.anno)>length(col.anno)){
        if(r.anno!=0 & length(r.anno)!=1){
            stop("length of col.anno must be same as r.anno you input")
        }
    }
    if(length(col.anno)>0){
        if(!is(col.anno, "list")) stop("col.anno must be a object of list")
        for(i in 1:length(col.anno)){
            if(checkLength(col.anno[[i]])) {
                stop(paste("the length of col.anno[[", i, 
                           "]]should be same as the length of leaves"))
            }
            if(checkNA(col.anno[[i]])) {
                stop(paste("contain NA in col.anno[[", i, "]]"))
            }
        }
    }
    motifScale <- match.arg(motifScale)
    leaves.names <- names(phylog$leaves)
    nodes.number <- length(phylog$nodes)
    nodes.names <- names(phylog$nodes)
    if (length(labels.leaves) != leaves.number)
        labels.leaves <- names(phylog$leaves)
    if (length(labels.nodes) != nodes.number)
        labels.nodes <- names(phylog$nodes)
    if (r.tree < 0.05 || r.tree > .5)
        stop("'r.tree': non convenient value [0.05, .5]")
    leaves.car <- gsub("[_]", " ", labels.leaves)
    nodes.car <- gsub("[_]", " ", labels.nodes)
    opar <- par(mar = par("mar"), srt = par("srt"))
    on.exit(par(opar))
    par(mar = c(0.1, 0.1, 0.1, 0.1), mfrow=c(1,1))
    dis <- phylog$droot
    max_Dis <- max(dis)
    if(!is.na(groupDistance)){
        groupDistance <- (max_Dis - groupDistance) / max_Dis
    }
    dis <- dis/max_Dis
    dist.leaves <- dis[leaves.names]
    dist.nodes <- dis[nodes.names]
    xlim <- c(0, max_Dis/r.tree)
    asp <- c(1, 1)
    pin <- dev.size("in")
    asp <- pin[2L]/pin[1L]
    plot.default(0, 0, type = "n", xlab = "", ylab = "", xaxt = "n", 
                 yaxt = "n", xlim = xlim, ylim = c(-0, 1), xaxs = "i", 
                 yaxs = "i", frame.plot = FALSE)
    
    xcar <- max_Dis*1.05 + .01
    leftMar <- .01
    
    vpheight <- 1/(leaves.number+1)
    leaves.width <- lapply(leaves.car, strwidth, 
                           units="user", cex=clabel.leaves)
    string.width <- strwidth("M", units="figure", cex=IndexCex)
    r.leaves <- max(unlist(leaves.width))
    r.leaves <- r.leaves + xcar
    r.total <- (r.leaves + leftMar)/xlim[2] + col.pfms.width + string.width
    lenPFM <- c(FALSE, FALSE)
    if(!is.null(pfms)){
        if(is.na(r.pfms)){
            r.pfms <- r.total
        }
        pfmsLen <- sapply(pfms, function(.ele) {
            length(unlist(strsplit(.ele@name, pfmNameSpliter)))
            })
        if(motifScale=="linear"){
            vph <- vpheight * pfmsLen
        }else{
          if(motifScale=="logarithmic"){
            vph <- vpheight*(1+log2(pfmsLen))
          }else{
            vph <- rep(vpheight, length(pfmsLen))
          }
        }
        vpwidth <- mapply(function(.ele, vpht) 
            vpht * ncol(.ele@mat) / 2 * asp, pfms, vph)
        r.total <- r.pfms + max(vpwidth) + col.pfms2.width + 2*string.width
        lenPFM[1] <- TRUE
    }
    if(!is.null(pfms2)){
        if(is.na(r.pfms2)){
            r.pfms2 <- r.total
        }
        pfmsLen2 <- sapply(pfms2, function(.ele) 
            length(unlist(strsplit(.ele@name, pfmNameSpliter))))
        if(motifScale=="linear"){
            vph2 <- vpheight * pfmsLen2
        }else{
          if(motifScale=="logarithmic"){
            vph2 <- vpheight*(1+log2(pfmsLen2))
          }else{
            vph2 <- rep(vpheight, length(pfmsLen2))
          }
        }
        vpwidth2 <- mapply(function(.ele, vpht) 
            vpht * ncol(.ele@mat) / 2 * asp, pfms2, vph2)
        r.total <- r.pfms2 + max(vpwidth2) + 2*string.width
        lenPFM[2] <- TRUE
    }
    
    if(sum(lenPFM)>0){
        plotIndex <- rep(plotIndex, 2)[lenPFM]
        IndexCol <- rep(IndexCol, 2)[lenPFM]
        IndexCex <- rep(IndexCex, 2)[lenPFM]
        names(plotIndex) <- names(IndexCol) <- 
            names(IndexCex) <- c("pfm", "pfm2")[lenPFM]
    }
    
    xx <- c(dist.leaves, dist.nodes)
    
    r.total <- sum(c(r.total, r.anno), na.rm=TRUE)
    
    ratio <- .98/r.total
    if(ratio < 1){
        xcar <- xcar * ratio
        xx <- xx * ratio
        leftMar <- leftMar * ratio
        groupDistance <- groupDistance * ratio
        clabel.leaves <- clabel.leaves * ratio
        clabel.nodes <- clabel.nodes * ratio
        IndexCex <- IndexCex * ratio
        cleaves <- cleaves * ratio
        cnodes <- cnodes * ratio
        r.anno <- r.anno * ratio
        r.leaves <- r.leaves * ratio
        if(!is.null(pfms)) vpwidth <- vpwidth * ratio
        if(!is.null(pfms2)) vpwidth2 <- vpwidth2 * ratio
        if(!is.null(pfms)) r.pfms <- r.pfms * ratio
        if(!is.null(pfms2)) r.pfms2 <- r.pfms2 * ratio
        r.total <- r.total * ratio
        if(!is.null(col.pfms)) col.pfms.width <- col.pfms.width*ratio
        if(!is.null(col.pfms2)) col.pfms2.width <- col.pfms2.width*ratio
    }
    
    xx <- xx*(xlim[2]*r.tree) + leftMar
    groupDistance <- groupDistance*(xlim[2]*r.tree) + leftMar
    
    y <- (leaves.number:1)/(leaves.number + 1)
    names(y) <- leaves.names
    
    if (is.null(col.tree)){
        col.tree <- rep("black", leaves.number)
    }
    
    if (cleaves > 0) {
        for (i in 1:leaves.number) {
            points(xx[i], y[i], pch = 21, bg=col.tree[i], 
                   cex = par("cex") * cleaves, col=col.tree[i])
        }
    }
    
    yn <- rep(0, nodes.number)
    names(yn) <- nodes.names
    yy <- c(y, yn)
    col.tree.lines <- col.tree
    names(col.tree.lines) <- names(phylog$leaves)
    for (i in 1:length(phylog$parts)) {
        w <- phylog$parts[[i]]
        but <- names(phylog$parts)[i]
        yy[but] <- mean(yy[w])
        colour <- floor(rowMeans(col2rgb(col.tree.lines[w])))
        col.tree.lines[but] <- rgb(colour[1], colour[2], 
                                   colour[3], maxColorValue=255)
        b <- range(yy[w])
        segments(xx[but], b[1], xx[but], b[2], col=col.tree.lines[but])
        x1 <- xx[w]
        y1 <- yy[w]
        x2 <- rep(xx[but], length(w))
        segments(x1, y1, x2, y1, col=col.tree.lines[w])
    }
    if(!is.na(groupDistance)){
        if(length(groupDistanceLineCol)!=length(groupDistance)){
            groupDistanceLineCol <- 
                rep(groupDistanceLineCol, 
                    ceiling(length(groupDistance)/
                                length(groupDistanceLineCol)))[
                                    seq_along(groupDistance)]
        }
        for(i in 1:length(groupDistance)){
            if(groupDistance[i] > 0)
                abline(v=groupDistance[i], col=groupDistanceLineCol[i], lty=2)
        }
    }
    if (cnodes > 0) {
        for (i in nodes.names) {
            points(xx[i], yy[i], pch = 21, bg="white", cex = cnodes)
        }
    }
    if (clabel.nodes > 0) {
        scatterutil.eti(xx[names(dist.nodes)], yy[names(dist.nodes)], nodes.car, 
                        clabel.nodes)
    }
    
    for (i in 1:leaves.number) {
        rect(xcar, y[i]-1/leaves.number/2, r.leaves, y[i]+1/leaves.number/2, 
             col=highlightCol(col.leaves.bg[i], col.leaves.bg.alpha), border=NA)
        if(clabel.leaves>0) 
            text(xcar, y[i], leaves.car[i], adj = 0, cex = par("cex") * 
                     clabel.leaves, col=col.leaves[i])
        #segments(xcar, y[i], xx[i], y[i], col = grey(0.7))
    }
    
    for(metaChar in c("\\","$","*","+",".","?","[","]","^","{","}","|","(",")"))
    {
        rcpostfix <- gsub(metaChar,paste("\\",metaChar,sep=""),
                          rcpostfix,fixed=TRUE)
    }
    drawPFMcir <- function(pfms, r.x, ym, vpwid, vphei, col.pfms.wid, idx){
        assign("tmp_motifStack_symbolsCache", list(), envir=.globals)
        ##extract names
        pfmNames <- lapply(pfms, function(.ele) .ele@name)
        if(idx=="pfm2"){
          ## sort the pfms
          freq <- lengths(strsplit(unlist(pfmNames), pfmNameSpliter))
          freq.id <- order(freq, decreasing = TRUE)
          pfms <-pfms[freq.id]
          pfmNames <- pfmNames[freq.id]
          vpwid <- vpwid[freq.id]
          vphei <- vphei[freq.id]
        }
        for(i in 1:length(pfmNames)){
            pfmname <- unlist(strsplit(pfmNames[[i]], pfmNameSpliter))
            pfmname <- gsub(paste(rcpostfix,"$",sep=""),"",pfmname)
            pfmIdx <- which(makeLeaveNames(labels.leaves) %in% 
                                makeLeaveNames(pfmname))
            if(length(pfmIdx)==0) 
                pfmIdx <- which(makeLeaveNames(names(phylog$leaves)) 
                                %in% makeLeaveNames(pfmname))
            if(length(pfmIdx)>0){
                vpy <- mean(ym[pfmIdx])
                pushViewport(viewport(x=r.x, y=vpy, width=vpwid[i], 
                                      height=vphei[i], just=c(0, .5)))
                plotMotifLogoA(pfms[[i]], ic.scale=ic.scale)
                popViewport()
                if(plotIndex[idx]&length(pfms)<leaves.number) {
                    grid.text(label=i, x=r.x-col.pfms.wid, 
                              y=vpy, 
                              gp=gpar(col=IndexCol[idx], 
                                      cex=IndexCex[idx]), 
                              just="right")
                }
            }else{
                warning(paste("No leave named as ",
                              paste(pfmname, collapse=", ")), sep="")
            }
        }
        rm(list="tmp_motifStack_symbolsCache", envir=.globals)
    }
    
    if(!is.null(col.pfms)){
        rect((r.pfms-col.pfms.width)*xlim[2], y-vpheight/2, r.pfms*xlim[2],
             y+vpheight/2, col=col.pfms, border=NA)
    }
    
    if(!is.null(pfms) && r.pfms < .95){
        drawPFMcir(pfms, r.pfms, y, vpwidth, vph, col.pfms.width, "pfm")
    }
    
    if(!is.null(col.pfms2)){
        rect((r.pfms2-col.pfms2.width)*xlim[2], y-vpheight/2, r.pfms2*xlim[2], 
             y+vpheight/2, col=col.pfms2, border=NA)
    }
    
    if(!is.null(pfms2) && r.pfms2 < .95){
        drawPFMcir(pfms2, r.pfms2, y, vpwidth2, vph2, col.pfms2.width, "pfm2")
    }
    
    if(sum(r.anno, na.rm=TRUE)>0){
        r.anno.diff <- c(0, 0, cumsum(r.anno[-length(r.anno)]))
        r.anno <- r.total - sum(r.anno, na.rm=TRUE) + c(0, r.anno) + r.anno.diff
        for(i in 2:length(r.anno)){
            rect(r.anno[i-1]*xlim[2], y-vpheight/2, r.anno[i]*xlim[2], 
                 y+vpheight/2, col=col.anno[[i-1]], border=NA)
        }
    }
    
    return(invisible())
}

#' plot affinity logo
#' 
#' plot affinity logo
#' 
#' 
#' @param psam a position-specific affinity matrix
#' @param motifName motif name
#' @param font font of logo
#' @param fontface fontface of logo
#' @param colset color setting for each logo letter
#' @param alpha Alpha channel for transparency of low affinity letters.
#' @param newpage plot in a new canvas or not.
#' @param draw Vector (logical(1)). TRUE to plot. FALSE, return a gList
#' @return none
#' @references Barrett C. Foat, Alexandre V. Morozov, Harmen J. Bussemaker;
#' Statistical mechanical modeling of genome-wide transcription factor
#' occupancy data by MatrixREDUCE, Bioinformatics, Volume 22, Issue 14, 15 July
#' 2006, Pages e141-e149, https://doi.org/10.1093/bioinformatics/btl223
#' @export
#' @importFrom grid gList linesGrob unit gpar grid.newpage grid.draw 
#' @examples
#' 
#' psam <- importMatrix(file.path(find.package("motifStack"), "extdata", "PSAM.mxr"), 
#'                      format="psam")[[1]]
#' plotAffinityLogo(psam)
#' 
plotAffinityLogo <- function(psam, motifName, font="sans", fontface="bold",
                             colset=c("#00811B","#2000C7","#FFB32C","#D00001"),
                             alpha=0.5, newpage=TRUE, draw=TRUE){
  markers <- NULL
  pssm <- FALSE
  if(is(psam, "data.frame")){
    psam <- as.matrix(psam)
  }else{
    if(inherits(psam, c("psam", "pssm"))){
      markers <- psam@markers 
      if(missing(motifName)) motifName = psam@name
      colset=psam@color[rownames(psam@mat)]
      pssm <- is(psam, "pssm")
      psam <- psam@mat
    }
  }
  if (!is(psam, "matrix")){
    stop("psam must be a matrix.")
  }
  if(!is(colset, "character"))
    stop("colset must be a character")
  if (length(colset)!=nrow(psam))
    stop(paste("colset length and psam row numbers different",length(colset),"!=",nrow(psam)))
  rname<-rownames(psam)
  if(is.null(rname))
    stop("psam rowname is empty")
  npos<-ncol(psam)
  ncha<-nrow(psam)
  key<-paste("x", ncha, font, paste(colset, collapse=""), paste(rname, collapse=""), sep="_")
  symbolsCache <- if(exists("tmp_motifStack_symbolsCache", envir=.globals)) get("tmp_motifStack_symbolsCache", envir=.globals) else list()
  symbols<-coloredSymbols(ncha, font, colset, rname, alpha, fontface=fontface)
  symbolsCache[[key]]<-symbols
  assign("tmp_motifStack_symbolsCache", symbolsCache, envir=.globals)
  pictureGrob <- get("pictureGrob", envir = .globals)
  
  #calculate postion of each symbol and plot
  plot <- gList()
  
  ddG <- if(pssm) psam else log(psam+1e-2)
  ddG.mu<-colMeans(ddG)
  ddG.height <- t(t(ddG) - ddG.mu)
  ddG.h.pos <- ddG.h.neg <- ddG.height
  ddG.h.pos[ddG.h.pos<0] <- 0
  ddG.h.neg[ddG.h.neg>0] <- 0
  ie <- max(abs(min(colSums(ddG.h.neg))), max(colSums(ddG.h.pos)))
  ddG.height <- ddG.height/(2*ie)
  dw<-1/npos
  x.pos<-0
  y.poss <- numeric(length=npos)
  y.low.poss <- numeric(length=npos)
  plot <- gList(plot, linesGrob(y=unit(c(.5, .5), "npc"), gp=gpar(lty=3)))
  for(j in seq.int(npos)){
    heights<-ddG.height[,j]
    ## less than 0
    id<-order(heights, decreasing = TRUE)
    y.pos<-0.5
    for(i in seq.int(ncha)){
      h<-heights[id[i]]
      if(h<0) {
        y.pos<-y.pos+h
        plot <- 
          gList(plot, 
                pictureGrob(picture=symbols[[paste0(id[i], "_", alpha)]],
                            x = x.pos,
                            y = y.pos,
                            width = dw,
                            height = -h,
                            just=c(0,0),
                            distort=TRUE))
      }
    }
    y.low.poss[j] <- y.pos
    ## greater than 0
    id<-order(heights, decreasing = FALSE)
    y.pos<-0.5
    for(i in seq.int(ncha)){
      h<-heights[id[i]]
      if(h>0) {
        plot <- 
          gList(plot, 
                pictureGrob(picture = symbols[[id[i]]],
                            x = x.pos,
                            y = y.pos,
                            width = dw,
                            height =h,
                            just=c(0,0),
                            distort=TRUE))
        y.pos<-y.pos+h
      }
    }
    y.poss[j] <- y.pos
    x.pos<-x.pos+dw
  }
  if(length(markers)>0){
    plot <- gList(plot, plotMarkers(markers, dw, y.poss, y.low.poss))
  }
  
  if(draw){
    if(newpage) grid.newpage()
    suppressWarnings(grid.draw(plot))
  }else{
    plot
  }
}

#' Hierarchical Clustering motifs
#' @description functions to perfom clustering of output of matalign
#' @param align output of matalign, used to generate distance matrix.
#' @param ... parameter to pass to the \link[stats]{hclust}.
#' @return An object of hclust.
#' @importFrom stats hclust dist setNames
#' @export
#' @examples 
#'  if(interactive() || Sys.getenv("USER")=="jianhongou"){
#'   fp <- system.file("extdata", package="motifStack")
#'   fs <- dir(fp, "pcm$")
#'   pcms <- importMatrix(file.path(fp, fs), format="pcm")
#'   align <- matalign(pcms)
#'   hc <- motifHclust(align, method="average")
#'  }
motifHclust <- function(align, ...){
  d <- matalignOut2dist(align)
  d <- dist(d)
  hc <- do.call("hclust", list(d=d, ...))
  return(hc)
}

matalignOut2dist <- function(align){
  stopifnot(
    "align must be output of matalign"=
      all(c("motif1", "motif2", "distance") %in% colnames(align)))
  # Extract required columns
  d_df <- align[, c("motif1", "motif2", "distance")]
  motifs <- unique(c(align$motif1, align$motif2))
  
  # Initialize matrix
  d <- matrix(NA, nrow = length(motifs), ncol = length(motifs))
  rownames(d) <- colnames(d) <- motifs
  
  # Create lookup for both directions at once
  lookup <- setNames(d_df$distance, paste(d_df$motif1, d_df$motif2))
  lookup_rev <- setNames(d_df$distance, paste(d_df$motif2, d_df$motif1))
  
  # Vectorized assignment
  pairs <- expand.grid(i = motifs, j = motifs, stringsAsFactors = FALSE)
  pairs <- pairs[pairs$i != pairs$j, ]
  keys <- paste(pairs$i, pairs$j)
  
  # Try forward lookup, then reverse
  distances <- lookup[keys]
  missing <- is.na(distances)
  distances[missing] <- lookup_rev[keys[missing]]
  
  # Assign to matrix
  d[cbind(pairs$i, pairs$j)] <- distances
  
  return(d)
}

---
title: "motifStack Vignette"
author: "Jianhong Ou, Michael Brodsky, Lihua Julie Zhu"
date: "`r BiocStyle::doc_date()`"
package: "`r BiocStyle::pkg_ver('motifStack')`"
bibliography: ref.bib
csl: nature.csl
abstract: >
  The motifStack package is designed for graphic representation of multiple 
  motifs with different similarity scores. It works with both DNA/RNA 
  sequence motif, affinity logo and amino acid sequence motif. In addition, it provides 
  the flexibility for users to customize the graphic parameters such as 
  the font type and symbol colors.
vignette: >
  %\VignetteIndexEntry{motifStack Vignette}
  %\VignetteEngine{knitr::rmarkdown}
  %\VignetteEncoding{UTF-8}
output:
  html_document:
    theme: simplex
    toc: true
    toc_float: true
    toc_depth: 4
    fig_caption: true
---

```{r checkplatform, include=FALSE}
library(knitr)
library(motifStack)
library(MotifDb)
library(ade4)
library(ggplot2)
library(TFBSTools)
library(JASPAR2020)
if(.Platform$OS.type=="windows"){
  opts_chunk$set(eval=FALSE)
}
```

# Introduction
A sequence logo, based on information theory, has been widely used as a graphical 
representation of sequence conservation (aka motif) in multiple amino acid or 
nucleic acid sequences. Sequence motif represents conserved characteristics 
such as DNA binding sites, where transcription factors bind, and catalytic sites 
in enzymes. Although many tools, such as seqlogo[@Oliver2006], have been 
developed to create sequence motif and to represent it as individual sequence 
logo, software tools for depicting the relationship among multiple sequence 
motifs are still lacking. We developed a flexible and powerful open-source 
R/Bioconductor package, __motifStack__, for visualization of the alignment of 
multiple sequence motifs.

# Import matrix

The `importMatrix` function is used to import motifs from files or convert
`XMatrix`/`XMatrixList` object into __motifStack__ compatable format.

## convert motifs from `XMatrixList`

```{r importMatrix,fig.cap="import data from PFMatrixList",fig.width=6,fig.height=3}
library(motifStack)
library(JASPAR2020)
motifs <- importMatrix(getMatrixSet(JASPAR2020, 
                                    list(species="Mus musculus")))
plot(motifs[[1]])
```

## import motifs from files

The supported formats are "meme", "transfac", "jaspar", "scpd", "cisbp",
and "psam".

```{r importFromFiles,fig.cap="import data from file",fig.width=6,fig.height=3}
RUNX1 <- importMatrix(system.file("extdata", "MA0002.1.jaspar",
                                  package = "motifStack",
                                  mustWork = TRUE))[[1]]
plot(RUNX1)
```

# Examples of using motifStack
## plot a DNA sequence logo with different fonts and colors
Users can select different fonts and colors to draw the sequence logo.
```{r DNAseqLogo,fig.cap="Plot a DNA sequence logo with different fonts and colors",fig.width=8,fig.height=2.5}
library(motifStack)
pcm <- read.table(file.path(find.package("motifStack"), 
                            "extdata", "bin_SOLEXA.pcm"))
pcm <- pcm[,3:ncol(pcm)]
rownames(pcm) <- c("A","C","G","T")
motif <- new("pcm", mat=as.matrix(pcm), name="bin_SOLEXA")
##pfm object
#motif <- pcm2pfm(pcm)
#motif <- new("pfm", mat=motif, name="bin_SOLEXA")
plot(motif)
#plot the logo with same height
plot(motif, ic.scale=FALSE, ylab="probability")
#try a different font and a different color group
motif@color <- colorset(colorScheme='basepairing')
plot(motif,font="serif")
```

## plot sequence logo with markers
If you assign markers slot by a list of `marker` object, markers can be plotted in the figure. 
There are three type of markers, "rect", "line" and "text".
```{r seqLogoMarkers, fig.cap="Plot a DNA sequence logo with markers", fig.width=8,fig.height=2.5}
markerRect <- new("marker", type="rect", start=6, stop=7, gp=gpar(lty=2, fill=NA, col="orange"))
markerLine <- new("marker", type="line", start=2, stop=7, gp=gpar(lwd=2, col="red"))
markerText <- new("marker", type="text", start=c(1, 5), 
                  label=c("*", "core"), gp=gpar(cex=2, col="red"))
motif <- new("pcm", mat=as.matrix(pcm), name="bin_SOLEXA", 
             markers=c(markerRect, markerLine, markerText))
plot(motif)
```

## change the x-axis labels

```{r seqLogoXaxis, fig.cap="Plot a DNA sequence logo with pre-defined xlabels", fig.width=8,fig.height=2.5}
plot(motif, xaxis=paste0("pos", seq.int(7)+10))
```


## plot a RNA sequence logo

To plot a RNA sequence logo, you only need to change the rowname of the matrix 
from "T" to "U" as follows.


```{r RNAseqLogo,fig.cap="Plot an RNA sequence logo",fig.width=6,fig.height=3}
rna <- pcm
rownames(rna)[4] <- "U"
motif <- new("pcm", mat=as.matrix(rna), name="RNA_motif")
plot(motif)
```

## plot an amino acid sequence logo
Given that motifStack allows to use any letters as symbols, 
it can also be used to draw amino acid sequence logos.
```{r AAseqLogo,fig.cap="Plot an sequence logo with any symbols as you want such as amino acid sequence logo",fig.width=6,fig.height=3}
library(motifStack)
protein<-read.table(file.path(find.package("motifStack"),"extdata","cap.txt"))
protein<-t(protein[,1:20])
motif<-pcm2pfm(protein)
motif<-new("pfm", mat=motif, name="CAP", 
            color=colorset(alphabet="AA",colorScheme="chemistry"))
plot(motif)
```

## plot an affinity logo
It can also be used to draw affinity logos given a position specific affinity matrix (PSAM) as described by Foat et al. [@foat2006statistical].
```{r affinityLogo,fig.cap="Plot an affinity logo",fig.width=6,fig.height=3}
library(motifStack)
motif<-matrix(
  c(
    .846, .631, .593, .000, .000, .000, .434, .410, 1.00, .655, .284, .000, .000, .771, .640, .961,
    .625, .679, .773, 1.00, 1.00, .000, .573, .238, .397, 1.00, 1.00, .000, .298, 1.00, 1.00, .996,
    1.00, 1.00, 1.00, .228, .000, 1.00, 1.00, .597, .622, .630, .000, 1.00, 1.00, .871, .617, 1.00,
    .701, .513, .658, .000, .000, .247, .542, 1.00, .718, .686, .000, .000, .000, .595, .437, .970
  ), nrow=4, byrow = TRUE)
rownames(motif) <- c("A", "C", "G", "T")
motif<-new("psam", mat=motif, name="affinity logo", 
           markers=list(new("marker", type="rect",
                            start=c(4, 11), stop=c(6, 13),
                            gp=gpar(col="#009E73", fill=NA, lty=2))))
plot(motif)
```

## plot sequence logo stack

To show multiple motifs on the same canvas as a sequence logo stack, the distance of motifs need to be calculated first. Previously,  MotIV[@Eloi2010]::`motifDistances` ( R implementation of STAMP[@Mahony2007]) is used to calculate the distance. However, The MotIV package were dropped from Bioconductor 3_12. Currently, by default, R implementation of matalign is used.  After alignment, users can use `plotMotifLogoStack`, `plotMotifLogoStackWithTree` or `plotMotifStackWithRadialPhylog` to draw sequence logos  in different layouts. To make it easy to use, we integrated different functionalities into one workflow function named as `motifStack`.



```{r logostack,fig.cap="Plot motifs with sequence logo stack style",fig.width=4,fig.height=6}
library(motifStack)
#####Input#####
motifs<-importMatrix(dir(file.path(find.package("motifStack"),
                                   "extdata"),"pcm$", 
                         full.names = TRUE))

## plot stacks
motifStack(motifs, layout="stack", ncex=1.0)
```
```{r rnalogostack,fig.cap="Plot RNA motifs with sequence logo stack style", fig.width=4,fig.height=6}
rnaMotifs <- DNAmotifToRNAmotif(motifs)
names(rnaMotifs)
motifStack(rnaMotifs, layout = "stack", 
           reorder=FALSE) ## we can also use reorder=FALSE to keep the order of input. 
```

```{r logostack2,fig.cap="Plot affinity logos with sequence logo stack style",fig.width=4,fig.height=3.5}
motif2 <- motif
motif2$mat <- motif$mat[, 5:12]
motif2$name <- "logo2"
psamMotifs <- list(motif, motif2)
motifStack(psamMotifs)
```

```{r treestack,fig.cap="Sequence logo stack with hierarchical cluster tree",fig.width=5,fig.height=6}
## plot stacks with hierarchical tree
motifStack(motifs, layout="tree")
```

```{r radialstack,fig.cap="Plot motifs in a radial style when the number of motifs is too much to be shown in a vertical stack",fig.width=6,fig.height=6}
## When the number of motifs is too much to be shown in a vertical stack, 
## motifStack can draw them in a radial style.
## random sample from MotifDb
library("MotifDb")
matrix.fly <- query(MotifDb, "Dmelanogaster")
motifs2 <- as.list(matrix.fly)
## use data from FlyFactorSurvey
motifs2 <- motifs2[grepl("Dmelanogaster\\-FlyFactorSurvey\\-",
                         names(motifs2))]
## format the names
names(motifs2) <- gsub("Dmelanogaster_FlyFactorSurvey_", "",
                       gsub("_FBgn\\d+$", "",
                            gsub("[^a-zA-Z0-9]","_",
                                 gsub("(_\\d+)+$", "", names(motifs2)))))
motifs2 <- motifs2[unique(names(motifs2))]
pfms <- sample(motifs2, 30)
## creat a list of object of pfm 
motifs2 <- mapply(pfms, names(pfms), FUN=function(.ele, .name){
  new("pfm",mat=.ele, name=.name)}, SIMPLIFY = FALSE)
## trim the motifs
motifs2 <- lapply(motifs2, trimMotif, t=0.4)
## setting colors
library(RColorBrewer)
color <- brewer.pal(10, "Set3")
## plot logo stack with radial style
motifStack(motifs2, layout="radialPhylog", 
           circle=0.3, cleaves = 0.2, 
           clabel.leaves = 0.5, 
           col.bg=rep(color, each=3), col.bg.alpha=0.3, 
           col.leaves=rep(color, each=3),
           col.inner.label.circle=rep(color, each=3), 
           inner.label.circle.width=0.05,
           col.outer.label.circle=rep(color, each=3), 
           outer.label.circle.width=0.02, 
           circle.motif=1.2,
           angle=350)
```

## plot a sequence logo cloud

We can also plot a sequence logo cloud for DNA motifs.

```{r motifCloud,fig.cap="Sequence logo cloud with rectangle packing layout",fig.width=6,fig.height=6}
## assign groups for motifs
groups <- rep(paste("group",1:5,sep=""), each=10)
names(groups) <- names(pfms)
## assign group colors
group.col <- brewer.pal(5, "Set3")
names(group.col)<-paste("group",1:5,sep="")
## create a list of pfm objects
pfms <- mapply(names(pfms), pfms, FUN=function(.ele, .pfm){
  new("pfm",mat=.pfm, name=.ele)}
               ,SIMPLIFY = FALSE)
## use matalign to calculate the distances of motifs
hc <- clusterMotifs(pfms)
## convert the hclust to phylog object
library(ade4)
phylog <- ade4::hclust2phylog(hc)
## reorder the pfms by the order of hclust
leaves <- names(phylog$leaves)
pfms <- pfms[leaves]
## extract the motif signatures
motifSig <- motifSignature(pfms, phylog, cutoffPval=0.0001, min.freq=1)
## draw the motifs with a tag-cloud style.
motifCloud(motifSig, scale=c(6, .5), 
           layout="rectangles", 
           group.col=group.col, 
           groups=groups, 
           draw.legend=TRUE)
```

## plot grouped sequence logo

Grouped sequence logo can also be plotted in radial phylogeny tree style.


```{r motifRadialPhylog,fig.cap="Grouped sequence logo with radialPhylog style layout",fig.width=6,fig.height=6}
## get the signatures from object of motifSignature
sig <- signatures(motifSig)
## set the inner-circle color for each signature
gpCol <- sigColor(motifSig)
## plot the logo stack with radial style.
plotMotifStackWithRadialPhylog(phylog=phylog, pfms=sig, 
                              circle=0.4, cleaves = 0.3, 
                              clabel.leaves = 0.5, 
                              col.bg=rep(color, each=3), col.bg.alpha=0.3, 
                              col.leaves=rep(rev(color), each=3),
                              col.inner.label.circle=gpCol, 
                              inner.label.circle.width=0.03,
                              angle=350, circle.motif=1.2, 
                              motifScale="logarithmic")
```

## motifCircos
We can also plot it with circos style. In circos style,
we can plot two group of motifs and with multiple color rings.

```{r motifCircos,fig.cap="Grouped sequence logo with circos style layout",fig.width=6,fig.height=6}
## plot the logo stack with cirsoc style.
motifCircos(phylog=phylog, pfms=pfms, pfms2=sig, 
            col.tree.bg=rep(color, each=5), col.tree.bg.alpha=0.3, 
            col.leaves=rep(rev(color), each=5),
            col.inner.label.circle=gpCol, 
            inner.label.circle.width=0.03,
            col.outer.label.circle=gpCol, 
            outer.label.circle.width=0.03,
            r.rings=c(0.02, 0.03, 0.04), 
            col.rings=list(sample(colors(), 30), 
                           sample(colors(), 30), 
                           sample(colors(), 30)),
            angle=350, motifScale="logarithmic")
```


## motifPiles

We can also plot the motifs in pile style. In pile style, 
we can plot two group of motifs with multiple types of annotation, for example heatmap.
The _col.anno_ parameter should be set as a named list.

```{r motifPilesHeatmap,fig.cap="Grouped sequence logo with a heatmap",fig.width=6,fig.height=6}
## plot the logo stack with heatmap.
df <- data.frame(A=runif(n = 30), B=runif(n = 30), C=runif(n = 30), D=runif(n = 30))
map2col <- function(x, pal){
  rg <- range(x)
  pal[findInterval(x, seq(rg[1], rg[2], length.out = length(pal)+1), 
                   all.inside = TRUE)]
}
dl <- lapply(df, map2col, pal=heat.colors(10))
## alignment of the pfms, this step will make the motif logos occupy 
## more space. Users can skip this alignment to see the difference.
pfmsAligned <- DNAmotifAlignment(pfms)
## plot motifs
motifPiles(phylog=phylog, pfms=pfmsAligned, 
            col.tree=rep(color, each=5),
            col.leaves=rep(rev(color), each=5),
            col.pfms2=gpCol, 
            r.anno=rep(0.02, length(dl)), 
            col.anno=dl,
            motifScale="logarithmic",
            plotIndex=TRUE,
            groupDistance=10)
```

# plot motifs with d3.js

Interactive plot can be generated using `browseMotifs` function which leverages the __d3.js__ library. 
All motifs on the plot are draggable and the plot can be easily exported as a **Scalable Vector Graphics (SVG)** file.


```{r browseMotifs,fig.width=8,fig.height=8}
browseMotifs(pfms = pfms, phylog = phylog, layout="tree", yaxis = FALSE, baseWidth=6, baseHeight = 15)
```

Plot the motifs in radialPhylog layout.

```{r browseMotifsRadialPhylog,fig.width=8,fig.height=8}
browseMotifs(pfms = pfms, phylog = phylog, layout="radialPhylog", yaxis = FALSE, xaxis = FALSE, baseWidth=6, baseHeight = 15)
```

# docker container for motifStack

[Docker](https://docs.docker.com/) container allows software to be packaged into containers which can be run in any platform using a virtual machine called boot2docker. To ease the installation of motifStack and its depencies, we have created a docker image containing all the components needed to run motifStack. Users can download the [motifStack docker](https://hub.docker.com/r/jianhong/motifstack/) image using the following code snippet.


<pre>
cd ~ ## in windows, please try cd c:\\ Users\\ username
docker pull jianhong/motifstack:latest
mkdir tmp4motifstack ## this will be the share folder for your host and container.
docker run -ti --rm -v ${PWD}/tmp4motifstack:/volume/data jianhong/motifstack:latest bash
  In motifstack:latest docker
    1  cd /volume/data
    2  git clone https://github.com/jianhong/motifStack.documentation.git
    3  cd motifStack.documentation/
    4  cp /usr/bin/matalign app/matalign-v4a
    5  cp /usr/bin/phylip/neighbor app/neighbor.app/Contents/MacOS/neighbor
    6  R cmd -e "rmarkdown::render('suppFigure2.Rmd')"
    7  R cmd -e "rmarkdown::render('suppFigure6.Rmd')"
</pre>

You will see the test.pdf file in the folder of tmp4motifstack. 

# plot motifs with ggplot2

motifs could be plotted by `geom_motif` function.

```{r geommotif,fig.width=8, fig.height=8}
pcm <- read.table(file.path(find.package("motifStack"), 
                            "extdata", "bin_SOLEXA.pcm"))
pcm <- pcm[,3:ncol(pcm)]
rownames(pcm) <- c("A","C","G","T")
markerRect <- new("marker", type="rect", start=6, stop=7, gp=gpar(lty=2, fill=NA, col="orange"))
markerLine <- new("marker", type="line", start=3, stop=5, gp=gpar(lwd=2, col="red"))
markerText <- new("marker", type="text", start=1, label="*", gp=gpar(cex=2, col="red"))
motif <- new("pcm", mat=as.matrix(pcm), name="bin_SOLEXA", 
             markers=c(markerRect, markerLine, markerText))
pfm <- pcm2pfm(motif)
df <- data.frame(xmin=c(.25, .25), ymin=c(.25, .75), xmax=c(.75, .75), ymax=c(.5, 1), 
                 fontfamily=c("serif", "mono"), fontface=c(2, 1))
df$motif <- list(pfm, pfm)

library(ggplot2)

ggplot(df, aes(xmin=xmin, ymin=ymin, xmax=xmax, ymax=ymax, motif=motif, 
               fontfamily=fontfamily, fontface=fontface)) + 
    geom_motif() + theme_bw() + ylim(0, 1) + xlim(0, 1)

df <- data.frame(x=.5, y=c(.25, .75), width=.5, height=.25, 
                 fontfamily=c("serif", "mono"), fontface=c(2, 1))
df$motif <- list(pfm, pfm)

ggplot(df, aes(x=x, y=y, width=width, height=height, motif=motif, 
               fontfamily=fontfamily, fontface=fontface)) + 
    geom_motif(use.xy=TRUE) + theme_bw() + ylim(0, 1) + xlim(0, 1)
```


# Session Info
```{r sessionInfo}
sessionInfo()
```

# Reference

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/plotAffinityLogo.R
\name{plotAffinityLogo}
\alias{plotAffinityLogo}
\title{plot affinity logo}
\usage{
plotAffinityLogo(
  psam,
  motifName,
  font = "sans",
  fontface = "bold",
  colset = c("#00811B", "#2000C7", "#FFB32C", "#D00001"),
  alpha = 0.5,
  newpage = TRUE,
  draw = TRUE
)
}
\arguments{
\item{psam}{a position-specific affinity matrix}

\item{motifName}{motif name}

\item{font}{font of logo}

\item{fontface}{fontface of logo}

\item{colset}{color setting for each logo letter}

\item{alpha}{Alpha channel for transparency of low affinity letters.}

\item{newpage}{plot in a new canvas or not.}

\item{draw}{Vector (logical(1)). TRUE to plot. FALSE, return a gList}
}
\value{
none
}
\description{
plot affinity logo
}
\examples{

psam <- importMatrix(file.path(find.package("motifStack"), "extdata", "PSAM.mxr"), 
                     format="psam")[[1]]
plotAffinityLogo(psam)

}
\references{
Barrett C. Foat, Alexandre V. Morozov, Harmen J. Bussemaker;
Statistical mechanical modeling of genome-wide transcription factor
occupancy data by MatrixREDUCE, Bioinformatics, Volume 22, Issue 14, 15 July
2006, Pages e141-e149, https://doi.org/10.1093/bioinformatics/btl223
}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/marker.R
\docType{class}
\name{marker-class}
\alias{marker-class}
\alias{marker}
\alias{$,marker-method}
\alias{$<-,marker-method}
\title{Class \code{marker}}
\usage{
\S4method{$}{marker}(x, name)
}
\arguments{
\item{x}{A marker object}

\item{name}{slot name of marker object}
}
\description{
An object of class \code{"marker"} represents a marker in a motif
}
\section{Objects from the Class}{
 Objects can be created by calls of the form
\code{new("marker", type, start, stop, label, gp)}.
}

\examples{

 new("marker", type="rect", start=c(2, 4), gp=gpar(lty=3))

}
\keyword{classes}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/plotMotifLogoStackWithTree.R
\name{plotMotifLogoStackWithTree}
\alias{plotMotifLogoStackWithTree}
\title{plot sequence logos stack with hierarchical cluster tree}
\usage{
plotMotifLogoStackWithTree(pfms, hc, treewidth = 1/8, trueDist = FALSE, ...)
}
\arguments{
\item{pfms}{a list of position frequency matrices, pfms must be a list of
class pfm}

\item{hc}{an object of the type produced by stats::hclust}

\item{treewidth}{the width to show tree}

\item{trueDist}{logical flags to use hclust height or not.}

\item{...}{other parameters can be passed to plotMotifLogo function}
}
\value{
none
}
\description{
plot sequence logos stack with hierarchical cluster tree
}
\examples{

  #####Input#####
  pcms<-readPCM(file.path(find.package("motifStack"), "extdata"),"pcm$")

  #####Clustering#####
  hc <- clusterMotifs(pcms)

  ##reorder the motifs for plotMotifLogoStack
  motifs<-pcms[hc$order]
  motifs <- lapply(motifs, pcm2pfm)
  ##do alignment
  motifs<-DNAmotifAlignment(motifs)
  ##plot stacks
  plotMotifLogoStack(motifs, ncex=1.0)
  plotMotifLogoStackWithTree(motifs, hc=hc)

}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/DNAmotifToRNAmotif.R
\name{DNAmotifToRNAmotif}
\alias{DNAmotifToRNAmotif}
\title{convert DNA motif into RNA motif}
\usage{
DNAmotifToRNAmotif(pfm)
}
\arguments{
\item{pfm}{An object of "pcm" or "pfm"}
}
\value{
An object of "pcm" or "pfm" of RNA motif
}
\description{
convert DNA motif into RNA motif
}
\examples{
motifs<-importMatrix(dir(file.path(find.package("motifStack"),
                         "extdata"),"pcm$", full.names = TRUE))
rnaMotifs <- DNAmotifToRNAmotif(motifs)
}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/plotMotifLogo.R
\name{geom_motif}
\alias{geom_motif}
\title{geom_motif}
\usage{
geom_motif(
  mapping = NULL,
  data = NULL,
  stat = "identity",
  position = "identity",
  ...,
  ic.scale = TRUE,
  use.xy = FALSE,
  show.legend = NA,
  inherit.aes = TRUE
)
}
\arguments{
\item{mapping}{Set of aesthetic mappings created by aes() or aes_(). If
specified and inherit.aes = TRUE (the default), it is combined with the
default mapping at the top level of the plot.  You must supply mapping if
there is no plot mapping.}

\item{data}{The data to be displayed in this layer.}

\item{stat}{The statistical transformation to use on the data for this
layer, as a string.}

\item{position}{Position adjustment, either as a string, or the result of a
call to a position adjustment function.}

\item{\dots}{Other arguments passed on to layer().}

\item{ic.scale}{logical If TRUE, the height of each column is proportional
to its information content.  Otherwise, all columns have the same height.}

\item{use.xy}{logical If TRUE, the required aesthethics will be x, y, width,
height, and motif.  Otherwise, xmin, ymin, xmax, ymax and motif.}

\item{show.legend}{Not used.}

\item{inherit.aes}{If FALSE, overrides the default aesthetics, rather than
combining with them.}
}
\value{
a layer that contains GeomMotif object.
}
\description{
geom_motif uses the locations of the four corners (xmin, xmax, ymin and
ymax) to plot motifs.
}
\section{Aesthetics}{
 geom_motif() understands the following aesthetics
(required aesthetics are in bold): \itemize{ \item \strong{\code{xmin}}
\item \strong{\code{xmax}} \item \strong{\code{ymin}} \item
\strong{\code{ymax}} \item \strong{\code{motif}} \item \code{angle} \item
\code{fontfamily} \item \code{fontface} }

OR

\itemize{ \item \strong{\code{x}} \item \strong{\code{y}} \item
\strong{\code{width}} \item \strong{\code{height}} \item
\strong{\code{motif}} \item \code{angle} \item \code{fontfamily} \item
\code{fontface} }
}

\examples{

pcm <- read.table(file.path(find.package("motifStack"), 
                            "extdata", "bin_SOLEXA.pcm"))
pcm <- pcm[,3:ncol(pcm)]
rownames(pcm) <- c("A","C","G","T")
motif <- new("pcm", mat=as.matrix(pcm), name="bin_SOLEXA")

df <- data.frame(xmin=c(.25, .25), ymin=c(.25, .75), xmax=c(.75, .75), ymax=c(.5, 1))
df$motif <- list(pcm2pfm(motif), pcm2pfm(motif))

library(ggplot2)
ggplot(df, aes(xmin=xmin, ymin=ymin, xmax=xmax, ymax=ymax, motif=motif)) + 
geom_motif() + theme_bw() + ylim(0, 1) + xlim(0, 1)

}
\author{
Jianhong Ou
}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/plotMotifLogo.R
\name{plotMotifLogo}
\alias{plotMotifLogo}
\title{plot sequence logo}
\usage{
plotMotifLogo(
  pfm,
  motifName,
  p = rep(0.25, 4),
  font = "sans",
  fontface = "bold",
  colset = c("#00811B", "#2000C7", "#FFB32C", "#D00001"),
  xaxis = TRUE,
  yaxis = TRUE,
  xlab = "position",
  ylab = "bits",
  xlcex = 1.2,
  ylcex = 1.2,
  ncex = 1.2,
  ic.scale = TRUE,
  newpage = TRUE,
  margins = c(4.1, 4.1, 2.1, 0.1),
  draw = TRUE,
  ...
)
}
\arguments{
\item{pfm}{a position frequency matrices}

\item{motifName}{motif name}

\item{p}{background possibility}

\item{font}{font of logo}

\item{fontface}{fontface of logo}

\item{colset}{color setting for each logo letter}

\item{xaxis}{draw x-axis or not. If a vector of character or numeric is
provided, the function will try to plot the x-axis by setting the labels
as the vectors.}

\item{yaxis}{draw y-axis or not}

\item{xlab}{x-label, do nothing if set xlab as NA}

\item{ylab}{y-label, do nothing if set ylab as NA}

\item{xlcex}{cex value for x-label}

\item{ylcex}{cex value for y-label}

\item{ncex}{cex value for motif name}

\item{ic.scale}{logical If TRUE, the height of each column is proportional
to its information content. Otherwise, all columns have the same height.
It will also can be set as FALSE followed by a numeric vectors.
The format is c(FALSE, scale).
If it is FALSE followed by a number (eg c(FALSE, 100)), 
the y axis labels will be re-scaled by 100.}

\item{newpage}{logical If TRUE, plot it in a new page.}

\item{margins}{A numeric vector interpreted in the same way as par(mar) in
base graphics.}

\item{draw}{Vector (logical(1)). TRUE to plot. FALSE, return a gList}

\item{...}{Not used.}
}
\value{
none
}
\description{
plot amino acid or DNA sequence logo
}
\examples{

pcm<-matrix(runif(40,0,100),nrow=4,ncol=10)
pfm<-pcm2pfm(pcm)
rownames(pfm)<-c("A","C","G","T")
plotMotifLogo(pfm)

}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/plotMotifLogo.R
\name{motifGrob}
\alias{motifGrob}
\title{Motif Grob}
\usage{
motifGrob(
  pfm,
  x = unit(0.5, "npc"),
  y = unit(0.5, "npc"),
  width = unit(1, "npc"),
  height = unit(1, "npc"),
  angle = 0,
  ic.scale = TRUE,
  default.units = "native",
  name = NULL,
  gp = gpar(fontfamily = "sans", fontface = "bold")
)
}
\arguments{
\item{pfm}{an object of pfm}

\item{x}{A numeric vector or unit object specifying x-values.}

\item{y}{A numeric vector or unit object specifying y-values.}

\item{width}{A numeric vector or unit object specifying width.}

\item{height}{A numeric vector or unit object specifying height.}

\item{angle}{A numeric value indicating the angle of rotation of the motif.
Positive values indicate the amount of rotation, in degrees, anticlockwise
from the positive x-axis.}

\item{ic.scale}{logical If TRUE, the height of each column is proportional
to its information content. Otherwise, all columns have the same height.}

\item{default.units}{A string indicating the default units to use if x, y,
width, or height are only given as numeric vectors.}

\item{name}{A character value to uniquely identify the motifGrob once it has
been pushed onto the grob tree.}

\item{gp}{A gpar object, typically the output from a call to the function
gpar. The list will be used as parameter of plotMotifLogoA.}
}
\value{
An gTree object.
}
\description{
This function create a motif grob.
}
\examples{

pcm<-matrix(runif(40,0,100),nrow=4,ncol=10)
pfm<-pcm2pfm(pcm)
rownames(pfm)<-c("A","C","G","T")
motif <- new("pfm", mat=pfm, name="bin_SOLEXA")
motifGrob(motif)

}
\author{
Jianhong Ou
}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/plotMotifStackWithRadialPhylog.R
\name{plotMotifStackWithRadialPhylog}
\alias{plotMotifStackWithRadialPhylog}
\title{plot sequence logo stacks with a radial phylogenic tree}
\usage{
plotMotifStackWithRadialPhylog(
  phylog,
  pfms = NULL,
  circle = 0.75,
  circle.motif = NA,
  cleaves = 1,
  cnodes = 0,
  labels.leaves = names(phylog$leaves),
  clabel.leaves = 1,
  labels.nodes = names(phylog$nodes),
  clabel.nodes = 0,
  draw.box = FALSE,
  col.leaves = rep("black", length(labels.leaves)),
  col.leaves.bg = NULL,
  col.leaves.bg.alpha = 1,
  col.bg = NULL,
  col.bg.alpha = 1,
  col.inner.label.circle = NULL,
  inner.label.circle.width = "default",
  col.outer.label.circle = NULL,
  outer.label.circle.width = "default",
  clockwise = FALSE,
  init.angle = if (clockwise) 90 else 0,
  angle = 360,
  pfmNameSpliter = ";",
  rcpostfix = "(RC)",
  motifScale = c("linear", "logarithmic"),
  ic.scale = TRUE,
  plotIndex = FALSE,
  IndexCol = "black",
  IndexCex = 0.8,
  groupDistance = NA,
  groupDistanceLineCol = "red",
  plotAxis = FALSE,
  font = "sans",
  ...
)
}
\arguments{
\item{phylog}{an object of class phylog}

\item{pfms}{a list of objects of class pfm}

\item{circle}{a size coefficient for the outer circle of the labels. Please
note this is the position of inner.label.cirle.}

\item{circle.motif}{a size coefficient for the motif circle}

\item{cleaves}{a character size for plotting the points that represent the
leaves, used with par("cex")*cleaves. If zero, no points are drawn}

\item{cnodes}{a character size for plotting the points that represent the
nodes, used with par("cex")*cnodes. If zero, no points are drawn}

\item{labels.leaves}{a vector of strings of characters for the leaves labels}

\item{clabel.leaves}{a character size for the leaves labels, used with
par("cex")*clabel.leaves}

\item{labels.nodes}{a vector of strings of characters for the nodes labels}

\item{clabel.nodes}{a character size for the nodes labels, used with
par("cex")*clabel.nodes. If zero, no nodes labels are drawn}

\item{draw.box}{if TRUE draws a box around the current plot with the
function box()}

\item{col.leaves}{a vector of colors for leaves labels}

\item{col.leaves.bg}{a vector of colors for background of leaves labels}

\item{col.leaves.bg.alpha}{alpha value [0, 1] for the colors of backgroud of
leaves labels}

\item{col.bg}{a vector of colors for tree background}

\item{col.bg.alpha}{a alpha value [0, 1] of colors for tree background}

\item{col.inner.label.circle}{a vector of colors for inner cirlce of pfms}

\item{inner.label.circle.width}{width for inner circle of pfms}

\item{col.outer.label.circle}{a vector of colors for outer circle of pfms}

\item{outer.label.circle.width}{width for outer circle of pfms}

\item{clockwise}{a logical value indicating if slices are drawn clockwise or
counter clockwise}

\item{init.angle}{number specifying the starting angle (in degrees) for the
slices. Defaults to 0 (i.e., `3 o'clock`) unless clockwise is true where
init.angle defaults to 90 (degrees), (i.e., `12 o'clock`)}

\item{angle}{number specifying the angle (in degrees) for phylogenic tree.
Defaults 360}

\item{pfmNameSpliter}{spliter when name of pfms contain multiple node of
labels.leaves}

\item{rcpostfix}{the postfix for reverse complements}

\item{motifScale}{the scale of logo size}

\item{ic.scale}{logical. If TRUE, the height of each column is proportional
to its information content. Otherwise, all columns have the same height.}

\item{plotIndex}{logical. If TRUE, will plot index number in the motifLogo
which can help user to describe the motifLogo}

\item{IndexCol}{The color of the index number when plotIndex is TRUE.}

\item{IndexCex}{The cex of the index number when plotIndex is TRUE.}

\item{groupDistance}{show groupDistance on the draw}

\item{groupDistanceLineCol}{groupDistance line color, default: red}

\item{plotAxis}{logical. If TRUE, will plot distance axis.}

\item{font}{font of logo}

\item{...}{not used.}
}
\value{
none
}
\description{
plot sequence logo stacks with a radial phylogenic tree
}
\examples{

  if(interactive() || Sys.getenv("USER")=="jianhongou"){
    library("MotifDb")
    matrix.fly <- query(MotifDb, "Dmelanogaster")
    motifs <- as.list(matrix.fly)
    motifs <- motifs[grepl("Dmelanogaster-FlyFactorSurvey-", 
                            names(motifs), fixed=TRUE)]
    names(motifs) <- gsub("Dmelanogaster_FlyFactorSurvey_", "", 
                gsub("_FBgn[0-9]+$", "", 
                  gsub("[^a-zA-Z0-9]","_", 
                     gsub("(_[0-9]+)+$", "", names(motifs)))))
    motifs <- motifs[unique(names(motifs))]
    pfms <- sample(motifs, 50)
    hc <- clusterMotifs(pfms)
    library(ade4)
    phylog <- ade4::hclust2phylog(hc)
    leaves <- names(phylog$leaves)
    pfms <- pfms[leaves]
    pfms <- mapply(pfms, names(pfms), FUN=function(.ele, .name){
                 new("pfm",mat=.ele, name=.name)})
    pfms <- DNAmotifAlignment(pfms, minimalConsensus=3)
    library(RColorBrewer)
    color <- brewer.pal(12, "Set3")
    plotMotifStackWithRadialPhylog(phylog, pfms, circle=0.9, 
                 cleaves = 0.5, clabel.leaves = 0.7, 
                 col.bg=rep(color, each=5), col.leaves=rep(color, each=5))
  }

}
\seealso{
\link[ade4:plot.phylog]{plot.phylog}
}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/publicUtilities.R
\name{colorset}
\alias{colorset}
\title{retrieve color setting for logo}
\usage{
colorset(alphabet = "DNA", colorScheme = "auto")
}
\arguments{
\item{alphabet}{character, 'DNA', 'RNA' or 'AA'}

\item{colorScheme}{'auto', 'charge', 'chemistry', 'classic' or
'hydrophobicity' for AA, 'auto', 'basepairing', or 'blindnessSafe' for DNA
ro RNA}
}
\value{
A character vector of color scheme
}
\description{
retrieve color setting for logo
}
\examples{

col <- colorset("AA", "hydrophobicity")

}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/clusterMotifs.R
\name{clusterMotifs}
\alias{clusterMotifs}
\title{cluster motifs}
\usage{
clusterMotifs(motifs, ...)
}
\arguments{
\item{motifs}{A list of pcms of pfms.}

\item{...}{parameter to be passed to \link{matalign} function.}
}
\value{
An object of hclust.
}
\description{
A help function to do matalign and motifHclust in one function.
}
\examples{
 if(interactive() || Sys.getenv("USER")=="jianhongou"){
  fp <- system.file("extdata", package="motifStack")
  fs <- dir(fp, "pcm$")
  pcms <- importMatrix(file.path(fp, fs), format="pcm")
  hc <- clusterMotifs(pcms)
 }
}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/pcm.R
\docType{class}
\name{pcm-class}
\alias{pcm-class}
\alias{pcm}
\alias{$,pcm-method}
\alias{$<-,pcm-method}
\alias{plot}
\alias{plot,pcm,ANY-method}
\alias{as}
\alias{coerce,pcm,matrix-method}
\alias{trimMotif}
\alias{trimMotif,pcm,numeric-method}
\alias{matrixReverseComplement}
\alias{matrixReverseComplement,pcm-method}
\alias{addBlank}
\alias{addBlank,pcm,numeric,logical-method}
\alias{getIC}
\alias{getIC,pcm,ANY-method}
\alias{pcm2pfm}
\alias{pcm2pfm,pcm,ANY-method}
\alias{pcm2pfm,matrix,ANY-method}
\alias{pcm2pfm,matrix,numeric-method}
\alias{pcm2pfm,data.frame,ANY-method}
\alias{pcm2pfm,data.frame,numeric-method}
\alias{pcm2pfm,list,ANY-method}
\alias{pcm2pfm,list,numeric-method}
\alias{pcm2pssm}
\alias{pcm2pssm,pcm,ANY-method}
\alias{pcm2pssm,matrix,ANY-method}
\alias{pcm2pssm,matrix,numeric-method}
\alias{pcm2pssm,data.frame,ANY-method}
\alias{pcm2pssm,data.frame,numeric-method}
\alias{pcm2pssm,list,ANY-method}
\alias{pcm2pssm,list,numeric-method}
\alias{as.data.frame,pcm-method}
\alias{format,pcm-method}
\title{Class \code{"pcm"}}
\usage{
\S4method{$}{pcm}(x, name)

\S4method{plot}{pcm,ANY}(x, y = "missing", ...)

trimMotif(x, t)

matrixReverseComplement(x)

addBlank(x, n, b)

getIC(x, p)

pcm2pfm(x, background)

pcm2pssm(x, background)

\S4method{as.data.frame}{pcm}(x, row.names = NULL, optional = FALSE, ...)

\S4method{format}{pcm}(x, ...)
}
\arguments{
\item{x}{An object of class \code{pcm}. For \code{getIC}, if parameter p is
followed, x should be an object of matrix.  For \code{pcm2pfm}, x also could
be an object of matrix.}

\item{name}{slot name of pcm object.}

\item{y}{Not use.}

\item{\dots}{Further potential arguments passed to \code{plotMotifLogo}.}

\item{t}{numeric value of information content threshold for trimming.}

\item{n}{how many spaces should be added.}

\item{b}{logical value to indicate where the space should be added.}

\item{p}{p is the background frequency.}

\item{background}{a \code{"numeric"} vector. The background frequency.}

\item{row.names, optional}{see as.data.frame}
}
\description{
An object of class \code{"pcm"} represents the position count matrix of a
DNA/RNA/amino-acid sequence motif. The entry stores a matrix, which in row
i, column j gives the counts of observing nucleotide/or amino acid i in
position j of the motif.

methods for pcm objects.
}
\section{Objects from the Class}{
 Objects can be created by calls of the form
\code{new("pcm", mat, name, alphabet, color, background)}.
}

\section{Methods}{
 \describe{ \item{addBlank}{\code{signature(x="pcm",
n="numeric", b="logical")} add space into the position count matrix for
alignment. b is a bool value, if TRUE, add space to the 3' end, else add
space to the 5' end. n indicates how many spaces should be added.}

\item{coerce}{\code{signature(from = "pcm", to = "matrix")}: convert object
pcm to matrix }

\item{getIC}{\code{signature(x = "pcm",)} Calculate information content
profile for position frequency matrix. }

\item{matrixReverseComplement}{\code{signature(x = "pcm")} get the reverse
complement of position frequency matrix.}

\item{plot}{\code{signature(x = "pcm")} Plots the sequence logo of the
position count matrix. }

\item{trimMotif}{\code{signature(x = "pcm", t= "numeric")} trim motif by
information content. }

\item{$, $<-}{Get or set the slot of \code{\link{pcm-class}}}

\item{as.data.frame}{convert \code{\link{pcm-class}} to a data.frame}
\item{format}{return the name_pcm of \code{\link{pcm-class}}} }
}

\examples{

pcm <- read.table(file.path(find.package("motifStack"), "extdata", "bin_SOLEXA.pcm"))
pcm <- pcm[,3:ncol(pcm)]
rownames(pcm) <- c("A","C","G","T")
motif <- new("pcm", mat=as.matrix(pcm), name="bin_SOLEXA")
plot(motif)
pcm2pfm(pcm)
pcm2pssm(pcm)

pcm <- read.table(file.path(find.package("motifStack"), "extdata", "bin_SOLEXA.pcm"))
pcm <- pcm[,3:ncol(pcm)]
rownames(pcm) <- c("A","C","G","T")
motif <- new("pcm", mat=as.matrix(pcm), name="bin_SOLEXA")
getIC(motif)
matrixReverseComplement(motif)
as(motif,"matrix")
pcm2pfm(motif)
as.data.frame(motif)
format(motif)

}
\keyword{classes}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/getRankedUniqueMotifs.R
\name{getRankedUniqueMotifs}
\alias{getRankedUniqueMotifs}
\title{get the unique motif in each category grouped by distance}
\usage{
getRankedUniqueMotifs(phylog, attr)
}
\arguments{
\item{phylog}{an object of class phylog}

\item{attr}{attribute used for category of motifs}
}
\value{
return a list: \item{uni.rank}{unique motif ranks}
\item{uni.length}{length of unique motif grouped by distance}
\item{uni.list}{unique motif names grouped by distance}
}
\description{
to get the unique motif in a given category, eg by species.
}
\examples{

   if(interactive() || Sys.getenv("USER")=="jianhongou"){
        library("MotifDb")
        matrix.fly <- query(MotifDb, "Dmelanogaster")
        matrix.human <- query(MotifDb, "Hsapiens")
        pfms <- c(as.list(matrix.fly), as.list(matrix.human))
        pfms <- pfms[sample(seq_along(pfms), 100)]
        hc <- clusterMotifs(pfms)
        library(ade4)
        phylog <- ade4::hclust2phylog(hc)
        leaves <- names(phylog$leaves)
        attr <- gsub("^(.*?)_.*$", "\1", leaves)
        getRankedUniqueMotifs(phylog, attr)
    }

}
\author{
Jianhong Ou
}
\keyword{misc}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/publicUtilities.R
\name{pfm2pwm}
\alias{pfm2pwm}
\title{convert pfm object to PWM}
\usage{
pfm2pwm(x, N = 10000)
}
\arguments{
\item{x}{an object of \code{\link{pfm}} or \code{\link{pcm}} or matrix}

\item{N}{Total number of event counts used for pfm generation.}
}
\value{
A numeric matrix representing the Position Weight Matrix for PWM.
}
\description{
convert pfm object to PWM
}
\examples{

library("MotifDb")
matrix.fly <- query(MotifDb, "Dmelanogaster")
pfm2pwm(matrix.fly[[1]])

}
\seealso{
\code{\link[Biostrings:matchPWM]{PWM}}
}
\author{
Jianhong Ou
}
\keyword{misc}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/AAmotifAlignment.R
\name{AAmotifAlignment}
\alias{AAmotifAlignment}
\title{align AA motifs}
\usage{
AAmotifAlignment(pcms, threshold = 0.4, minimalConsensus = 0)
}
\arguments{
\item{pcms}{a list of position frequency matrices, pfms must be a list of
class pcm}

\item{threshold}{information content cutoff threshold for useful postions}

\item{minimalConsensus}{minimal length of consensus for alignment}
}
\value{
a list of aligned motifs
}
\description{
align AA motifs for plotting motifs stack
}
\examples{

pcms<-importMatrix(system.file("extdata", "prot.meme", package="motifStack"),
                   format="meme", to="pfm")
motifs<-AAmotifAlignment(pcms)

}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/pfm.R
\docType{class}
\name{pfm-class}
\alias{pfm-class}
\alias{pfm}
\alias{$,pfm-method}
\alias{$<-,pfm-method}
\alias{plot,pfm,ANY-method}
\alias{coerce}
\alias{coerce,pfm,matrix-method}
\alias{getIC,pfm,ANY-method}
\alias{getIC,matrix,numeric-method}
\alias{getIC,matrix,matrix-method}
\alias{trimMotif,pfm,numeric-method}
\alias{matrixReverseComplement,pfm-method}
\alias{addBlank,pfm,numeric,logical-method}
\alias{as.data.frame,pfm-method}
\alias{format,pfm-method}
\title{Class \code{"pfm"}}
\usage{
\S4method{$}{pfm}(x, name)

\S4method{plot}{pfm,ANY}(x, y = "missing", ...)

\S4method{getIC}{pfm,ANY}(x, p = "missing")

\S4method{trimMotif}{pfm,numeric}(x, t)

\S4method{matrixReverseComplement}{pfm}(x)

\S4method{addBlank}{pfm,numeric,logical}(x, n, b)

\S4method{as.data.frame}{pfm}(x, row.names = NULL, optional = FALSE, ...)

\S4method{format}{pfm}(x, ...)
}
\arguments{
\item{x}{An object of class \code{pfm}. For \code{getIC}, if parameter p is
followed, x should be an object of matrix.}

\item{name}{Slot name.}

\item{y}{Not use.}

\item{\dots}{Further potential arguments passed to \code{plotMotifLogo}.}

\item{p}{p is the background frequency.}

\item{t}{numeric value of information content threshold for trimming.}

\item{n}{how many spaces should be added.}

\item{b}{logical value to indicate where the space should be added.}

\item{row.names, optional}{see as.data.frame}
}
\description{
An object of class \code{"pfm"} represents the position frequency matrix of
a DNA/RNA/amino-acid sequence motif. The entry stores a matrix, which in row
i, column j gives the frequency of observing nucleotide/or amino acid i in
position j of the motif.

methods for pfm objects.
}
\section{Objects from the Class}{
 Objects can be created by calls of the form
\code{new("pfm", mat, name, alphabet, color, background)}.
}

\section{Methods}{
 \describe{ \item{addBlank}{\code{signature(x="pfm",
n="numeric", b="logical")} add space into the position frequency matrix for
alignment. b is a bool value, if TRUE, add space to the 3' end, else add
space to the 5' end. n indicates how many spaces should be added.}

\item{getIC}{\code{signature(x = "pfm",)} Calculate information content
profile for position frequency matrix. }

\item{getIC}{\code{signature(x = "matrix", p = "numeric")} Calculate
information content profile for matrix. p is the background frequency}

\item{matrixReverseComplement}{\code{signature(x = "pfm")} get the reverse
complement of position frequency matrix.}

\item{plot}{\code{signature(x = "pfm")} Plots the sequence logo of the
position frequency matrix. }

\item{trimMotif}{\code{signature(x = "pfm", t= "numeric")} trim motif by
information content. }

\item{$, $<-}{Get or set the slot of \code{\link{pfm-class}}}
\item{as.data.frame}{convert \code{\link{pfm-class}} to a data.frame}
\item{format}{return the name_pfm of \code{\link{pfm-class}}} }
}

\examples{

pcm <- read.table(file.path(find.package("motifStack"), "extdata", "bin_SOLEXA.pcm"))
pcm <- pcm[,3:ncol(pcm)]
rownames(pcm) <- c("A","C","G","T")
motif <- pcm2pfm(pcm)
motif <- new("pfm", mat=motif, name="bin_SOLEXA")
plot(motif)


pcm <- read.table(file.path(find.package("motifStack"), "extdata", "bin_SOLEXA.pcm"))
pcm <- pcm[,3:ncol(pcm)]
rownames(pcm) <- c("A","C","G","T")
motif <- pcm2pfm(pcm)
motif <- new("pfm", mat=motif, name="bin_SOLEXA")
getIC(motif)
matrixReverseComplement(motif)
addBlank(motif, 1, FALSE)
addBlank(motif, 3, TRUE)
as(motif,"matrix")
as.data.frame(motif)
format(motif)

}
\keyword{classes}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/plotMotifLogo.R
\name{plotMotifLogoA}
\alias{plotMotifLogoA}
\title{plot sequence logo without plot.new}
\usage{
plotMotifLogoA(
  pfm,
  font = "sans",
  fontface = "bold",
  ic.scale = TRUE,
  draw = TRUE
)
}
\arguments{
\item{pfm}{an object of pfm}

\item{font}{font of logo}

\item{fontface}{fontface of logo}

\item{ic.scale}{logical If TRUE, the height of each column is proportional
to its information content. Otherwise, all columns have the same height.}

\item{draw}{Vector (logical(1)). TRUE to plot. FALSE, return a gList}
}
\value{
none
}
\description{
plot amino acid or DNA sequence logo in a given canvas
}
\examples{

pcm<-matrix(runif(40,0,100),nrow=4,ncol=10)
pfm<-pcm2pfm(pcm)
rownames(pfm)<-c("A","C","G","T")
motif <- new("pfm", mat=pfm, name="bin_SOLEXA")
plotMotifLogoA(motif)

}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/mergeMotifs.R
\name{mergeMotifs}
\alias{mergeMotifs}
\title{merge multiple motifs}
\usage{
mergeMotifs(..., bgNoise = NA)
}
\arguments{
\item{...}{\link{pcm} or \link{pfm} objects}

\item{bgNoise}{if it is not NA, test will using a background by
Dirichlet(1)-distributed random frequencies with weight bg.noise.  The value
of bgNoise should be a number in the range of 0 to 1, eg. 0.05}
}
\value{
a \link{pfm} object
}
\description{
merge multiple motifs by calculate mean of each position
}
\examples{

    pcms<-readPCM(file.path(find.package("motifStack"), "extdata"),"pcm$")
    mergeMotifs(pcms)

}
\author{
Jianhong Ou
}
\keyword{misc}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/plotMotifLogoStack.R
\name{plotMotifLogoStack}
\alias{plotMotifLogoStack}
\title{plot sequence logos stack}
\usage{
plotMotifLogoStack(pfms, ...)
}
\arguments{
\item{pfms}{a list of position frequency matrices, pfms must be a list of
class pfm}

\item{...}{other parameters can be passed to plotMotifLogo function}
}
\value{
none
}
\description{
plot sequence logos stack
}
\examples{

  pcm1<-matrix(c(0,50,0,50,
           100,0,0,0,
           0,100,0,0,
           0,0,100,0,
           0,0,0,100,
           50,50,0,0,
           0,0,50,50), nrow=4)
  pcm2<-matrix(c(50,50,0,0,
           0,100,0,0,
           0,50,50,0,
           0,0,0,100,
           50,50,0,0,
           0,0,50,50), nrow=4)
  rownames(pcm1)<-c("A","C","G","T")
  rownames(pcm2)<-c("A","C","G","T")
  pfms<-list(p1=new("pfm",mat=pcm2pfm(pcm1),name="m1"),
         p2=new("pfm",mat=pcm2pfm(pcm2),name="m2"))
  pfms<-DNAmotifAlignment(pfms)
  plotMotifLogoStack(pfms)

}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/browseMotifs.R
\name{browseMotifs}
\alias{browseMotifs}
\title{browse motifs}
\usage{
browseMotifs(
  pfms,
  phylog,
  layout = c("tree", "cluster", "radialPhylog"),
  nodeRadius = 2.5,
  baseWidth = 12,
  baseHeight = 30,
  xaxis = TRUE,
  yaxis = TRUE,
  width = NULL,
  height = NULL,
  ...
)
}
\arguments{
\item{pfms}{a list of \link{pfm}}

\item{phylog}{layout type. see \link[Rgraphviz]{GraphvizLayouts}}

\item{layout}{layout type. Could be tree, cluster or radialPhylog.}

\item{nodeRadius}{node radius, default 2.5px.}

\item{baseWidth, baseHeight}{width and height of each alphabet of the motif
logo.}

\item{xaxis, yaxis}{plot x-axis or y-axis or not in the motifs.}

\item{width}{width of the figure}

\item{height}{height of the figure}

\item{...}{parameters not used}
}
\value{
An object of class htmlwidget that will intelligently print itself
into HTML in a variety of contexts including the R console, within R
Markdown documents, and within Shiny output bindings.
}
\description{
browse motifs in a web browser
}
\examples{

if(interactive() || Sys.getenv("USER")=="jianhongou"){
 library("MotifDb")
 matrix.fly <- query(MotifDb, "Dmelanogaster")
 motifs <- as.list(matrix.fly)
 motifs <- motifs[grepl("Dmelanogaster-FlyFactorSurvey-", 
                        names(motifs), fixed=TRUE)]
 names(motifs) <- gsub("Dmelanogaster_FlyFactorSurvey_", "", 
                      gsub("_FBgn[0-9]+$", "", 
                           gsub("[^a-zA-Z0-9]","_", 
                                gsub("(_[0-9]+)+$", "", names(motifs)))))
 motifs <- motifs[unique(names(motifs))]
 pfms <- sample(motifs, 10)
 pfms <- mapply(pfms, names(pfms), FUN=function(.ele, .name){
                  new("pfm",mat=.ele, name=.name)})
 browseMotifs(pfms)
}

}
\keyword{plot}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/publicUtilities.R
\name{readPCM}
\alias{readPCM}
\title{read pcm from a path}
\usage{
readPCM(path = ".", pattern = NULL)
}
\arguments{
\item{path}{a character vector of full path names}

\item{pattern}{an optional regular expression}
}
\value{
A list of \code{\link{pcm}} objects
}
\description{
read position count matrix from a path
}
\examples{

pcms<-readPCM(file.path(find.package("motifStack"), "extdata"),"pcm$")

}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/reorderUPGMAtree.R
\name{reorderUPGMAtree}
\alias{reorderUPGMAtree}
\title{re-order UPGMA tree}
\usage{
reorderUPGMAtree(phylog, motifs, rcpostfix = "(RC)")
}
\arguments{
\item{phylog}{an object of phylog}

\item{motifs}{a list of objects of pfm}

\item{rcpostfix}{the postfix for reverse complements}
}
\value{
an object of phylog
}
\description{
re-order the UPGMA tree by adjacent motif distance
}
\examples{

  if(interactive() || Sys.getenv("USER")=="jianhongou"){
    library("MotifDb")
    matrix.fly <- query(MotifDb, "Dmelanogaster")
    motifs <- as.list(matrix.fly)
    motifs <- motifs[grepl("Dmelanogaster-FlyFactorSurvey-", names(motifs), fixed=TRUE)]
    names(motifs) <- gsub("Dmelanogaster_FlyFactorSurvey_", "", 
                gsub("_FBgn[0-9]+$", "", 
                  gsub("[^a-zA-Z0-9]","_", 
                     gsub("(_[0-9]+)+$", "", names(motifs)))))
    motifs <- motifs[unique(names(motifs))]
    pfms <- sample(motifs, 50)
    hc <- clusterMotifs(pfms)
    library(ade4)
    phylog <- ade4::hclust2phylog(hc)
    pfms <- mapply(pfms, names(pfms), FUN=function(.ele, .name){
                 new("pfm",mat=.ele, name=.name)})
    reorderUPGMAtree(phylog, pfms)
  }

}
\author{
Jianhong Ou
}
\keyword{misc}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/pssm.R
\docType{class}
\name{pssm-class}
\alias{pssm-class}
\alias{pssm}
\alias{$,pssm-method}
\alias{$<-,pssm-method}
\alias{plot,pssm,ANY-method}
\alias{coerce()}
\alias{coerce,pssm,matrix-method}
\alias{matrixReverseComplement,pssm-method}
\alias{addBlank,pssm,numeric,logical-method}
\alias{as.data.frame,pssm-method}
\alias{format,pssm-method}
\title{Class \code{"pssm"}}
\usage{
\S4method{$}{pssm}(x, name)

\S4method{plot}{pssm,ANY}(x, y = "missing", ...)

\S4method{matrixReverseComplement}{pssm}(x)

\S4method{addBlank}{pssm,numeric,logical}(x, n, b)

\S4method{as.data.frame}{pssm}(x, row.names = NULL, optional = FALSE, ...)

\S4method{format}{pssm}(x, ...)
}
\arguments{
\item{x}{An object of class \code{pssm}. For \code{getIC}, if parameter p is
followed, x should be an object of matrix.}

\item{name}{Slot name.}

\item{y}{Not use.}

\item{\dots}{Further potential arguments passed to \code{plotMotifLogo}.}

\item{n}{how many spaces should be added.}

\item{b}{logical value to indicate where the space should be added.}

\item{row.names, optional}{see as.data.frame}
}
\description{
An object of class \code{"pssm"} represents the position specific score 
matrix of a DNA/RNA/amino-acid sequence motif. The entry stores a matrix, 
which in row i, column j gives the log-odds probability of nucleotide/or 
amino acid i in position j of the motif.

methods for pssm objects.
}
\section{Objects from the Class}{
 Objects can be created by calls of the form
\code{new("pssm", mat, name, alphabet, color, background)}.
}

\section{Methods}{
 \describe{ \item{addBlank}{\code{signature(x="pssm",
n="numeric", b="logical")} add space into the position frequency matrix for
alignment. b is a bool value, if TRUE, add space to the 3' end, else add
space to the 5' end. n indicates how many spaces should be added.}

\item{matrixReverseComplement}{\code{signature(x = "pssm")} get the reverse
complement of position frequency matrix.}

\item{plot}{\code{signature(x = "pssm")} Plots the sequence logo of the
position frequency matrix. }

\item{$, $<-}{Get or set the slot of \code{\link{pssm-class}}}
\item{as.data.frame}{convert \code{\link{pssm-class}} to a data.frame}
\item{format}{return the name_pssm of \code{\link{pssm-class}}} }
}

\examples{

pcm <- read.table(file.path(find.package("motifStack"), 
                            "extdata", "bin_SOLEXA.pcm"))
pcm <- pcm[,3:ncol(pcm)]
rownames(pcm) <- c("A","C","G","T")
motif <- pcm2pssm(pcm)
motif <- new("pssm", mat=motif, name="bin_SOLEXA")
plot(motif)


pcm <- read.table(file.path(find.package("motifStack"), 
                  "extdata", "bin_SOLEXA.pcm"))
pcm <- pcm[,3:ncol(pcm)]
rownames(pcm) <- c("A","C","G","T")
motif <- pcm2pssm(pcm)
motif <- new("pssm", mat=motif, name="bin_SOLEXA")
matrixReverseComplement(motif)
addBlank(motif, 1, FALSE)
addBlank(motif, 3, TRUE)
as(motif,"matrix")
as.data.frame(motif)
format(motif)

}
\keyword{classes}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/matalign.R
\name{compare2profiles}
\alias{compare2profiles}
\title{compare two profiles}
\usage{
compare2profiles(
  pcm1,
  pcm2,
  method = c("Smith-Waterman", "Needleman-Wunsch"),
  pseudo = 1
)
}
\arguments{
\item{pcm1, pcm2}{object of pcm}

\item{method}{Alignment method. "Smith-Waterman" or "Needleman-Wunsch".
Default is "Smith-Waterma"}

\item{pseudo}{pseudocount}
}
\value{
a list with names: motif1, motif2, alignmentScore, 
startPos1, startPos2, endPos1, endPos2, alignmentLength.
}
\description{
compare two pcm object
}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/motifCloud.R
\name{motifCloud}
\alias{motifCloud}
\title{plot a DNA sequence logo cloud}
\usage{
motifCloud(
  motifSig,
  rcpostfix = "(RC)",
  layout = c("rectangles", "cloud", "tree"),
  scale = c(6, 0.5),
  rot.per = 0.1,
  draw.box = TRUE,
  draw.freq = TRUE,
  box.col = "gray",
  freq.col = "gray",
  group.col = NULL,
  groups = NULL,
  draw.legend = FALSE,
  font = "sans",
  ic.scale = TRUE
)
}
\arguments{
\item{motifSig}{an object of class \linkS4class{motifSig}}

\item{rcpostfix}{postfix for reverse-complement motif names, default: (RC)}

\item{layout}{layout of the logo cloud, rectangles, cloud or tree}

\item{scale}{A vector of length 2 indicating the range of the size of the
sequence logo.}

\item{rot.per}{proportion sequence logo with 90 degree rotation. Only work
for "cloud" layout}

\item{draw.box}{draw box for each sequence logo or not}

\item{draw.freq}{label frequency of each signature or not}

\item{box.col}{color of box for each sequence logo}

\item{freq.col}{color of frequency label}

\item{group.col}{color setting for groups}

\item{groups}{a named vectors of motif groups}

\item{draw.legend}{draw group color legend or not}

\item{font}{font of logo}

\item{ic.scale}{logical If TRUE, the height of each column is proportional
to its information content. Otherwise, all columns have the same height.}
}
\value{
none
}
\description{
Plot a DNA sequence logo cloud
}
\examples{

  if(interactive() || Sys.getenv("USER")=="jianhongou"){
    library("MotifDb")
    matrix.fly <- query(MotifDb, "Dmelanogaster")
    motifs <- as.list(matrix.fly)
    motifs <- motifs[grepl("Dmelanogaster-FlyFactorSurvey-", 
                            names(motifs), fixed=TRUE)]
    names(motifs) <- gsub("Dmelanogaster_FlyFactorSurvey_", "", 
                gsub("_FBgn[0-9]+$", "", 
                  gsub("[^a-zA-Z0-9]","_", 
                     gsub("(_[0-9]+)+$", "", names(motifs)))))
    motifs <- motifs[unique(names(motifs))]
    pfms <- sample(motifs, 50)
    hc <- clusterMotifs(pfms)
    library(ade4)
    phylog <- ade4::hclust2phylog(hc)
    leaves <- names(phylog$leaves)
    pfms <- pfms[leaves]
    pfms <- mapply(pfms, names(pfms), FUN=function(.ele, .name){
                 new("pfm",mat=.ele, name=.name)})
    motifSig <- motifSignature(pfms, phylog, cutoffPval=0.0001)
    motifCloud(motifSig)
  }

}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/plotMotifLogo.R
\name{plotYaxis}
\alias{plotYaxis}
\title{plot y-axis}
\usage{
plotYaxis(ymax, ic.scale)
}
\arguments{
\item{ymax}{max value of y axix}

\item{ic.scale}{Use IC scale or not. See plotMotifLogo for help.}
}
\value{
none
}
\description{
plot y-axis for the sequence logo
}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/matalign.R
\name{calF}
\alias{calF}
\title{calculate frequence}
\usage{
calF(count, P = rep(1/length(count), length(count)), pseudo = 1)
}
\arguments{
\item{count}{position counts}

\item{P}{background probility}

\item{pseudo}{pseudocount}
}
\value{
numeric(1)
}
\description{
calculate frequence
}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/plotMotifLogo.R
\docType{data}
\name{GeomMotif}
\alias{GeomMotif}
\title{GeomMotif object}
\format{
The format is: Classes 'GeoMotif', 'Geom', 'ggproto', 'gg' <ggproto
object: Class GeoMotif, Geom, gg> aesthetics: function default_aes: uneval
draw_group: function draw_key: function draw_layer: function draw_panel:
function extra_params: na.rm handle_na: function non_missing_aes:
optional_aes: parameters: function required_aes: xmin ymin xmax ymax motif
setup_data: function use_defaults: function super: <ggproto object: Class
Geom, gg>
}
\usage{
GeomMotif
}
\description{
GeomMotif object is a ggproto object.
}
\examples{

pcm <- read.table(file.path(find.package("motifStack"), 
                            "extdata", "bin_SOLEXA.pcm"))
pcm <- pcm[,3:ncol(pcm)]
rownames(pcm) <- c("A","C","G","T")
motif <- new("pcm", mat=as.matrix(pcm), name="bin_SOLEXA")

df <- data.frame(xmin=c(.25, .25), ymin=c(.25, .75), xmax=c(.75, .75), ymax=c(.5, 1))
df$motif <- list(pcm2pfm(motif), pcm2pfm(motif))

library(ggplot2)

ggplot(df, aes(xmin=xmin, ymin=ymin, xmax=xmax, ymax=ymax, motif=motif)) + 
geom_motif() + theme_bw() + ylim(0, 1) + xlim(0, 1)


}
\seealso{
geom_motif
}
\keyword{datasets}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/DNAmotifAlignment.R
\name{DNAmotifAlignment}
\alias{DNAmotifAlignment}
\title{align DNA motifs}
\usage{
DNAmotifAlignment(
  pfms,
  threshold = 0.4,
  minimalConsensus = 0,
  rcpostfix = "(RC)",
  revcomp = rep(TRUE, length(pfms))
)
}
\arguments{
\item{pfms}{a list of position frequency matrices, pfms must be a list of
class pfm or psam}

\item{threshold}{information content cutoff threshold for useful postions}

\item{minimalConsensus}{minimal length of consensus for alignment}

\item{rcpostfix}{the postfix for reverse complements}

\item{revcomp}{a logical vector to indicates whether the reverse complemet
should be involved into alignment}
}
\value{
a list of aligned motifs
}
\description{
align DNA motifs for plotting motifs stack
}
\examples{

pcms<-readPCM(file.path(find.package("motifStack"), "extdata"),"pcm$")
motifs<-lapply(pcms,pcm2pfm)
motifs<-DNAmotifAlignment(motifs)

}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/plotMotifStackWithPhylog.R
\name{plotMotifStackWithPhylog}
\alias{plotMotifStackWithPhylog}
\title{plot sequence logo stacks with a ape4-style phylogenic tree}
\usage{
plotMotifStackWithPhylog(
  phylog,
  pfms = NULL,
  f.phylog = 0.3,
  f.logo = NULL,
  cleaves = 1,
  cnodes = 0,
  labels.leaves = names(phylog$leaves),
  clabel.leaves = 1,
  labels.nodes = names(phylog$nodes),
  clabel.nodes = 0,
  font = "sans",
  ic.scale = TRUE,
  ...
)
}
\arguments{
\item{phylog}{an object of class phylog}

\item{pfms}{a list of objects of class pfm}

\item{f.phylog}{a size coefficient for tree size (a parameter to draw the
tree in proportion to leaves label)}

\item{f.logo}{a size coefficient for the motif}

\item{cleaves}{a character size for plotting the points that represent the
leaves, used with par("cex")*cleaves. If zero, no points are drawn}

\item{cnodes}{a character size for plotting the points that represent the
nodes, used with par("cex")*cnodes. If zero, no points are drawn}

\item{labels.leaves}{a vector of strings of characters for the leaves labels}

\item{clabel.leaves}{a character size for the leaves labels, used with
par("cex")*clavel.leaves}

\item{labels.nodes}{a vector of strings of characters for the nodes labels}

\item{clabel.nodes}{a character size for the nodes labels, used with
par("cex")*clabel.nodes. If zero, no nodes labels are drawn}

\item{font}{font of logo}

\item{ic.scale}{logical If TRUE, the height of each column is proportional
to its information content. Otherwise, all columns have the same height.}

\item{...}{not used.}
}
\value{
none
}
\description{
plot sequence logo stacks with a ape4-style phylogenic tree
}
\examples{

  if(interactive() || Sys.getenv("USER")=="jianhongou"){
    library("MotifDb")
    matrix.fly <- query(MotifDb, "Dmelanogaster")
    motifs <- as.list(matrix.fly)
    motifs <- motifs[grepl("Dmelanogaster-FlyFactorSurvey-", names(motifs), fixed=TRUE)]
    names(motifs) <- gsub("Dmelanogaster_FlyFactorSurvey_", "", 
                gsub("_FBgn[0-9]+$", "", 
                  gsub("[^a-zA-Z0-9]","_", 
                     gsub("(_[0-9]+)+$", "", names(motifs)))))
    motifs <- motifs[unique(names(motifs))]
    pfms <- sample(motifs, 50)
    hc <- clusterMotifs(pfms)
    library(ade4)
    phylog <- ade4::hclust2phylog(hc)
    leaves <- names(phylog$leaves)
    pfms <- pfms[leaves]
    pfms <- mapply(pfms, names(pfms), FUN=function(.ele, .name){
                 new("pfm",mat=.ele, name=.name)})
    pfms <- DNAmotifAlignment(pfms, minimalConsensus=3)
    plotMotifStackWithPhylog(phylog, pfms, f.phylog=0.3, 
                             cleaves = 0.5, clabel.leaves = 0.7)
  }

}
\seealso{
\link[ade4:plot.phylog]{plot.phylog}
}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/matalign.R
\name{getALLRscoreFromCounts}
\alias{getALLRscoreFromCounts}
\title{calculate ALLR from counts}
\usage{
getALLRscoreFromCounts(count1, count2, P1, P2, pseudo)
}
\arguments{
\item{count1, count2}{count in position j for matrix 1 or 2}

\item{P1, P2}{background for matrix 1 or 2}

\item{pseudo}{pseudocount}
}
\value{
numeric(1) of ALLR
}
\description{
calculate ALLR from counts
}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/matalign.R
\name{traceBackGlobal}
\alias{traceBackGlobal}
\title{traceback global}
\usage{
traceBackGlobal(dpScore, score, m, n)
}
\arguments{
\item{dpScore}{Dynamic programming score}

\item{score}{ALLR scores}

\item{m, n}{matrix width}
}
\value{
a data.frame
}
\description{
traceback global
}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/importMatrix.R
\name{importMatrix}
\alias{importMatrix}
\title{import motifs from local files}
\usage{
importMatrix(
  filenames,
  format = c("auto", "pfm", "cm", "pcm", "meme", "transfac", "jaspar", "scpd", "cisbp",
    "psam", "xmatrix", "hocomoco"),
  to = c("auto", "pcm", "pfm", "pssm", "psam")
)
}
\arguments{
\item{filenames}{filename, 
an \link[TFBSTools:XMatrixList-class]{XMatrixList} object,
or an \link[TFBSTools:XMatrix-class]{XMatrix} object
to be imported.}

\item{format}{file format}

\item{to}{import to \link{pcm-class} or \link{pfm-class}}
}
\value{
a list of object \link{pcm-class} or \link{pfm-class}
}
\description{
Import the motifs into \link{pcm-class} or \link{pfm-class} from files
exported from Transfac, CisBP, and JASPAR.
}
\examples{

  path <- system.file("extdata", package = "motifStack")
  importMatrix(dir(path, "*.pcm", full.names = TRUE))

}
\author{
Jianhong Ou
}
\keyword{misc}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/matalign.R
\name{traceBackLocal}
\alias{traceBackLocal}
\title{traceback local}
\usage{
traceBackLocal(dpScore, score, m, n)
}
\arguments{
\item{dpScore}{Dynamic programming score matrix}

\item{score}{ALLR scores, m x n matrix}

\item{m, n}{matrix width}
}
\value{
a data.frame
}
\description{
traceback local
}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/signature.R
\docType{class}
\name{motifSig-class}
\alias{motifSig-class}
\alias{motifSig}
\alias{signatures}
\alias{signatures,motifSig-method}
\alias{frequence}
\alias{frequence,motifSig-method}
\alias{nodelist}
\alias{nodelist,motifSig-method}
\alias{sigColor}
\alias{sigColor,motifSig-method}
\alias{$,motifSig-method}
\alias{$<-,motifSig-method}
\title{Class \code{"motifSig"}}
\usage{
signatures(object)

frequence(object)

nodelist(object)

sigColor(object)

\S4method{$}{motifSig}(x, name)
}
\arguments{
\item{object}{An object of class \code{motifSig}.}

\item{x}{A motifSig object}

\item{name}{slot name of motifSig object}
}
\description{
An object of class \code{"motifSig"} represents the output of function
\link{motifSignature}

methods for motifSig objects.
}
\section{Objects from the Class}{
 Objects can be created by calls of the form
\code{new("motifSig", signature, freq, nodelist, gpcol)}.
}

\section{Methods}{
 \describe{ \item{signatures}{\code{signature(object =
"motifSig")} return the signatures of motifSig }

\item{frequence}{\code{signature(object = "motifSig")} return the frequency
of motifSig}

\item{nodelist}{\code{signature(object = "motifSig")} return the nodelist of
motifSig}

\item{sigColor}{\code{signature(object = "motifSig")} return the group color
sets of motifSig}

\item{$, $<-}{Get or set the slot of \code{\link{motifSig}}} }
}

\keyword{classes}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/motifHclust.R
\name{motifHclust}
\alias{motifHclust}
\title{Hierarchical Clustering motifs}
\usage{
motifHclust(align, ...)
}
\arguments{
\item{align}{output of matalign, used to generate distance matrix.}

\item{...}{parameter to pass to the \link[stats]{hclust}.}
}
\value{
An object of hclust.
}
\description{
functions to perfom clustering of output of matalign
}
\examples{
 if(interactive() || Sys.getenv("USER")=="jianhongou"){
  fp <- system.file("extdata", package="motifStack")
  fs <- dir(fp, "pcm$")
  pcms <- importMatrix(file.path(fp, fs), format="pcm")
  align <- matalign(pcms)
  hc <- motifHclust(align, method="average")
 }
}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/motifStack-Package.R
\docType{package}
\name{motifStack-package}
\alias{motifStack-package}
\title{Plot stacked logos for single or multiple DNA, RNA and amino acid sequence}
\description{
motifStack is a package that is able to draw amino acid sequence as easy as
to draw DNA/RNA sequence. motifStack provides the flexibility for users to
select the font type and symbol colors. motifStack is designed for graphical
representation of multiple motifs.
}
\author{
Jianhong Ou and Lihua Julie Zhu

Maintainer: Jianhong Ou <jianhong.ou@umassmed.edu>
}
\keyword{package}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/psam.R
\docType{class}
\name{psam-class}
\alias{psam-class}
\alias{psam}
\alias{$,psam-method}
\alias{$<-,psam-method}
\alias{plot,psam,ANY-method}
\alias{as()}
\alias{coerce,psam,matrix-method}
\alias{matrixReverseComplement,psam-method}
\alias{addBlank,psam,numeric,logical-method}
\alias{as.data.frame,psam-method}
\alias{format,psam-method}
\title{Class \code{"psam"}}
\usage{
\S4method{$}{psam}(x, name)

\S4method{plot}{psam,ANY}(x, y = "missing", ...)

\S4method{matrixReverseComplement}{psam}(x)

\S4method{addBlank}{psam,numeric,logical}(x, n, b)

\S4method{as.data.frame}{psam}(x, row.names = NULL, optional = FALSE, ...)

\S4method{format}{psam}(x, ...)
}
\arguments{
\item{x}{An object of class \code{psam}.}

\item{name}{Slot name.}

\item{y}{Not use.}

\item{\dots}{Further potential arguments passed to \code{plotAffinityLogo}.}

\item{n}{how many spaces should be added.}

\item{b}{logical value to indicate where the space should be added.}

\item{row.names, optional}{see as.data.frame}
}
\description{
An object of class \code{"psam"} represents the position specific affinity
matrix (PSAM) of a DNA/RNA/amino-acid sequence motif. The entry stores a
matrix, which in row i, column j gives the affinity of observing
nucleotide/or amino acid i in position j of the motif.

methods for psam objects.
}
\section{Objects from the Class}{
 Objects can be created by calls of the form
\code{new("psam", mat, name, alphabet, color)}.
}

\section{Methods}{
 \describe{ \item{addBlank}{\code{signature(x="psam",
n="numeric", b="logical")} add space into the position specific affinity
matrix for alignment. b is a bool value, if TRUE, add space to the 3' end,
else add space to the 5' end. n indicates how many spaces should be added.}

\item{matrixReverseComplement}{\code{signature(x = "psam")} get the reverse
complement of position specific affinity matrix.}

\item{plot}{\code{signature(x = "psam")} Plots the affinity logo of the
position specific affinity matrix. }

\item{$, $<-}{Get or set the slot of \code{\link{psam-class}}}
\item{as.data.frame}{convert \code{\link{psam-class}} to a data.frame}
\item{format}{return the name_pfm of \code{\link{psam-class}}} }
}

\examples{

motif <- importMatrix(file.path(find.package("motifStack"), "extdata", "PSAM.mxr"), 
         format="psam")[[1]]
plot(motif)


motif <- importMatrix(file.path(find.package("motifStack"), "extdata", "PSAM.mxr"), 
                      format="psam")[[1]]
matrixReverseComplement(motif)
addBlank(motif, 1, FALSE)
addBlank(motif, 3, TRUE)
as(motif,"matrix")
as.data.frame(motif)
format(motif)

}
\keyword{classes}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/matalign.R
\name{dpLocal}
\alias{dpLocal}
\title{Dynamic programming function, local version}
\usage{
dpLocal(score, m, n)
}
\arguments{
\item{score}{ALLR scores, m x n matrix}

\item{m, n}{matrix width}
}
\value{
score matrix
}
\description{
Dynamic programming function, local version
}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/motifStack.R
\name{motifStack}
\alias{motifStack}
\title{plot a DNA sequence logo stack}
\usage{
motifStack(
  pfms,
  layout = c("stack", "treeview", "phylog", "radialPhylog"),
  reorder = TRUE,
  ...
)
}
\arguments{
\item{pfms}{a list of objects of class \link{pfm}}

\item{layout}{layout of the logo stack, stack, treeview or radialPhylog}

\item{reorder}{logical(1). Default TRUE. Set to FALSE will do alignment but
keep the order of the pfms. This parameter only work for stack layout.}

\item{\dots}{any parameters could to pass to \link{plotMotifLogoStack},
\link{plotMotifLogoStackWithTree}, \link{plotMotifStackWithPhylog} or
\link{plotMotifStackWithRadialPhylog}.
And the `revcomp` parameter for \link{DNAmotifAlignment}.}
}
\value{
return a list contains pfms and phylog
}
\description{
Plot a DNA sequence logo stack
}
\examples{

  if(interactive() || Sys.getenv("USER")=="jianhongou"){
    library("MotifDb")
    matrix.fly <- query(MotifDb, "Dmelanogaster")
    motifs <- as.list(matrix.fly)
    motifs <- motifs[grepl("Dmelanogaster-FlyFactorSurvey-", 
                            names(motifs), fixed=TRUE)]
    names(motifs) <- gsub("Dmelanogaster_FlyFactorSurvey_", "", 
                gsub("_FBgn[0-9]+$", "", 
                  gsub("[^a-zA-Z0-9]","_", 
                     gsub("(_[0-9]+)+$", "", names(motifs)))))
    motifs <- motifs[unique(names(motifs))]
    pfms <- sample(motifs, 50)
    pfms <- mapply(pfms, names(pfms), FUN=function(.ele, .name){
                 new("pfm",mat=.ele, name=.name)})
    motifStack(pfms, "radialPhylog")
    
    ## AA motifs
    pcms<-importMatrix(system.file("extdata", "prot.meme", 
                                   package="motifStack"),
                   format="meme", to="pfm")
    motifStack(pcms[1:5])
    motifStack(pcms[1:5], reorder=FALSE)
  }

}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/matalign.R
\name{calI}
\alias{calI}
\title{calculate I'}
\usage{
calI(freq1, freq2, P)
}
\arguments{
\item{freq1}{position frequence for matrix 1 position j}

\item{freq2}{position frequence for matrix 2 position j}

\item{P}{background of profile1}
}
\value{
numeric(1)
}
\description{
calculate I'
}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/signature.R
\docType{class}
\name{ouNode-class}
\alias{ouNode-class}
\alias{ouNode}
\alias{$,ouNode-method}
\alias{$<-,ouNode-method}
\title{Class \code{ouNode}}
\usage{
\S4method{$}{ouNode}(x, name)
}
\arguments{
\item{x}{A ouNode object}

\item{name}{slot name of ouNode object}
}
\description{
An object of class \code{"ouNode"} represents a motif node in a cluster tree
}
\section{Objects from the Class}{
 Objects can be created by calls of the form
\code{new("ouNode", left, right, parent, distl, distr, sizel, sizer)}.
}

\examples{

 new("ouNode", left="A", right="B", parent="Root", distl=1, distr=2, sizel=1, sizer=1)

}
\keyword{classes}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/publicUtilities.R
\name{highlightCol}
\alias{highlightCol}
\title{add alpha transparency value to a color}
\usage{
highlightCol(col, alpha = 0.5)
}
\arguments{
\item{col}{vector of any of the three kinds of R color specifications, i.e.,
either a color name (as listed by \link[grDevices]{colors}()), a hexadecimal
string of the form "#rrggbb" or "#rrggbbaa" (see \link[grDevices]{rgb}), or
a positive integer i meaning \link[grDevices]{palette}()[i].}

\item{alpha}{a value in [0, 1]}
}
\value{
a vector of colors in hexadecimal string of the form "#rrggbbaa".
}
\description{
An alpha transparency value can be specified to a color, in order to get
better color for background.
}
\examples{

    highlightCol(1:5, 0.3)
    highlightCol(c("red", "green", "blue"), 0.3)

}
\author{
Jianhong Ou
}
\keyword{misc}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/matalign.R
\name{getDistance}
\alias{getDistance}
\title{Calculate distances between two profiles}
\usage{
getDistance(hsp, count1, count2, P1, P2, pseudo)
}
\arguments{
\item{hsp}{output of traceBack function}

\item{count1, count2}{motif profile 1 or 2}

\item{P1, P2}{background of profile 1 or 2}

\item{pseudo}{pseudocount}
}
\value{
full distance and aligned distance.
}
\description{
Calculate distances between two profiles
}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/plotMotifLogo.R
\name{plotXaxis}
\alias{plotXaxis}
\title{plot x-axis}
\usage{
plotXaxis(pfm, p = rep(0.25, 4), label = NULL)
}
\arguments{
\item{pfm}{position frequency matrices}

\item{p}{background possibility}

\item{label}{x-axis labels}
}
\value{
none
}
\description{
plot x-axis for the sequence logo
}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/plotMotifOverMotif.R
\name{plotMotifOverMotif}
\alias{plotMotifOverMotif}
\title{plot motif over another motif}
\usage{
plotMotifOverMotif(
  motif,
  backgroundMotif,
  bgNoise = NA,
  font = "sans",
  textgp = gpar()
)
}
\arguments{
\item{motif}{an object of \code{\link{pcm}} or \code{\link{pfm}}}

\item{backgroundMotif}{an object of \code{\link{pcm}} or \code{\link{pfm}}}

\item{bgNoise}{if it is not NA, test will using a background by
Dirichlet(1)-distributed random frequencies with weight bg.noise.  The value
of bgNoise should be a number in the range of 0 to 1, eg. 0.05}

\item{font}{font for logo symbol}

\item{textgp}{text parameter}
}
\value{
none
}
\description{
plot motif over another motif to emphesize the difference.
}
\examples{

pcms <- readPCM(file.path(find.package("motifStack"), "extdata"),"pcm$")
len <- sapply(pcms, function(.ele) ncol(.ele$mat))
pcms <- pcms[len==7]
plotMotifOverMotif(pcms[[1]], pcms[[2]], bgNoise=0.05)

}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/motifSignature.R
\name{motifSignature}
\alias{motifSignature}
\title{get signatures from motifs}
\usage{
motifSignature(
  pfms,
  phylog,
  cutoffPval,
  groupDistance,
  rcpostfix = "(RC)",
  min.freq = 2,
  trim = 0.2,
  families = list(),
  sort = TRUE
)
}
\arguments{
\item{pfms}{a list of objects of class pfm}

\item{phylog}{an object of class phylog}

\item{cutoffPval}{pvalue for motifs to merge.}

\item{groupDistance}{maxmal distance of motifs in the same group}

\item{rcpostfix}{postfix for reverse-complement motif names, default: (RC)}

\item{min.freq}{signatures with frequency below min.freq will not be plotted}

\item{trim}{minimal information content for each position of signature}

\item{families}{for each family, the motif number in one signature should
only count as 1}

\item{sort}{sort the signatures by frequency or not.}
}
\value{
an Object of class \linkS4class{motifSig}
}
\description{
extract signatures from multiple motifs by distance calculated from STAMP
}
\examples{

  if(interactive() || Sys.getenv("USER")=="jianhongou"){
    library("MotifDb")
    matrix.fly <- query(MotifDb, "Dmelanogaster")
    motifs <- as.list(matrix.fly)
    motifs <- motifs[grepl("Dmelanogaster-FlyFactorSurvey-", 
                            names(motifs), fixed=TRUE)]
    names(motifs) <- gsub("Dmelanogaster_FlyFactorSurvey_", "", 
                gsub("_FBgn[0-9]+$", "", 
                  gsub("[^a-zA-Z0-9]","_", 
                     gsub("(_[0-9]+)+$", "", names(motifs)))))
    motifs <- motifs[unique(names(motifs))]
    pfms <- sample(motifs, 50)
    hc <- clusterMotifs(pfms)
    library(ade4)
    phylog <- ade4::hclust2phylog(hc)
    leaves <- names(phylog$leaves)
    pfms <- pfms[leaves]
    pfms <- mapply(pfms, names(pfms), FUN=function(.ele, .name){
                 new("pfm",mat=.ele, name=.name)})
    motifSig <- motifSignature(pfms, phylog, cutoffPval=0.0001)
  }

}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/matalign.R
\name{matalign}
\alias{matalign}
\title{Matrix Aligner}
\usage{
matalign(
  pcms,
  method = c("Smith-Waterman", "Needleman-Wunsch"),
  pseudo = 1,
  revcomp = TRUE,
  ...
)
}
\arguments{
\item{pcms}{A list of \link{pcm}}

\item{method}{Alignment method. "Smith-Waterman" or "Needleman-Wunsch".
Default is "Smith-Waterma"}

\item{pseudo}{pseudocount}

\item{revcomp}{Check reverseComplement or not.}

\item{...}{Not use.}
}
\value{
A data frame with alignment information. The column names
are motif1, motif2, alignmentScore, startPos1, startPos2, endPos1, endPos2,
alignmentLength.
}
\description{
Matrix Aligner is modified from Matalign-v4a.
Matalign-v4a is a program to compare two positional specific matrices.
The author of Matalign-v4a is Ting Wang and Gary Stormo.
}
\examples{
if(interactive() || Sys.getenv("USER")=="jianhongou"){
  fp <- system.file("extdata", package="motifStack")
  fs <- dir(fp, "pcm$")
  pcms <- importMatrix(file.path(fp, fs), format="pcm")
  matalign(pcms)
 }
}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/matalign.R
\name{getScore}
\alias{getScore}
\title{Calculate pair_wise position score}
\usage{
getScore(pcm1, pcm2, pseudo = 1)
}
\arguments{
\item{pcm1, pcm2}{object of pcm}

\item{pseudo}{pseudocount}
}
\value{
A score matrix with nrow of ncol of pcm1 
and ncol of ncol of pcm2.
}
\description{
Calculate pair_wise position score
}
